Package: swdpwr
Type: Package
Title: Power Calculation for Stepped Wedge Cluster Randomized Trials
Version: 1.12
Date: 2026-05-14
Authors@R: c(person(given = "Jiachen",
                        family = "Chen",
                        role = c("cre", "aut"),
                        email = "jiachen.chen322@gmail.com"),
                 person(given = "Xin",
                        family = "Zhou",
                        role = "aut"),
                 person(given = "Fan",
                        family = "Li",
                        role = "aut"),
                 person(given = "Donna",
                        family = "Spiegelman.",
                        role = "aut"))
Maintainer: Jiachen Chen <jiachen.chen322@gmail.com>
Description: To meet the needs of statistical power calculation for stepped wedge cluster randomized trials, we developed this software. Different parameters can be specified by users for different scenarios, including: cross-sectional and cohort designs, binary and continuous outcomes, marginal (GEE) and conditional models (mixed effects model), three link functions (identity, log, logit links), with and without time effects (the default specification assumes no-time-effect) under exchangeable, nested exchangeable and block exchangeable correlation structures. Unequal numbers of clusters per sequence are also allowed. The methods included in this package: Zhou et al. (2020) <doi:10.1093/biostatistics/kxy031>, Li et al. (2018) <doi:10.1111/biom.12918>. Supplementary documents can be found at: <https://ysph.yale.edu/cmips/research/software/study-design-power-calculation/swdpwr/>. The Shiny app for swdpwr can be accessed at: <https://jiachenchen322.shinyapps.io/swdpwr_shinyapp/>. The package also includes functions that perform calculations for the intra-cluster correlation coefficients based on the random effects variances as input variables for continuous and binary outcomes, respectively. 
Imports: spatstat.random
License: GPL-3
Encoding: UTF-8
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2026-05-14 17:20:02 UTC
RoxygenNote: 7.2.3
Packaged: 2026-05-14 16:22:22 UTC; jiachenchen
Author: Jiachen Chen [cre, aut],
  Xin Zhou [aut],
  Fan Li [aut],
  Donna Spiegelman. [aut]
Built: R 4.6.0; aarch64-apple-darwin23; 2026-05-14 19:25:36 UTC; unix
Archs: swdpwr.so.dSYM

Package: swdpwr
Type: Package
Title: Power Calculation for Stepped Wedge Cluster Randomized Trials
Version: 1.12
Date: 2026-05-14
Authors@R: c(person(given = "Jiachen",
                        family = "Chen",
                        role = c("cre", "aut"),
                        email = "jiachen.chen322@gmail.com"),
                 person(given = "Xin",
                        family = "Zhou",
                        role = "aut"),
                 person(given = "Fan",
                        family = "Li",
                        role = "aut"),
                 person(given = "Donna",
                        family = "Spiegelman.",
                        role = "aut"))
Maintainer: Jiachen Chen <jiachen.chen322@gmail.com>
Description: To meet the needs of statistical power calculation for stepped wedge cluster randomized trials, we developed this software. Different parameters can be specified by users for different scenarios, including: cross-sectional and cohort designs, binary and continuous outcomes, marginal (GEE) and conditional models (mixed effects model), three link functions (identity, log, logit links), with and without time effects (the default specification assumes no-time-effect) under exchangeable, nested exchangeable and block exchangeable correlation structures. Unequal numbers of clusters per sequence are also allowed. The methods included in this package: Zhou et al. (2020) <doi:10.1093/biostatistics/kxy031>, Li et al. (2018) <doi:10.1111/biom.12918>. Supplementary documents can be found at: <https://ysph.yale.edu/cmips/research/software/study-design-power-calculation/swdpwr/>. The Shiny app for swdpwr can be accessed at: <https://jiachenchen322.shinyapps.io/swdpwr_shinyapp/>. The package also includes functions that perform calculations for the intra-cluster correlation coefficients based on the random effects variances as input variables for continuous and binary outcomes, respectively. 
Imports: spatstat.random
License: GPL-3
Encoding: UTF-8
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2026-05-14 17:20:02 UTC
RoxygenNote: 7.2.3
Packaged: 2026-05-14 16:22:22 UTC; jiachenchen
Author: Jiachen Chen [cre, aut],
  Xin Zhou [aut],
  Fan Li [aut],
  Donna Spiegelman. [aut]
Built: R 4.5.2; aarch64-apple-darwin20; 2026-05-14 19:07:11 UTC; unix
Archs: swdpwr.so.dSYM

subroutine cholesky ( a, n, nn, u, nullty, ifault )

!*****************************************************************************80
!
!! CHOLESKY computes the Cholesky factorization of a PDS matrix.
!
!  Discussion:
!
!    For a positive definite symmetric matrix A, the Cholesky factor U
!    is an upper triangular matrix such that A = U' * U.
!
!    This routine was originally named "CHOL", but that conflicted with
!    a built in MATLAB routine name.
!
!    The missing initialization "II = 0" has been added to the code.
!
!  Modified:
!
!    11 February 2008
!
!  Author:
!
!    Original FORTRAN77 version by Michael Healy.
!    Modifications by AJ Miller.
!    FORTRAN90 version by John Burkardt.
!
!  Reference:
!
!    Michael Healy,
!    Algorithm AS 6:
!    Triangular decomposition of a symmetric matrix,
!    Applied Statistics,
!    Volume 17, Number 2, 1968, pages 195-197.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) A((N*(N+1))/2), a positive definite matrix
!    stored by rows in lower triangular form as a one dimensional array,
!    in the sequence
!    A(1,1),
!    A(2,1), A(2,2),
!    A(3,1), A(3,2), A(3,3), and so on.
!
!    Input, integer ( kind = 4 ) N, the order of A.
!
!    Input, integer ( kind = 4 ) NN, the dimension of A, (N*(N+1))/2.
!
!    Output, real ( kind = 8 ) U((N*(N+1))/2), an upper triangular matrix,
!    stored by columns, which is the Cholesky factor of A.  The program is
!    written in such a way that A and U can share storage.
!
!    Output, integer ( kind = 4 ) NULLTY, the rank deficiency of A.
!    If NULLTY is zero, the matrix is judged to have full rank.
!
!    Output, integer ( kind = 4 ) IFAULT, an error indicator.
!    0, no error was detected;
!    1, if N < 1;
!    2, if A is not positive semi-definite.
!    3, if NN < (N*(N+1))/2.
!
!  Local Parameters:
!
!    Local, real ( kind = 8 ) ETA, should be set equal to the smallest positive
!    value such that 1.0 + ETA is calculated as being greater than 1.0 in the
!    accuracy being used.
!
  implicit none

  integer nn

  double precision a(nn)
  double precision, parameter :: eta = 1.0D-09
  integer i
  integer icol
  integer ifault
  integer ii
  integer irow
  integer j
  integer k
  integer kk
  integer l
  integer m
  integer n
  integer nullty
!  double precision rsq
  double precision u(nn)
  double precision w
  double precision x

  ifault = 0
  nullty = 0

  if ( n <= 0 ) then
    ifault = 1
    return
  end if

  if ( nn < ( n * ( n + 1 ) ) / 2 ) then
    ifault = 3
    return
  end if

  j = 1
  k = 0
  ii = 0
!
!  Factorize column by column, ICOL = column number.
!
  do icol = 1, n

    ii = ii + icol
    x = eta * eta * a(ii)
    l = 0
    kk = 0
!
!  IROW = row number within column ICOL.
!
    do irow = 1, icol

      kk = kk + irow
      k = k + 1
      w = a(k)
      m = j

      do i = 1, irow - 1
        l = l + 1
        w = w - u(l) * u(m)
        m = m + 1
      end do

      l = l + 1

      if ( irow == icol ) then
        exit
      end if

      if ( u(l) /= 0.0D+00 ) then

        u(k) = w / u(l)

      else

        u(k) = 0.0D+00

        if ( abs ( x * a(k) ) < w * w ) then
          ifault = 2
          return
        end if

      end if

    end do
!
!  End of row, estimate relative accuracy of diagonal element.
!
    if ( abs ( w ) <= abs ( eta * a(k) ) ) then

      u(k) = 0.0D+00
      nullty = nullty + 1

    else

      if ( w < 0.0D+00 ) then
        ifault = 2
        return
      end if

      u(k) = sqrt ( w )

    end if

    j = j + icol

  end do

  return
    end

    subroutine syminv ( a, n, c, nullty, ifault )

!*****************************************************************************80
!
!! SYMINV computes the inverse of a symmetric matrix.
!
!  Modified:
!
!    11 February 2008
!
!  Author:
!
!    FORTRAN77 version by Michael Healy
!    FORTRAN90 version by John Burkardt
!
!  Reference:
!
!    Michael Healy,
!    Algorithm AS 7:
!    Inversion of a Positive Semi-Definite Symmetric Matrix,
!    Applied Statistics,
!    Volume 17, Number 2, 1968, pages 198-199.
!
!  Parameters:
!
!    Input, real ( kind = 8 ) A((N*(N+1))/2), a positive definite matrix stored
!    by rows in lower triangular form as a one dimensional array, in the
!    sequence
!    A(1,1),
!    A(2,1), A(2,2),
!    A(3,1), A(3,2), A(3,3), and so on.
!
!    Input, integer ( kind = 4 ) N, the order of A.
!
!    Output, real ( kind = 8 ) C((N*(N+1))/2), the inverse of A, or generalized
!    inverse if A is singular, stored using the same storage scheme employed
!    for A.  The program is written in such a way that A and U can share
!    storage.
!
!    Workspace, real ( kind = 8 ) W(N).
!
!    Output, integer ( kind = 4 ) NULLTY, the rank deficiency of A.  If NULLTY
!    is zero, the matrix is judged to have full rank.
!
!    Output, integer ( kind = 4 ) IFAULT, error indicator.
!    0, no error detected.
!    1, N < 1.
!    2, A is not positive semi-definite.
!
  implicit none

  integer n
  double precision a(n*(n+1)/2), c(n*(n+1)/2)

  integer i
  integer icol
  integer ifault
  integer irow
  integer j
  integer jcol
  integer k
  integer l
  integer mdiag
  integer ndiag
  integer nn
  integer nrow
  integer nullty
  double precision w(n)
  double precision x

  ifault = 0

  if ( n <= 0 ) then
    ifault = 1
    return
  end if

  nrow = n
!
!  Compute the Cholesky factorization of A.
!  The result is stored in C.
!
  nn = ( n * ( n + 1 ) ) / 2

  call cholesky ( a, n, nn, c, nullty, ifault )

  if ( ifault /= 0 ) then
    return
  end if
!
!  Invert C and form the product (Cinv)' * Cinv, where Cinv is the inverse
!  of C, row by row starting with the last row.
!  IROW = the row number,
!  NDIAG = location of last element in the row.
!
  irow = nrow
  ndiag = nn

  do
!
!  Special case, zero diagonal element.
!
    if ( c(ndiag) == 0.0D+00 ) then

      l = ndiag
      do j = irow, nrow
        c(l) = 0.0D+00
        l = l + j
      end do

    else

      l = ndiag
      do i = irow, nrow
        w(i) = c(l)
        l = l + i
      end do

      icol = nrow
      jcol = nn
      mdiag = nn

      do

        l = jcol

        if ( icol == irow ) then
          x = 1.0D+00 / w(irow)
        else
          x = 0.0D+00
        end if

        k = nrow

        do while ( irow < k )

          x = x - w(k) * c(l)
          k = k - 1
          l = l - 1

          if ( mdiag < l ) then
            l = l - k + 1
          end if

        end do

        c(l) = x / w(irow)

        if ( icol <= irow ) then
          exit
        end if

        mdiag = mdiag - icol
        icol = icol - 1
        jcol = jcol - 1

      end do

    end if

    ndiag = ndiag - irow
    irow = irow - 1

    if ( irow <= 0 ) then
      exit
    end if

  end do

  return
end

subroutine computeparameterGEElogit(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
    implicit none
    ! ---- arg types -----------------------
    integer :: JJ
    double precision :: mu, beta, tau2
    double precision :: gamma(JJ)
    double precision :: p11, rho0
    double precision :: p0(JJ)
    ! ---------------------------------------
    ! ---------------------------------------
    integer :: j

    mu = log(1/(1-p0(1))-1)
    beta = log(1/(1-p11)-1)-mu
    tau2 = rho0*mu*(1-mu)
    ! gamma
    gamma(1) = 0.0d0
    do j=2,JJ
        gamma(j) =  log(1/(1-p0(j))-1) - mu
    end do
end subroutine computeparameterGEElogit

function LogitPower_time(mu, beta, gamma, tau2, II, JJ, KK, GQ, GQX, GQW, X_in,typeone) result (power)
    implicit none
  ! ---- arg types -----------------------
    integer :: II, JJ, KK,ifault
    integer :: X_in(II,JJ)    ! II : number of clusters
    ! JJ : number of steps
    ! KK : number of subjects per cluster per step
    double precision :: mu, beta, tau2,typeone,ppp
    double precision :: gamma(JJ)
    ! true values of beta0, beta1, and tau2
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    double precision :: power
    ! ----------------------------------------
    double precision, parameter :: PI = 3.14159265358979323846   ! pi
    integer :: X(II,JJ)   ! intervention matrix
    !integer :: DD      ! II/(JJ-1). By design, II is a multiple of (JJ-1)
    integer :: i, j, k
    logical :: upper
    double precision, external :: alnorm
    double precision, external :: ppnd16
    integer :: z0(JJ), z1(JJ)   ! z0: # of subjects with outcome 0; z1: # of subjects with outcome 1.
    integer :: nZ               ! total number of possible combination of z0 and z1
    double precision :: derlikelihood(JJ+2)   ! derivative of likelihood
    double precision :: derlikelihood2(JJ+2, JJ+2)  ! square of derivative of likelihood
    double precision :: invVar(JJ+2,JJ+2)      ! inverse of variance matrix
    double precision :: Var(JJ+2,JJ+2),invVarPre(JJ+2,JJ+2)         ! variance matrix
    double precision :: prob
    double precision :: sebeta  ! se of beta
    ifault = 0
    upper = .false.

  !  DD = II/(JJ-1)   ! II is a multiple of (JJ-1)
    ! assign intervention
    X = 0
    do i=1,II
      do j = 1,JJ
        X(i,j) =  X_in(i,j)
      enddo
    enddo

    ! compute the possible combinations of (z0,z1)
    nZ = 1
    do j=1,JJ
        nZ = nZ * (KK+1)
    end do
    ! run the algorithm
    invVar = 0.0d0
    do i=1,II
      if(i<2) then
        invVarPre=0
        z0 = 0
        do k=1, nZ
            z1 = KK - z0
            call der_likelihood_timelogit(mu,beta,gamma,tau2, z0, z1, X(i,:), JJ, KK, GQ, GQX, GQW, derlikelihood, prob)
            call vectorsquare(derlikelihood, JJ+2, derlikelihood2)
            invVar = invVar + derlikelihood2 * prob
            invVarPre = invVarPre+derlikelihood2 * prob
            call updatezz(z0, JJ, KK)
        end do
      cycle
      end if

      if(i>1 .and. ALL(X(i,:).EQ. X(i-1,:))) then
      invVar = invVar + invVarPre
      !finish = updatez(z0, JJ, KK)
      else
        ! per cluster
        invVarPre=0
        z0 = 0
        do k=1, nZ
            z1 = KK - z0
            call der_likelihood_timelogit(mu,beta,gamma,tau2, z0, z1, X(i,:), JJ, KK, GQ, GQX, GQW, derlikelihood, prob)
            call vectorsquare(derlikelihood, JJ+2, derlikelihood2)
            invVar = invVar + derlikelihood2 * prob
            invVarPre = invVarPre+derlikelihood2 * prob
            call updatezz(z0, JJ, KK)
        end do
      end if
    end do
    call syminverse(invVar,Var,JJ+2)
    sebeta = sqrt(Var(2,2))
    ppp=ppnd16(typeone/2,ifault)
    power = alnorm(beta/sebeta+ppp,upper) + alnorm(-beta/sebeta+ppp,upper)
  !if(beta<0) then
  !power =alnorm(-beta/sebeta-1.959964d0,upper)
!else
!  power =alnorm(beta/sebeta-1.959964d0,upper)
!end if
end function LogitPower_time

subroutine updatezz(z0, JJ, KK)
    implicit none
    ! ---- arg types -----------------------
    integer :: JJ, KK
    integer :: z0(JJ)
    ! --------------------------------------
    integer :: j
    z0(1) = z0(1) + 1
    do j=1,JJ-1
        if (z0(j)>KK) then
            z0(j) = 0
            z0(j+1) = z0(j+1) + 1
        else
            exit
        end if
    end do
end subroutine updatezz


subroutine der_likelihood_timelogit(mu,beta,gamma,tau2, z0, z1, XX, JJ, KK, GQ, GQX, GQW, derlikelihood, prob)
    implicit none
    ! ---- arg types -----------------------
    integer :: JJ, KK
    double precision :: mu, beta, tau2
    double precision :: gamma(JJ)
    ! true values of mu, beta, gamma, tau2
    integer :: z0(JJ), z1(JJ)   ! z0: # of subjects with outcome 0; z1: # of subjects with outcome 1.
    integer :: XX(JJ)     ! treatment assignment
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    double precision :: derlikelihood(JJ+2)
    double precision :: prob
    ! --------------------------------------
    double precision, parameter :: PI = 3.14159265358979323846   ! pi
    double precision :: likelihoodf
    double precision :: x
    integer :: i, j, k
    double precision :: ff0, ff1, ff01
    double precision :: ff, ffprob
    double precision :: ff_mu, ff_beta
    double precision :: ff_gamma(JJ-1)
    double precision :: temp

    derlikelihood = 0.0d0
    likelihoodf = 0.0d0
    prob = 0.0d0
    do i=1,GQ
        x = GQX(i)
        ff = 1.0d0
        ffprob = 1.0d0
        ff_mu = 0.0d0
        ff_beta = 0.0d0
        do j=1,JJ
            ff0 = 1.0d0/(1.0d0+exp(mu+beta*XX(j)+gamma(j)+sqrt(2.0d0*tau2)*x))
            ff1 = 1-ff0
            ff = ff*(ff0**z0(j))*(ff1**z1(j))
            temp = z1(j)*ff0 - z0(j)*ff1
            ff_mu = ff_mu + temp
            ff_beta = ff_beta + XX(j)*temp
            k = j-1
            if (k>0) then
                ff_gamma(k) = temp
            end if

            ff01 = ff0*ff1
            ! compute binomial
            ! compute combination number with power of ff0 and ff1
            ! to avoid overflow
            if (z0(j)<z1(j)) then
                ffprob = ffprob*ff1**(z1(j)-z0(j))
                do k=0,(z0(j)-1)
                    ffprob = ffprob*dble(KK-k)/dble(z0(j)-k)*ff01
                end do
            else
                ffprob = ffprob*ff0**(z0(j)-z1(j))
                do k=0,(z1(j)-1)
                    ffprob = ffprob*dble(KK-k)/dble(z1(j)-k)*ff01
                end do
            end if
        end do
        prob = prob + GQW(i)*ffprob
        likelihoodf = likelihoodf + GQW(i)*ff
        derlikelihood(1) = derlikelihood(1) + GQW(i)*ff*ff_mu
        derlikelihood(2) = derlikelihood(2) + GQW(i)*ff*ff_beta
        derlikelihood(3:(JJ+1)) = derlikelihood(3:(JJ+1)) + GQW(i)*ff*ff_gamma
        derlikelihood(JJ+2) = derlikelihood(JJ+2) + GQW(i)*ff*(x*x-0.5d0)/tau2
    enddo
    derlikelihood = derlikelihood / likelihoodf
    prob = prob/sqrt(pi)

end subroutine der_likelihood_timelogit

function LogitPower_notime(mu, beta, tau2, II, JJ, KK, GQ, GQX, GQW,X_in,typeone) result (power)
    implicit none
    ! ---- arg types -----------------------
    double precision :: mu, beta, tau2,typeone,ppp
    integer :: II, JJ, KK,ifault
    integer :: X_in(II,JJ)
    ! true values of beta0, beta1, and tau2

    ! II : number of clusters
    ! JJ : number of steps
    ! KK : number of subjects per cluster per step
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    double precision :: power
    ! ----------------------------------------
    integer :: NI   ! number of subjects per cluster, NI=JJ*KK
    !integer :: DD   ! II/(JJ-1). By design, II is a multiple of (JJ-1)

    double precision, parameter :: PI = 3.14159265358979323846   ! pi
    integer :: i, j
    integer :: z0(II), z1(II)
    integer :: z00, z01, z10, z11
    double precision :: h11, h12, h13, h22, h23, h33,h11pre,h12pre,h13pre,h22pre,h23pre,h33pre
    double precision :: derlikelihood_mu, derlikelihood_beta, derlikelihood_tau2
    double precision, external :: prob_z
    double precision :: prob
    double precision :: sebeta  ! se of beta1
    logical :: upper
    double precision, external :: ppnd16
    double precision, external :: alnorm

    upper = .false.
    ifault = 0

    NI = JJ * KK
    !DD = II/(JJ-1)


    z0 = 0
    do j=1,II
        z0(j) =(JJ-sum(X_in(j,:)))*KK
    enddo
    z1 = NI - z0

    h11 = 0.0d0
    h12 = 0.0d0
    h13 = 0.0d0
    h22 = 0.0d0
    h23 = 0.0d0
    h33 = 0.0d0
    do i=1,II
      if(i>1 .and. ALL(X_in(i,:).EQ. X_in(i-1,:))) then
        h11=h11+h11pre
        h22=h22+h22pre
        h33=h33+h33pre
        h12=h12+h12pre
        h13=h13+h13pre
        h23=h23+h23pre
      else
        h11pre=0
        h22pre=0
        h33pre=0
        h12pre=0
        h13pre=0
        h23pre=0
        do z00 = 0,z0(i)
            z01 = z0(i) - z00
            do z10 = 0,z1(i)
                z11 = z1(i) - z10
                call der_likelihood_notimelogit(mu, beta, tau2, z00, z01, z10, z11, GQ, GQX, GQW, derlikelihood_mu, &
                derlikelihood_beta, derlikelihood_tau2, prob)
                h11 = h11 + derlikelihood_mu*derlikelihood_mu*prob
                h22 = h22 + derlikelihood_beta*derlikelihood_beta*prob
                h33 = h33 + derlikelihood_tau2*derlikelihood_tau2*prob
                h12 = h12 + derlikelihood_mu*derlikelihood_beta*prob
                h13 = h13 + derlikelihood_mu*derlikelihood_tau2*prob
                h23 = h23 + derlikelihood_beta*derlikelihood_tau2*prob
                h11pre=h11pre+derlikelihood_mu*derlikelihood_mu*prob
                h22pre=h22pre+derlikelihood_beta*derlikelihood_beta*prob
                h33pre = h33pre + derlikelihood_tau2*derlikelihood_tau2*prob
                h12pre = h12pre + derlikelihood_mu*derlikelihood_beta*prob
                h13pre = h13pre + derlikelihood_mu*derlikelihood_tau2*prob
                h23pre = h23pre + derlikelihood_beta*derlikelihood_tau2*prob
            enddo
        enddo
      end if
    enddo
    sebeta = sqrt(abs((h33*h11-h13*h13)/(h11*h22*h33+2.0d0*h12*h23*h13-h13*h13*h22-h12*h12*h33-h23*h23*h11)))

  !  if(beta<0) then
  !  power =alnorm(-beta/sebeta-1.959964d0,upper)
  !else
  !  power =alnorm(beta/sebeta-1.959964d0,upper)
  !end if
  ppp=ppnd16(typeone/2,ifault)
  power = alnorm(beta/sebeta+ppp,upper) + alnorm(-beta/sebeta+ppp,upper)
end function LogitPower_notime


subroutine der_likelihood_notimelogit(mu, beta, tau2, z00, z01, z10, z11, GQ, GQX, GQW, derlikelihood_mu, &
derlikelihood_beta, derlikelihood_tau2, prob)
    implicit none
    ! ---- arg types -----------------------
    double precision :: mu, beta, tau2
    ! true values of beta0, beta1, and tau2
    integer :: z00, z01, z10, z11
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    double precision :: derlikelihood_mu
    double precision :: derlikelihood_beta
    double precision :: derlikelihood_tau2
    double precision :: prob
    ! ---------------------------------------
    double precision :: likelihoodf

    double precision :: ff00, ff01, ff10, ff11
    double precision :: ff, ff1, ffprob, ff0prob, ff1prob
    integer :: z0, z1
    integer :: i, k
    double precision :: x

    double precision, parameter :: PI = 3.14159265358979323846   ! pi

    z0 = z00 + z01
    z1 = z10 + z11
    derlikelihood_mu = 0.0d0
    derlikelihood_beta = 0.0d0
    derlikelihood_tau2 = 0.0d0
    likelihoodf = 0.0d0
    prob = 0.0d0
    do i=1,GQ
        x = GQX(i)
        ff = 1.0d0
        ffprob = 1.0d0
        ff00 = 1.0d0/(1.0d0+exp(mu+sqrt(2.0d0*tau2)*x))
        ff01 = 1-ff00
        ff10 = 1.0d0/(1.0d0+exp(mu+beta+sqrt(2.0d0*tau2)*x))
        ff11 = 1-ff10

        ff = (ff00**z00)*(ff01**z01)*(ff10**z10)*(ff11**z11)
        likelihoodf = likelihoodf + GQW(i) * ff
        ff1 = ff*(z01*ff00-z00*ff01+z11*ff10-z10*ff11)
        derlikelihood_mu = derlikelihood_mu + GQW(i) * ff1
        ff1 = ff*(z11*ff10-z10*ff11)
        derlikelihood_beta = derlikelihood_beta + GQW(i) * ff1
        ff1 = ff*(x*x-0.5d0)/tau2
        derlikelihood_tau2 = derlikelihood_tau2 + GQW(i) * ff1

        ! prob
        ff0prob = ff00*ff01
        ff1prob = ff10*ff11
        ! compute combination number with power of ff00 and ff01
        ! to avoid overflow
        if (z00<z01) then
            ffprob = ffprob*ff01**(z01-z00)
            do k=0,(z00-1)
                ffprob = ffprob*dble(z0-k)/dble(z00-k)*ff0prob
            end do
        else
            ffprob = ffprob*ff00**(z00-z01)
            do k=0,(z01-1)
                ffprob = ffprob*dble(z0-k)/dble(z01-k)*ff0prob
            end do
        end if
        ! compute combination number with power of ff10 and ff11
        ! to avoid overflow
        if (z10<z11) then
            ffprob = ffprob*ff11**(z11-z10)
            do k=0,(z10-1)
                ffprob = ffprob*dble(z1-k)/dble(z10-k)*ff1prob
            end do
        else
            ffprob = ffprob*ff10**(z10-z11)
            do k=0,(z11-1)
                ffprob = ffprob*dble(z1-k)/dble(z11-k)*ff1prob
            end do
        end if
        prob = prob + GQW(i) * ffprob
    enddo
    derlikelihood_mu = derlikelihood_mu / likelihoodf
    derlikelihood_beta = derlikelihood_beta / likelihoodf
    derlikelihood_tau2 = derlikelihood_tau2 / likelihoodf
    ! likelihoodf = likelihoodf/sqrt(pi)
    prob = prob / sqrt(pi)
end subroutine der_likelihood_notimelogit

function LogPower_GEE_notime(mu, beta, gamma,rho0, II, JJ, KK, &
                     X_in,ICC0,ICC2,typeone) result (power)


    implicit none
    ! ---- arg types -----------------------
    integer :: II, JJ, KK
    integer :: X_in(II,JJ)
    ! II : number of clusters
    ! JJ : number of steps
    ! KK : number of subjects per cluster per step
    double precision :: mu, beta,rho0,alpha0,alpha1,alpha2,ICC0,ICC2,typeone,ppp
    ! true values of mu, beta, and tau2
    double precision :: gamma(JJ),period(2),B1(JJ*KK,JJ*KK)
    !double precision :: a, b        ! lower and upper limits of GL integral
    !integer :: mincomp(JJ+2), maxcomp(JJ+2)
    !integer :: GQ   ! number of GQ points
    !double precision :: GQX(GQ), GQW(GQ)
    !double precision :: t_power
    double precision :: power,lambda1,lambda2,lambda3,lambda4,vardelta
    ! ----------------------------------------

    double precision, parameter :: PI = 3.14159265358979323846   ! pi
    real :: X(JJ,2)  ! intervention matrix
         ! II/(JJ-1). By design, II is a multiple of (JJ-1)
    integer :: i, j, k,m,ifault
    integer :: l
    !logical :: upper

    !double precision, external :: alnorm
    !integer, external :: updatez
    double precision :: M1(JJ,JJ),M2(KK,KK), M3(JJ,JJ), M4(KK,KK)
    double precision :: z0(JJ*KK),z1(JJ*KK,JJ*KK),gmu(JJ),mmu(JJ,JJ)   ! z0: # of subjects with outcome 0; z1: # of subjects with outcome 1.
    double precision :: bm1(JJ*KK,JJ*KK),bm4(JJ*KK,JJ*KK),R(JJ*KK,JJ*KK)
    double precision :: bm2(JJ*KK,JJ*KK),bm3(JJ*KK,JJ*KK)
    double precision :: B2(JJ*KK,JJ*KK),B3(JJ*KK,JJ*KK),Wsub4(2,JJ)
    double precision :: invR(JJ*KK,JJ*KK),Omega(2,2),Ry(2)
    double precision :: invOmega(2,2),Wsub(JJ,2),Wsub3(JJ,JJ),Wsub2(JJ,JJ)
    double precision :: W(JJ,JJ)
    ! integer :: nZ               ! total number of possible combination of z0 and z1
    !integer :: finish
    !double precision :: derlikelihood(JJ+2)   ! derivative of likelihood
    !double precision :: derlikelihood2(JJ+2, JJ+2)  ! square of derivative of likelihood
    !double precision :: invVar(JJ+2,JJ+2)      ! inverse of variance matrix
    !double precision :: Var(JJ+2,JJ+2)         ! variance matrix
    !double precision :: prob
    !double precision :: sebeta  ! se of beta
    logical :: upper
    double precision, external :: alnorm
    double precision, external :: ppnd16
  !  double precision, external :: diag
    double precision, external :: matmual
    upper = .false.
    ifault = 0
    gamma=0
    z0=1
    z1=1

    B1=0
    !allocate(X_in(II,JJ))

    !DD=II/GG
    !DD = II/(JJ-1)   ! II is a multiple of (JJ-1)
    ! assign intervention


    alpha0= ICC0
    alpha1= rho0
    alpha2= ICC2

    !correlation matrix
    do i = 1, JJ*KK
    B1(i,i) = z0(i)
    end do

    M1=1
    M2=0
    do i = 1,KK
      M2(i,i)=1
    end do

    M3=0
    do i = 1,JJ
      M3(i,i)=1
    end do
    M4=1

    B2=0
    B3=0
    bm1 = (1- alpha0 + alpha1 - alpha2) * B1

    Do i=1,JJ  ! tab(i,.)
          Do j=1,JJ  ! tab(i,j)
                Do k=1,KK
                      Do l=1,KK
                             B2((i-1)*KK+k,(j-1)*KK+l)=M1(i,j)*M2(k,l)
                       Enddo
                 Enddo
           Enddo
    enddo






    !call kron_prod(M1,M2,B2)
    bm2 = (alpha2 - alpha1)*B2


        Do i=1,JJ  ! tab(i,.)
              Do j=1,JJ  ! tab(i,j)
                    Do k=1,KK
                          Do l=1,KK
                                 B3((i-1)*KK+k,(j-1)*KK+l)=M3(i,j)*M4(k,l)
                           Enddo
                     Enddo
               Enddo
        enddo



    !call kron_prod(M3,M4,B3)
    bm3 = (alpha0 - alpha1)*B3
    bm4 = alpha1 * z1
    R= bm1+bm2+bm3+bm4


    !check positive definiteness
    lambda1 = 1- alpha0 + alpha1 - alpha2
    lambda2 = 1- alpha0 - (JJ-1)*(alpha1 - alpha2)
    lambda3 = 1 + (KK-1)*(alpha0 - alpha1) - alpha2
    lambda4 = 1 + (KK-1)*alpha0 + (JJ-1)*(KK-1)*alpha1 + (JJ-1)*alpha2

    if (min(lambda1,lambda2,lambda3,lambda4)<0) then
       !print *, 'not positive-definite, min(lambda1,lambda2,lambda3,lambda4)<0'
      !stop
    end if
    !inverse of R
    !analytical inverse is used here, if the matrix gets large,
    !one could also use the closed-form expression provided in the paper
    call syminverse(R,invR,JJ*KK)
    X = 0
    Omega = 0
    Ry = 0


            period(2)=beta

            period(1)= mu
            mmu=0
             X=1

           Omega=0
           do i=1,II
              do j=1,JJ
                X(j,2)=X_in(i,j)
           end do
           gmu=matmul(X,period)
           do m=1,JJ
             mmu(m,m)=EXP(gmu(m))

             if ((mmu(m,m)*mmu(m,m)+alpha0*mmu(m,m)*(1-mmu(m,m)))>mmu(m,m)) then
                !print *, '(mmu(m,m)*mmu(m,m)+alpha0*mmu(m,m)*(1-mmu(m,m)))>mmu(m,m)'
               !stop
             end if

             if ((mmu(m,m)*mmu(m,m)+alpha0*mmu(m,m)*(1-mmu(m,m)))<max(2*mmu(m,m)-1,0d0)) then
                !print *, '(mmu(m,m)*mmu(m,m)+alpha0*mmu(m,m)*(1-mmu(m,m)))<max(2*mmu(m,m)-1,0d0)'
               !stop
             end if

             mmu(m,m)=(mmu(m,m)*(1-mmu(m,m)))**0.5
             mmu(m,m)=EXP(gmu(m))*1/mmu(m,m)
           enddo

           do m=1,(JJ-1)
             do k=(m+1),JJ
               if (((gmu(m)*gmu(k)+alpha1*((gmu(m)*(1-gmu(m)))**0.5)*((gmu(k)*(1-gmu(k)))**0.5)))>min(gmu(m),gmu(k))) then
                  !print *, '((gmu(m)*gmu(k)+alpha1*((gmu(m)*(1-gmu(m)))**0.5)*((gmu(k)*(1-gmu(k)))**0.5)))>min(gmu(m),gmu(k))'
                 !stop
               end if

               if (((gmu(m)*gmu(k)+alpha1*((gmu(m)*(1-gmu(m)))**0.5)*((gmu(k)*(1-gmu(k)))**0.5)))<max(gmu(m)+gmu(k)-1,0d0)) then
                  !print *, '((gmu(m)*gmu(k)+alpha1*((gmu(m)*(1-gmu(m)))**0.5)*((gmu(k)*(1-gmu(k)))**0.5)))<max(0,gmu(m)+gmu(k)-1)'
                 !stop
               end if
               if (((gmu(m)*gmu(k)+alpha2*((gmu(m)*(1-gmu(m)))**0.5)*((gmu(k)*(1-gmu(k)))**0.5)))>min(gmu(m),gmu(k))) then
                  !print *, '((gmu(m)*gmu(k)+alpha2*((gmu(m)*(1-gmu(m)))**0.5)*((gmu(k)*(1-gmu(k)))**0.5)))>min(gmu(m),gmu(k))'
                 !stop
               end if

               if (((gmu(m)*gmu(k)+alpha2*((gmu(m)*(1-gmu(m)))**0.5)*((gmu(k)*(1-gmu(k)))**0.5)))<max(gmu(m)+gmu(k)-1,0d0)) then
                  !print *, '((gmu(m)*gmu(k)+alpha2*((gmu(m)*(1-gmu(m)))**0.5)*((gmu(k)*(1-gmu(k)))**0.5)))<max(0,gmu(m)+gmu(k)-1)'
                !stop
               end if

             end do
           end do

           Wsub=matmul(mmu,X)
           W=0
           do k=1,JJ
             W(k,k)=KK/lambda3
           end do
           Wsub2=1
           do k=1,JJ
           do m=1,JJ
             Wsub2=(lambda4-lambda3)*KK/(JJ*lambda4*lambda3)
           enddo
           enddo

           Wsub3=W-Wsub2
           Wsub4=matmul(TRANSPOSE(Wsub),Wsub3)
           Omega=Omega+matmul(Wsub4,Wsub)
           end do

           call syminverse(Omega,invOmega,2)
      ! call syminverse(Omega,invOmega,2)


        vardelta = invOmega(2,2)
     ! verify whether this is close to the assumed delta, which is log(0.25)
    !vardelta = invOmega(1,1)!  # var of the trt effect estimator


    !delta=0
    !vardelta=1
    ! z-test
    !power = alnorm(delta/sqrt(vardelta)-1.959964d0,upper) + alnorm(-delta/sqrt(vardelta)-1.959964d0,upper)
    !if(beta<0) then
    !power =alnorm(-beta/sqrt(vardelta)-1.959964d0,upper)
  !else
    !power =alnorm(beta/sqrt(vardelta)-1.959964d0,upper)
  !end if
  ppp=ppnd16(typeone/2,ifault)
  power =alnorm(-beta/sqrt(vardelta)+ppp,upper)+alnorm(beta/sqrt(vardelta)+ppp,upper)

  !power =alnorm(-beta/sqrt(vardelta)-1.959964d0,upper)+alnorm(beta/sqrt(vardelta)-1.959964d0,upper)

    !z_power = pnorm(qnorm(0.05/2) + abs(delta)/sqrt(vardelta))
   !print(z_power)

    ! t-test df=# clusters minus p
  !  df = II - (JJ+1)
  !  t_power = pt(qt(0.05/2,df=df) + abs(delta)/sqrt(vardelta),df=df)


end function LogPower_GEE_notime

subroutine computeparameterlogit(JJ, mu, beta, gamma, tau2, p0, p11, rho0, GQ, GQX, GQW, convergence)
    implicit none
    ! ---- arg types -----------------------
    integer :: JJ
    double precision :: mu, beta, tau2
    double precision :: gamma(JJ)
    double precision :: p11, rho0
    double precision :: p0(JJ)
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    integer :: convergence
    ! ---------------------------------------
    ! ---------------------------------------
    double precision :: f2(2)
    double precision :: derf2(2,2)
    double precision :: invderf2(2,2)
    double precision :: f, derf, invderf
    double precision :: gammatemp
    !integer :: iter
    integer :: i, j

    double precision, parameter :: epsilon=1.0d-5
    integer, parameter :: maxiter=100

    convergence = 0
    ! compute mu and tau2
    do i=1,maxiter
        call computef_mutau2(f2, mu, tau2, p0(1), rho0, GQ, GQX, GQW)
        call derivativef_mutau2(derf2, mu, tau2, p0(1), rho0, GQ, GQX, GQW)
        if (maxval(abs(f2))<epsilon) then
            convergence = convergence + 1
            exit
        end if
        call inverse(derf2,invderf2,2)
        mu = mu - dot_product(invderf2(1,:), f2)
        tau2 = tau2 - dot_product(invderf2(2,:), f2)
        if (tau2<epsilon) tau2 = epsilon
    end do
    ! compute beta
    do i=1,maxiter
        call computef(f, mu, beta, tau2, p11, GQ, GQX, GQW)
        call derivativef(derf, mu, beta, tau2, p11, GQ, GQX, GQW)
        if (abs(f)<epsilon) then
            convergence = convergence + 1
            exit
        end if
        invderf = 1.0d0 / derf
        beta = beta - invderf * f
    end do
    ! gamma
    gamma(1) = 0.0d0
    do j=2,JJ
        gammatemp = 0.0d0
        do i=1,maxiter
            call computef(f, mu, gammatemp, tau2, p0(j), GQ, GQX, GQW)
            call derivativef(derf, mu, gammatemp, tau2, p0(j), GQ, GQX, GQW)
            if (abs(f)<epsilon) then
                gamma(j) = gammatemp
                convergence = convergence + 1
                exit
            end if
            invderf = 1/derf
            gammatemp = gammatemp - invderf * f
        end do
    end do

    if (convergence==(JJ+1)) then
        convergence=1
    else
        convergence=0
    end if
end subroutine computeparameterlogit

subroutine computef_mutau2(f, mu, tau2, p01, rho0, GQ, GQX, GQW)
    implicit none
    ! ---- arg types -----------------------
    double precision :: f(2)
    double precision :: mu
    double precision :: tau2
    double precision :: p01, rho0
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    ! ---------------------------------------
    double precision, parameter :: PI = 3.14159265358979323846   ! pi
    double precision :: intp0
    ! intp0 = int p0
    double precision :: intp02
    ! intp02 = int (p0)^2
    double precision :: intp0p00
    ! intp0p00 = int p0(1-p0)
    integer :: i
    double precision :: x
    double precision :: ff00, ff01
    double precision :: denominator, numerator

    intp0 = 0.0d0
    intp02 = 0.0d0
    intp0p00 = 0.0d0
    do i=1,GQ
        x = GQX(i)
        ff00 = 1.0d0/(1.0d0+exp(mu+sqrt(2.0d0*tau2)*x))
        ff01 = 1-ff00
        intp0 = intp0 + GQW(i) * ff01
        intp02 = intp02 + GQW(i) * ff01 * ff01
        intp0p00 = intp0p00 + GQW(i) * ff00 * ff01
    enddo
    intp0 = intp0 / sqrt(pi)
    intp02 = intp02 / sqrt(pi)
    intp0p00 = intp0p00 / sqrt(pi)

    f(1) = intp0 - p01
    denominator = intp0p00+intp02-intp0*intp0
    numerator = intp02-intp0*intp0
    f(2) = numerator - rho0 * denominator
end subroutine computef_mutau2

subroutine derivativef_mutau2(derf, mu, tau2, p01, rho0, GQ, GQX, GQW)
    implicit none
    ! ---- arg types -----------------------
    double precision :: derf(2,2)
    ! double precision :: f(2)
    double precision :: mu
    double precision :: tau2
    double precision :: p01, rho0
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    ! ---------------------------------------
    double precision, parameter :: PI = 3.14159265358979323846   ! pi
    double precision :: intp0
    ! intp0 = int p0
    double precision :: intp0tau
    double precision :: intp02tau
    double precision :: intp0p00
    ! intp0p00 = int p0(1-p0
    double precision :: intp0p00tau
    double precision :: intp02p00
    double precision :: intp00temp
    integer :: i
    double precision :: x
    double precision :: ff00, ff01

    intp0 = 0.0d0
    intp0tau = 0.0d0
    intp02tau = 0.0d0
    intp0p00 = 0.0d0
    intp0p00tau = 0.0d0
    intp02p00 = 0.0d0
    intp00temp = 0.0d0
    p01= p01
    do i=1,GQ
        x = GQX(i)
        ff00 = 1.0d0/(1.0d0+exp(mu+sqrt(2.0d0*tau2)*x))
        ff01 = 1-ff00
        intp0 = intp0 + GQW(i) * ff01
        intp0tau = intp0tau + GQW(i) * ff01 * (x*x-0.5d0)/tau2
        intp02tau = intp02tau + GQW(i) * ff01 * ff01 * (x*x-0.5d0)/tau2
        intp0p00 = intp0p00 + GQW(i) * ff00 * ff01
        intp0p00tau = intp0p00tau + GQW(i)*ff00*ff01*(x*x-0.5d0)/tau2
        intp02p00 = intp02p00 + GQW(i) * ff01*ff01*ff00
        intp00temp = intp00temp + GQW(i) * ff01*ff00*(ff00-ff01)
    enddo
    intp0 = intp0 / sqrt(pi)
    intp0tau = intp0tau / sqrt(pi)
    intp02tau = intp02tau / sqrt(pi)
    intp0p00 = intp0p00 / sqrt(pi)
    intp0p00tau = intp0p00tau / sqrt(pi)
    intp02p00 = intp02p00 / sqrt(pi)
    intp00temp = intp00temp / sqrt(pi)

    derf(1,1) = intp0p00
    derf(2,1) = 2*(1-rho0)*intp02p00 -2*(1-rho0)*intp0*intp0p00-rho0*intp00temp
    derf(1,2) = intp0tau
    derf(2,2) = (1-rho0)*intp02tau - 2*(1-rho0)*intp0*intp0tau - rho0*intp0p00tau
end subroutine derivativef_mutau2

subroutine computef(f, mu, beta, tau2, p1, GQ, GQX, GQW)
    implicit none
    ! ---- arg types -----------------------
    double precision :: f
    double precision :: mu
    double precision :: beta
    double precision :: tau2
    double precision :: p1
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    ! ---------------------------------------
    double precision, parameter :: PI = 3.14159265358979323846   ! pi
    double precision :: intp
    integer :: i
    double precision :: x
    double precision :: ff

    intp = 0.0d0
    do i=1,GQ
        x = GQX(i)
        ff = 1.0d0 - 1.0d0/(1.0d0+exp(mu+beta+sqrt(2.0d0*tau2)*x))
        intp = intp + GQW(i) * ff
    enddo
    intp = intp / sqrt(pi)

    f = intp - p1

end subroutine computef

subroutine derivativef(derf, mu, beta, tau2, p1, GQ, GQX, GQW)
    implicit none
    ! ---- arg types -----------------------
    double precision :: derf
    double precision :: mu
    double precision :: beta
    double precision :: tau2
    double precision :: p1
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    ! ---------------------------------------
    double precision, parameter :: PI = 3.14159265358979323846   ! pi
    double precision :: intp0p00
    integer :: i
    double precision :: x
    double precision :: ff00, ff01
    p1=0+p1
    intp0p00 = 0.0d0
    do i=1,GQ
        x = GQX(i)
        ff00 = 1.0d0/(1.0d0+exp(mu+beta+sqrt(2.0d0*tau2)*x))
        ff01 = 1-ff00
        intp0p00 = intp0p00 + GQW(i) * ff00 * ff01
    enddo
    derf = intp0p00 / sqrt(pi)

end subroutine derivativef

#' A function of power calculation for Stepped Wedge Design Studies
#' @description This function performs power calculations for stepped wedge cluster randomized trials under different scenarios. The default setting assumes no time effect; to include time effects, set meanresponse_start and meanresponse_end0 to different values. Please refer to the documentation for guidance on incorporating time effects.
#' @param K number of participants at each time period in a cluster, specified as the average clusterperiod size considering cluster-size variability
#' @param design I*J dimensional data set that describes the study design (control 0, intervention 1), I is the number of clusters, J is the number of time periods. Unequal allocation of sequences and only complete designs with no transition periods are allowed
#' @param family family of responses, specify family="gaussian" for continuous outcome and family="binomial" for binary outcome, with default value of "binomial"
#' @param model choose from conditional model (model="conditional") and marginal model (model="marginal"), with default value of applying conditional model
#' @param link choose link function from link="identity", link="log" and link="logit", with default value of identity link
#' @param type choose the study type, specify type="cohort" for closed cohort study and type="cross-sectional" for cross-sectional study, with default value of cross-sectional study
#' @param meanresponse_start the anticipated mean response in the control group at the start of the study
#' @param meanresponse_end0 the anticipated mean response in the control group at the end of the study, with default value equals to meanresponse_start (no time effects). To include time effects in your model, set meanresponse_start and meanresponse_end0 to different values.
#' @param meanresponse_end1 the anticipated mean response in the intervention group at the end of the study
#' @param effectsize_beta the anticipated effect size, just omit this parameter if you don't need to specify it. In all scenarios, you can choose to specify the three parameters about mean responses without specifying this effect size, or alternatively specify meanresponse_start, meanresponse_end0 and this effect size. For continuous outcomes, users can conduct power calculations by only specifying this parameter without the above three parameters about mean responses (as the power is dependent just on it), then calculation will be implemented assuming scenarios without time effects. If you would consider scenarios with time effects and continuous outcomes, please specify meanresponse_start, meanresponse_end0 (donot require accurate information, just make sure they are not equal) and this effectsize_beta.
#' @param sigma2 marginal variance of the outcome (only needed for continuous outcomes and should not be an input for binary outcomes), with default value of 0.
#' @param typeIerror two-sided type I error, with default value of 0.05
#' @param alpha0 within-period correlation, with default value of 0.1
#' @param alpha1 between-period correlation, with default value of alpha0/2
#' @param alpha2 within-individual correlation, should not be an input under cross-sectional designs although it is numerically identical to alpha1 in this scenario by definition
#' @return The object returned has a class of \code{swdpower}, which includes a list of the design matrix and a summary of this design (including the power)
#' @examples
#' library(swdpwr)
#' #a cross-sectional design with 12 clusters, 3 periods and binary outcomes applying conditional model
#' #alpha2 should not be specified, as the current version does not support power calculation using
#' #conditional models with binary outcomes in a cohort design
#' #create a 12*3 matrix which describes the study design,
#' #0 means control status, 1 means intervention status
#' dataset = matrix(c(rep(c(0,1,1),6),rep(c(0,0,1),6)),12,3,byrow=TRUE)
#'
#' #specify meanresponse_start, meanresponse_end0 and meanresponse_end1
#' swdpower(K = 30, design = dataset, family = "binomial", model = "conditional", link = "logit",
#' type = "cross-sectional", meanresponse_start = 0.2, meanresponse_end0 = 0.3,
#' meanresponse_end1 = 0.4, typeIerror = 0.05, alpha0 = 0.01, alpha1 = 0.01)
#'
#' #specify meanresponse_start, meanresponse_end0 and effectsize_beta
#' swdpower(K = 30, design = dataset, family = "binomial", model = "conditional", link = "logit",
#' type = "cross-sectional", meanresponse_start = 0.2, meanresponse_end0 = 0.3, effectsize_beta = 0.6,
#' typeIerror = 0.05, alpha0 = 0.01, alpha1 = 0.01)
#'
#' #a cohort design with 8 clusters, 3 periods and continuous outcomes applying marginal model
#' #sigma2 should be specified, as continuous outcomes require marginal variance in calculation
#' #create a 8*3 matrix which describes the study design,
#' #0 means control status, 1 means intervention status
#' dataset = matrix(c(rep(c(0,1,1),4),rep(c(0,0,1),4)),8,3, byrow=TRUE)
#'
#' #specify meanresponse_start, meanresponse_end0 and meanresponse_end1 assuming time effects
#' swdpower(K = 24, design = dataset, family = "gaussian", model = "marginal", link = "identity",
#' type = "cohort", meanresponse_start = 0.1, meanresponse_end0 = 0.2,  meanresponse_end1 = 0.4,
#' sigma2 = 0.095, typeIerror = 0.05, alpha0 = 0.03, alpha1 = 0.015, alpha2 = 0.2)
#'
#' #specify meanresponse_start, meanresponse_end0 and effectsize_beta assuming time effects.
#' #As an alternative to the previous example, the time effect specification for meanresponse_start
#' #and meanresponse_end0 does not need to be precise (make sure they are not equal).
#' swdpower(K = 24, design = dataset, family = "gaussian", model = "marginal", link = "identity",
#' type = "cohort", meanresponse_start = 0.1, meanresponse_end0 = 0.2,  effectsize_beta=0.2,
#' sigma2 = 0.095, typeIerror = 0.05, alpha0 = 0.03, alpha1 = 0.015, alpha2 = 0.2)
#'
#' #specify effectsize_beta only, then the program runs assuming no time effects
#' swdpower(K = 24, design = dataset, family = "gaussian", model = "marginal", link = "identity",
#' type = "cohort",effectsize_beta=0.3, sigma2 = 0.095, typeIerror = 0.05, alpha0 = 0.03,
#' alpha1 = 0.015, alpha2 = 0.2)
#' @export

swdpower<-function(K, design, family="binomial", model="conditional", link="identity", type="cross-sectional", meanresponse_start=NA, meanresponse_end0=meanresponse_start, meanresponse_end1=NA, effectsize_beta=NA, sigma2=0, typeIerror=0.05, alpha0=0.1, alpha1=alpha0/2, alpha2=NA)
{
  ICC0=alpha0
  ICC1=alpha1
  ICC2=alpha2
  if(type!="cohort"&&type!="cross-sectional") stop("Wrong input for study type.")
  if(model=="conditional"&&type=="cohort"&&family=="binomial") {
    warning("For binary outcomes, conditional model only allows for cross-sectional settings.'type='cross-sectional'' is forced.")
    type="cross-sectional"}
  if(type=="cross-sectional"&is.na(ICC2)==0) warning("For a cross-sectional study, alpha2 is undefined. So please do not specify it although it equals to alpha1 by definition.")
  if(type=="cross-sectional")  ICC2=ICC1
  if(family=="binomial"&&sigma2!=0)  warning("Argument 'sigma2=' is not used because 'family='binomial'' is specified. For binary outcomes, the marginal variance of outcome sigma2 should not be an input.")
  if(family=="gaussian") {response=1} else
    if(family=="binomial") {response=2} else
    {stop("Wrong input of class for family of responses.")}
  if(family=="gaussian"&&link!="identity") {
    warning("Continuous outcomes only allow for identity link function and the link function is forced to be identity.")
    link="identity"
  }
  lf=link
  if(link=="identity") {link=1} else
    if(link=="log") {link=2} else
      if(link=="logit") {link=3} else
      {stop("Wrong input of class for link functions.")}

  if(model=="conditional"&&type=="cross-sectional"&&family=="binomial"&&(ICC0!=ICC1)) {
    warning("For cross-sectional setting and binary outcome, conditional model requires alpha0=alpha1 as time effects are fixed. Value of 'alpha0' is set to 'alpha1'.")
    ICC0=ICC1}

  md=model
  if(model=="conditional") {model=1} else
    if(model=="marginal") {model=2} else
    {stop("Wrong input of class for models.")}
  if(type=="cohort"&&is.na(ICC2)==1) stop("ICC2 should be specified for cohort study")
  if(family=="gaussian"&&sigma2==0) warning("The marginal variance sigma2 should be specified for continuous outcomes")

  if(!is.na(meanresponse_start)&&!is.na(meanresponse_end0)&&!is.na(meanresponse_end1)&&!is.na(effectsize_beta)) stop("Don't specify all of meanresponse_start, meanresponse_end0, meanresponse_end1, effectsize_beta at the same time. Only two ways of parameter specification are allowed: 1)specify: meanresponse_start, meanresponse_end0, meanresponse_end1; 2)specify: meanresponse_start, meanresponse_end0, effectsize_beta.")
  if(family=="gaussian"&&!is.na(effectsize_beta)&&!is.na(meanresponse_end1-meanresponse_end0)&&((meanresponse_end1-meanresponse_end0)!=effectsize_beta)) {stop("The effect size has contradictive input as meanresponse_end1-meanresponse_end0 is not equal to effectsize_beta.")}
  if(family=="gaussian"&!is.na(effectsize_beta)) {
    if(!is.na(meanresponse_end0-meanresponse_start)) {meanresponse_end1=meanresponse_end0+effectsize_beta}
    else {
      meanresponse_start=0
      meanresponse_end0=0
      meanresponse_end1=meanresponse_end0+effectsize_beta}
  }
  if(family=="binomial"&&is.na(meanresponse_end1)) {
    if(link==1) meanresponse_end1=meanresponse_end0+effectsize_beta
    if(link==2) meanresponse_end1=(meanresponse_end0)*exp(effectsize_beta)
    if(link==3) meanresponse_end1=((1/(1-meanresponse_end0)-1)*exp(effectsize_beta))/(1+((1/(1-meanresponse_end0)-1)*exp(effectsize_beta)))
  }

  if(!is.na(meanresponse_start)*!is.na(meanresponse_end0)*!is.na(meanresponse_end1)) {}
  else stop("Missing input parameter for effect size calculation.")
  m1=meanresponse_start
  m2=meanresponse_end0
  m3=meanresponse_end1
  tem1=min(m1,m2,m3)
  tem2=max(m1,m2,m3)
  if(family=="binomial"&&tem1<0) stop("Violation of valid probability, given input parameters: min(meanresponse_start,meanresponse_end0, meanresponse_end1)<0. Please check whether any of these values are out of range and revise one or more of them.")
  if(family=="binomial"&&tem2>1) stop("Violation of valid probability, given input parameters: max(meanresponse_start,meanresponse_end0, meanresponse_end1)>1. Please check whether any of these values are out of range and revise one or more of them.")

  if(family=="binomial"&&model==1&&(K>150)&&(m1!=m2)) stop("K should be at least smaller than 150 for this scenario as the running time is too long with this K for the power calculation of binary outcomes under conditional model with time effects. Please reduce K or use the model without time effects or use marginal models.")

  dataset=design
  I=dim(dataset)[1]
  J=dim(dataset)[2]
  II=I
  JJ=J
  KK=K
  X_in=dataset
  res=response
  opt=model
  if(link==1) {
    mu=m1
    gammaJ=m2-m1
    beta=m3-m2
  }
  if(link==2) {
    mu=log(m1)
    gammaJ=log(m2/m1)
    beta=log(m3/m2)
  }
  if(link==3) {
    mu=log(1/(1-m1)-1)
    gammaJ=log(1/(1-m2)-1)-log(1/(1-m1)-1)
    beta=log(1/(1-m3)-1)-log(1/(1-m2)-1)
  }

  alpha=typeIerror
  mu=mu
  beta=beta
  p0totalchange=gammaJ
  sigma2=sigma2
  rho0=ICC1
  typeone=alpha
  link=link-1


  TOLERANCE = 1e-5
  convergence = 0
  p0 = rep(0,JJ)
  gamma = rep(0,JJ)
  mincomp = rep(0,JJ+2)
  maxcomp = rep(0,JJ+2)
  #initialization
  tau2=1
  power=0



  temp1=c(ICC0,ICC1,ICC2)
  if(max(temp1)>1) stop('Violate range of intraclass correlations: max(alpha0,alpha1,alpha2)>1.Please correct the values of correlation parameters, they must be between 0 and 1.')

  temp1=c(ICC0,ICC1,ICC2)
  if(min(temp1)<0) stop('Violate range of intraclass correlations: min(alpha0,alpha1,alpha2)<0.Please correct the values of correlation parameters, they must be between 0 and 1.')

  if(typeone>1) stop("Two-sided Type I error provided is larger than 1, it must be between 0 and 1, and is usually 0.05.")
  if(typeone<0) stop("Two-sided Type I error provided is less than 0, it must be between 0 and 1, and is usually 0.05.")
  alpha0= ICC0
  alpha1= rho0
  alpha2= ICC2
  if(res>1.5){

    if(opt<1.5)
    {
      if (p0totalchange > TOLERANCE | p0totalchange < -TOLERANCE)
      {
        if(link<1)
        {
          GQ=100
          GQX = rep(0,GQ)
          GQW = rep(0,GQ)
          p01=mu
          p11=mu+beta
          p0[1] = p01
          p11 = p11
          p0stepchange = p0totalchange/(JJ-1)
          for(j in 2:JJ)
          {
            p0[j]= p0[j-1] + p0stepchange
          }
          #  call computeparameter(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
          #dyn.load("computeparameter.so")
          mu=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$mu)
          beta=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$beta)
          gamma=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$gamma)
          tau2=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$tau2)

          period=NULL
          period=gamma+mu
          period[JJ+1]=beta
          X=matrix(0,JJ,JJ+1)
          X[,1:JJ]=diag(JJ)
          for(i in 1:II)
          {
            X[,JJ+1]=X_in[i,]
            gmu=X%*%as.matrix(period)
            mmu=(gmu*(1-gmu))^0.5
            for(m in 1:JJ)
            {
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))>gmu[m]) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))>gmu(m)')
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))<max(2*gmu[m]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))<max(0,2*gmu(m)-1)')
            }
            for(m in 1:(JJ-1))
              for(k in (m+1):JJ)
              {
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('((gmu(m)*gmu(k)+alpha1*(1/mmu(m,m))*(1/mmu(k,k))))>min(gmu(m),gmu(k))')
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha1*(1/mmu(m,m))*(1/mmu(k,k))))<max(0,gmu(m)+gmu(k)-1)')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha2*(1/mmu(m,m))*(1/mmu(k,k))))>min(gmu(m),gmu(k))')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha2*(1/mmu(m,m))*(1/mmu(k,k))))<max(0,gmu(m)+gmu(k)-1)')
              }
          }



          temp1=c(p01+p0totalchange,p11+p0totalchange,p01,p11)
          if(min(temp1)<0) stop("Violate theory of probability under identity link: min(mu+gammaJ,mu+beta+gammaJ,mu,mu+beta)<0. Please check whether any of these four values are out of range.")

          temp1=c(p01+p0totalchange,p11+p0totalchange,p01,p11)
          if(max(temp1)>1) stop('Violate theory of probability under identity link: max(mu+gammaJ,mu+beta+gammaJ,mu,mu+beta)>1. Please check whether any of these four values are out of range.')

          a = 100
          b = -100
          for(j in 1:JJ)
          {
            temp = mu+gamma[j]
            if (temp < a){
              a = temp
              mincomp=rep(0,JJ+2)
              mincomp[JJ+1] = 1
              mincomp[j] = 1
            }

            if (temp > b){
              b = temp
              maxcomp=rep(0,JJ+2)
              maxcomp[JJ+1] = 1
              maxcomp[j] = 1
            }
            temp = mu+beta+gamma[j]
            if (temp < a){
              a = temp
              mincomp= rep(0,JJ+2)
              mincomp[JJ+1] = 1
              mincomp[JJ+2] = 1
              mincomp[j] = 1
            }

            if (temp > b){
              b = temp
              maxcomp= rep(0,JJ+2)
              maxcomp[JJ+1] = 1
              maxcomp[JJ+2] = 1
              maxcomp[j] = 1
            }
          }
          a = -a
          b = 1-b
          #call legendre_handle (GQ, a, b, GQX, GQW)
          ##dyn.load("legendre_rule.so")
          GQX=suppressWarnings(.Fortran("legendrehandle",GQ=as.integer(GQ), a=as.numeric(a), b=as.numeric(b), GQX=as.numeric(GQX), GQW=as.numeric(GQW) )$GQX)
          GQW=suppressWarnings(.Fortran("legendrehandle",GQ=as.integer(GQ), a=as.numeric(a), b=as.numeric(b), GQX=as.numeric(GQX), GQW=as.numeric(GQW) )$GQW)
          #Gaussian Legendre will not take two limits, a and b
          #power = LinearPower_time(mu, beta, gamma, tau2, II, JJ, KK, a, b, mincomp, maxcomp, GQ, GQX, GQW, X_in)
          #dyn.load("power_cal_wrapper.so")
          power=suppressWarnings(.Fortran("LinearPowertimewrapper",mu=mu, beta, gamma=gamma, tau2=tau2, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), a=as.numeric(a), b=as.numeric(b), mincomp=as.integer(mincomp), maxcomp=as.integer(maxcomp), GQ=as.integer(GQ), GQX=as.numeric(GQX), GQW=as.numeric(GQW), X_in=as.integer(X_in),typeone=as.numeric(typeone),power=power )$power)

        }
        else if(link<2 & link>0)
        {
          GQ=500
          GQX = rep(0,GQ)
          GQW = rep(0,GQ)
          gamma = rep(0,JJ)
          p01= exp(mu)
          p0[1] = p01
          p11 = exp(mu+beta)
          p11 = p11
          p0stepchange = p0totalchange/(JJ-1)
          for(j in 2:JJ)
          {
            gamma[j]= gamma[j-1] + p0stepchange
          }
          for(j in 2:JJ)
          {
            p0[j]= exp(gamma[j]+mu)
          }
          #  call computeparameter(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
          #dyn.load("computeparameterlog.so")
          mu=suppressWarnings(.Fortran("computeparameterlog",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$mu)
          beta=suppressWarnings(.Fortran("computeparameterlog",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$beta)
          gamma=suppressWarnings(.Fortran("computeparameterlog",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$gamma)
          tau2=suppressWarnings(.Fortran("computeparameterlog",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$tau2)

          period=NULL
          period=gamma+mu
          period[JJ+1]=beta
          X=matrix(0,JJ,JJ+1)
          X[,1:JJ]=diag(JJ)
          for(i in 1:II)
          {
            X[,JJ+1]=X_in[i,]
            gmu=X%*%as.matrix(period)
            gmu=exp(gmu)
            mmu=(gmu*(1-gmu))^0.5
            for(m in 1:JJ)
            {
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))>gmu[m]) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))>gmu(m)')
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))<max(2*gmu[m]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))<max(0,2*gmu(m)-1)')
            }
            for(m in 1:(JJ-1))
              for(k in (m+1):JJ)
              {
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha1*(1/mmu(m,m))*(1/mmu(k,k))))>min(gmu(m),gmu(k))')
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0))  stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha1*(1/mmu(m,m))*(1/mmu(k,k))))<max(0,gmu(m)+gmu(k)-1)')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha2*(1/mmu(m,m))*(1/mmu(k,k))))>min(gmu(m),gmu(k))')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha2*(1/mmu(m,m))*(1/mmu(k,k))))<max(0,gmu(m)+gmu(k)-1)')
              }
          }


          temp1=c(mu+p0totalchange,mu+beta+p0totalchange,mu,mu+beta)
          if(max(temp1)>0) stop('Violate theory of probability under log link: max(mu+gammaJ,mu+beta+gammaJ,mu,mu+beta)>0.Please check whether any of these four values are out of range.')




          a = 100
          b = -100
          for(j in 1:JJ)
          {
            temp = mu+gamma[j]
            if (temp < a){
              a = temp
              mincomp= rep(0,JJ+2)
              mincomp[JJ+1] = 1
              mincomp[j] = 1
            }

            if (temp > b){
              b = temp
              maxcomp= rep(0,JJ+2)
              maxcomp[JJ+1] = 1
              maxcomp[j] = 1
            }
            temp = mu+beta+gamma[j]
            if (temp < a){
              a = temp
              mincomp= rep(0,JJ+2)
              mincomp[JJ+1] = 1
              mincomp[JJ+2] = 1
              mincomp[j] = 1
            }

            if (temp > b){
              b = temp
              maxcomp= rep(0,JJ+2)
              maxcomp[JJ+1] = 1
              maxcomp[JJ+2] = 1
              maxcomp[j] = 1
            }
          }
          if (beta>0)
          {
            a= 5000
          }else
          { a= 5000 }

          b = b
          #call legendre_handle (GQ, b, a, GQX, GQW)
          #!call legendre_handle2 (GQ, b, a, GQX, GQW)
          #dyn.load("legendre_rule.so")
          GQX=suppressWarnings(.Fortran("legendrehandle",GQ=as.integer(GQ), a=b, b=a, GQX=as.numeric(GQX), GQW=as.numeric(GQW) )$GQX)
          GQW=suppressWarnings(.Fortran("legendrehandle",GQ=as.integer(GQ), a=b, b=a, GQX=as.numeric(GQX), GQW=as.numeric(GQW) )$GQW)

          #Gaussian Legendre will not take two limits, a and b
          #power = LogPower_time(mu, beta, gamma, tau2, II, JJ, KK, b, a, mincomp, maxcomp, GQ, GQX, GQW, X_in)
          #dyn.load("power_cal_wrapper.so")
          power=suppressWarnings(.Fortran("LogPowertimewrapper",mu=mu, beta=beta, gamma=gamma, tau2=tau2, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), a=b, b=a, mincomp=as.integer(mincomp), maxcomp= as.integer(maxcomp), GQ=as.integer(GQ),GQX=as.numeric(GQX), GQW=as.numeric(GQW), X_in=as.integer(X_in),typeone=as.numeric(typeone),power=power )$power)

        }else
        {
          GQ = 40
          GQX = rep(0,GQ)
          GQW = rep(0,GQ)
          #call HERZO(GQ,GQX,GQW)
          #dyn.load("herzo.so")
          GQW=suppressWarnings(.Fortran("HERZO",GQ=as.integer(GQ),GQX=as.numeric(GQX),GQW=as.numeric(GQX) )$GQW)
          GQX=suppressWarnings(.Fortran("HERZO",GQ=as.integer(GQ),GQX=as.numeric(GQX),GQW=as.numeric(GQX) )$GQX)
          p01=exp(mu)/(1+exp(mu))
          p11=exp(mu+beta)/(1+exp(mu+beta))
          p0[1] = p01
          p11 = p11
          p0stepchange = p0totalchange/(JJ-1)
          for(j in 2:JJ)
          {
            gamma[j]= gamma[j-1] + p0stepchange
          }
          for(j in 2:JJ)
          {
            p0[j]= exp(gamma[j]+mu)/(1+exp(mu+gamma[j]))
          }
          #initial values
          mual=mu
          betaal=beta
          gammaal=gamma
          tau2 = 1.0
          #gamma = 0.0
          #call computeparameterlogit(JJ, mu, beta, gamma, tau2, p0, p11, rho0, GQ, GQX, GQW, convergence)
          #dyn.load("computeparameterlogit.so")
          mu=suppressWarnings(.Fortran("computeparameterlogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0, GQ=as.integer(GQ), GQX=as.numeric(GQX), GQW=as.numeric(GQW), convergence=convergence)$mu)
          beta=suppressWarnings(.Fortran("computeparameterlogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0, GQ=as.integer(GQ), GQX=as.numeric(GQX), GQW=as.numeric(GQW), convergence=convergence)$beta)
          gamma=suppressWarnings(.Fortran("computeparameterlogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0, GQ=as.integer(GQ), GQX=as.numeric(GQX), GQW=as.numeric(GQW), convergence=convergence)$gamma)
          tau2=suppressWarnings(.Fortran("computeparameterlogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0, GQ=as.integer(GQ), GQX=as.numeric(GQX), GQW=as.numeric(GQW), convergence=convergence)$tau2)

          period=NULL
          period=gamma+mu
          period[JJ+1]=beta
          X=matrix(0,JJ,JJ+1)
          X[,1:JJ]=diag(JJ)
          for(i in 1:II)
          {
            X[,JJ+1]=X_in[i,]
            gmu=X%*%as.matrix(period)
            gmu=exp(gmu)/(1+exp(gmu))
            mmu=(gmu*(1-gmu))^0.5
            for(m in 1:JJ)
            {
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))>gmu[m]) stop('Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.')
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))<max(2*gmu[m]-1,0)) stop('Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.')
            }
            for(m in 1:(JJ-1))
              for(k in (m+1):JJ)
              {
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
              }
          }

          #mu=mual
          #beta=betaal
          #gamma=gammaal
          #power = LogitPower_time(mu, beta, gamma, tau2, II, JJ, KK, GQ, GQX, GQW,X_in)
          #dyn.load("power_cal_wrapper.so")
          power=suppressWarnings(.Fortran("LogitPowertimewrapper",mu=mu, beta=beta, gamma=gamma, tau2=tau2, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), GQ=as.integer(GQ), GQX=as.numeric(GQX), GQW=as.numeric(GQW), X_in=as.integer(X_in),typeone=as.numeric(typeone), power=power )$power)
          if(!is.na(effectsize_beta)) beta=effectsize_beta
        }
      }
      else
      {
        if(link<1)
        {

          GQ=100
          GQX = rep(0,GQ)
          GQW = rep(0,GQ)
          p01=mu
          p11=beta+mu
          p0[1] = p01
          p11 = p11
          p0stepchange = p0totalchange/(JJ-1)
          for(j in 2:JJ)
          {
            p0[j]= p0[j-1] + p0stepchange
          }
          #call computeparameter(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
          #dyn.load("computeparameter.so")
          mu=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$mu)
          beta=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$beta)
          tau2=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$tau2)

          period=NULL
          period[1]=mu
          period[2]=beta
          X=matrix(1,JJ,2)

          for(i in 1:II)
          {
            X[,2]=X_in[i,]
            gmu=X%*%as.matrix(period)
            mmu=(gmu*(1-gmu))^0.5
            for(m in 1:JJ)
            {
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))>gmu[m]) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))>gmu(m)')
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))<max(2*gmu[m]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))<max(0,2*gmu(m)-1)')
            }
            for(m in 1:(JJ-1))
              for(k in (m+1):JJ)
              {
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
              }
          }

          temp1=c(p01+p0totalchange,p11+p0totalchange,p01,p11)
          if(min(temp1)<0) stop("Violate theory of probability under identity link: min(mu+gammaJ,mu+beta+gammaJ,mu,mu+beta)<0.Please check whether any of these four values are out of range.")

          temp1=c(p01+p0totalchange,p11+p0totalchange,p01,p11)
          if(max(temp1)>1) stop('Violate theory of probability under identity link: max(mu+gammaJ,mu+beta+gammaJ,mu,mu+beta)>1.Please check whether any of these four values are out of range.')

          if (beta>0){
            a = - mu
            b = 1 - mu - beta
          }else
          {
            a = - mu - beta
            b = 1 - mu
          }
          #! a = a / dsqrt(2.0d0*tau2)
          #! b = b / dsqrt(2.0d0*tau2)
          #call legendre_handle (GQ, a, b, GQX, GQW)
          #! Gaussian Legendre will not take two limits, a and b
          #power = LinearPower_notime(mu, beta, tau2, II, JJ, KK, a, b, GQ, GQX, GQW, X_in)
          #dyn.load("legendre_rule.so")
          GQX=suppressWarnings(.Fortran("legendrehandle",GQ=as.integer(GQ), a=a, b=b, GQX=as.numeric(GQX), GQW=as.numeric(GQW) )$GQX)
          GQW=suppressWarnings(.Fortran("legendrehandle",GQ=as.integer(GQ), a=a, b=b, GQX=as.numeric(GQX), GQW=as.numeric(GQW) )$GQW)
          #dyn.load("power_cal_wrapper.so")
          power=suppressWarnings(.Fortran("LinearPowernotimewrapper",mu=mu, beta=beta,  tau2=tau2, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), a=a, b=b, GQ=as.integer(GQ), GQX=as.numeric(GQX), GQW=as.numeric(GQW), X_in=as.integer(X_in) ,typeone=as.numeric(typeone), power=power )$power)
        }
        else if(link<2 & link>0)
        {

          GQ=500
          GQX = rep(0,GQ)
          GQW = rep(0,GQ)
          p01= exp(mu)
          p0[1] = p01
          p11 = exp(mu+beta)
          p11 = p11
          p0stepchange = p0totalchange/(JJ-1)
          for(j in 2:JJ)
          {
            gamma[j]= gamma[j-1] + p0stepchange
          }
          for(j in 2:JJ)
          {
            p0[j] = exp(gamma[j]+mu)
          }

          temp1=c(mu+p0totalchange,mu+beta+p0totalchange,mu,mu+beta)
          if(max(temp1)>0) stop('Violate theory of probability under log link: max(mu+gammaJ,mu+beta+gammaJ,mu,mu+beta)>0.Please check whether any of these four values are out of range.')

          #call computeparameterlog(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
          #dyn.load("computeparameterlog.so")
          mu=suppressWarnings(.Fortran("computeparameterlog",JJ=as.integer(JJ),mu=mu,beta=beta,gamma=gamma,tau2=tau2,p0=p0,p11=p11, rho0=rho0 )$mu)
          beta=suppressWarnings(.Fortran("computeparameterlog",JJ=as.integer(JJ), mu=mu, beta=beta,gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$beta)
          tau2=suppressWarnings(.Fortran("computeparameterlog",JJ=as.integer(JJ), mu=mu, beta=beta,gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$tau2)

          period=NULL
          period[1]=mu
          period[2]=beta
          X=matrix(1,JJ,2)
          for(i in 1:II)
          {
            X[,2]=X_in[i,]
            gmu=X%*%as.matrix(period)
            gmu=exp(gmu)
            mmu=(gmu*(1-gmu))^0.5
            for(m in 1:JJ)
            {
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))>gmu[m]) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))>gmu(m)')
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))<max(2*gmu[m]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))<max(0,2*gmu(m)-1)')
            }
            for(m in 1:(JJ-1))
              for(k in (m+1):JJ)
              {
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0))  stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
              }
          }



          if (beta>0) {
            #!inf= 0
            #!a = 0.5d0/tau2
            a= 5000.0
            #!a=0.05
            b = - mu - beta

          }else{
            # !inf= 0
            #!a =0.5d0/tau2
            a= 5000.0
            #!a=0.05
            b =  - mu
          }
          #! a = a / dsqrt(2.0d0*tau2)
          #! b = b / dsqrt(2.0d0*tau2)
          b=-b
          # !b=0
          # call legendre_handle (GQ, b, a, GQX, GQW)
          # !  call legendre_handle2 (GQ, b, a, GQX, GQW)
          # ! Gaussian Legendre will not take two limits, a and b
          # power = LogPower_notime(mu, beta, tau2, II, JJ, KK, b, a, GQ, GQX, GQW, X_in)
          #dyn.load("legendre_rule.so")
          GQX=suppressWarnings(.Fortran("legendrehandle",GQ=as.integer(GQ), a=b, b=a, GQX=as.numeric(GQX), GQW=as.numeric(GQW) )$GQX)
          GQW=suppressWarnings(.Fortran("legendrehandle",GQ=as.integer(GQ), a=b, b=a, GQX=as.numeric(GQX), GQW=as.numeric(GQW) )$GQW)
          #Gaussian Legendre will not take two limits, a and b
          #dyn.load("power_cal_wrapper.so")
          power=suppressWarnings(.Fortran("LogPowernotimewrapper",mu=mu, beta=beta, tau2=tau2, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), a=b,b=a,GQ=as.integer(GQ),GQX=as.numeric(GQX), GQW=as.numeric(GQW), X_in=as.integer(X_in) ,typeone=as.numeric(typeone), power=power )$power)

        }
        else
        {
          GQ = 40
          GQX = rep(0,GQ)
          GQW = rep(0,GQ)
          #call HERZO(GQ,GQX,GQW)
          #dyn.load("herzo.so")
          GQX=suppressWarnings(.Fortran("HERZO",GQ=as.integer(GQ),GQX=as.numeric(GQX),GQW=as.numeric(GQW) )$GQX)
          GQW=suppressWarnings(.Fortran("HERZO",GQ=as.integer(GQ),GQX=as.numeric(GQX),GQW=as.numeric(GQW) )$GQW)
          p0totalchange=0
          p01=exp(mu)/(1+exp(mu))
          p11=exp(mu+beta)/(1+exp(mu+beta))
          p0[1] = p01
          p11 = p11
          p0stepchange = p0totalchange/(JJ-1)
          for(j in 2:JJ)
          {
            gamma[j]= gamma[j-1] + p0stepchange
          }
          for(j in 2:JJ)
          {
            p0[j]= exp(gamma[j]+mu)/(1+exp(mu+gamma[j]))
          }

          mual=mu
          betaal=beta
          gammaal=gamma
          tau2 = 1.0
          #gamma = 0.0
          #call computeparameterlogit(JJ, mu, beta, gamma, tau2, p0, p11, rho0, GQ, GQX, GQW, convergence)
          #power = LogitPower_notime(mu, beta, tau2, II, JJ, KK, GQ, GQX, GQW,X_in)
          #dyn.load("computeparameterlogit.so")
          mu=suppressWarnings(.Fortran("computeparameterlogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0,GQ=as.integer(GQ), GQX=as.numeric(GQX), GQW=as.numeric(GQW), convergence=convergence )$mu)
          beta=suppressWarnings(.Fortran("computeparameterlogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0,GQ=as.integer(GQ), GQX=as.numeric(GQX), GQW=as.numeric(GQW), convergence=convergence )$beta)
          tau2=suppressWarnings(.Fortran("computeparameterlogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0,GQ=as.integer(GQ), GQX=as.numeric(GQX), GQW=as.numeric(GQW), convergence=convergence )$tau2)

          period=NULL
          period[1]=mu
          period[2]=beta
          X=matrix(1,JJ,2)
          for(i in 1:II)
          {
            X[,2]=X_in[i,]
            gmu=X%*%as.matrix(period)
            gmu=exp(gmu)/(1+exp(gmu))
            mmu=(gmu*(1-gmu))^0.5
            for(m in 1:JJ)
            {
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))>gmu[m]) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))>gmu(m)')
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))<max(2*gmu[m]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))<max(0,2*gmu(m)-1)')
            }
            for(m in 1:(JJ-1))
              for(k in (m+1):JJ)
              {
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0))  stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
              }
          }

          #dyn.load("power_cal_wrapper.so")
          #mu=mual
          #beta=betaal
          #gamma=gammaal
          power=suppressWarnings(.Fortran("LogitPowernotimewrapper",mu=mu, beta=beta, tau2=tau2, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), GQ=as.integer(GQ), GQX=as.numeric(GQX), GQW=as.numeric(GQW), X_in=as.integer(X_in), typeone=as.numeric(typeone),power=power )$power)
          if(!is.na(effectsize_beta)) beta=effectsize_beta
        }
      }
    }
    else
    {
      alpha0= ICC0
      alpha1= rho0
      alpha2= ICC2
      lambda1 = 1- alpha0 + alpha1 - alpha2
      lambda2 = 1- alpha0 - (JJ-1)*(alpha1 - alpha2)
      lambda3 = 1 + (KK-1)*(alpha0 - alpha1) - alpha2
      lambda4 = 1 + (KK-1)*alpha0 + (JJ-1)*(KK-1)*alpha1 + (JJ-1)*alpha2
      temp2=c(lambda1,lambda2,lambda3,lambda4)
      if(min(temp2)<0) stop('Correlation matrix R is no longer positive definite. Please check whether the between-period correlation is unrealistically larger than the within-period correlation or the within-individual correlation.')

      #if(ICC1>ICC0)  stop('ICC1>ICC0')


      #if(ICC1>ICC2)  stop('ICC1>ICC2')

      if (p0totalchange > TOLERANCE | p0totalchange < -TOLERANCE)
      {
        if(link<1)
        {
          p01=mu
          p11=mu+beta
          p0[1] = p01
          p11 = p11
          p0stepchange = p0totalchange/(JJ-1)
          for(j in 2:JJ)
          {
            p0[j]= p0[j-1] + p0stepchange
          }

          temp1=c(p01+p0totalchange,p11+p0totalchange,p01,p11)
          if(min(temp1)<0) stop("Violate theory of probability under identity link: min(mu+gammaJ,mu+beta+gammaJ,mu,mu+beta)<0.Please check whether any of these four values are out of range.")

          temp1=c(p01+p0totalchange,p11+p0totalchange,p01,p11)
          if(max(temp1)>1) stop('Violate theory of probability under identity link: max(mu+gammaJ,mu+beta+gammaJ,mu,mu+beta)>1.Please check whether any of these four values are out of range.')

          #call computeparameter(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
          #dyn.load("computeparameter.so")
          mu=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$mu)
          beta=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$beta)
          gamma=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$gamma)
          rho0=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$rho0)
          #power=LinearPower_GEE(mu, beta, gamma, rho0, II, JJ, KK, X_in)
          #dyn.load("power_cal_wrapper.so")
          period=NULL
          period=gamma+mu
          period[JJ+1]=beta
          X=matrix(0,JJ,JJ+1)
          X[,1:JJ]=diag(JJ)
          for(i in 1:II)
          {
            X[,JJ+1]=X_in[i,]
            gmu=X%*%as.matrix(period)
            mmu=(gmu*(1-gmu))^0.5
            for(m in 1:JJ)
            {
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))>gmu[m]) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))>gmu(m)')
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))<max(2*gmu[m]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))<max(0,2*gmu(m)-1)')
            }
            for(m in 1:(JJ-1))
              for(k in (m+1):JJ)
              {
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('((gmu(m)*gmu(k)+alpha1*(1/mmu(m,m))*(1/mmu(k,k))))>min(gmu(m),gmu(k))')
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha1*(1/mmu(m,m))*(1/mmu(k,k))))<max(0,gmu(m)+gmu(k)-1)')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha2*(1/mmu(m,m))*(1/mmu(k,k))))>min(gmu(m),gmu(k))')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha2*(1/mmu(m,m))*(1/mmu(k,k))))<max(0,gmu(m)+gmu(k)-1)')
              }
          }



          power=suppressWarnings(.Fortran("LinearPowerGEEwrapper",mu=mu, beta=beta, gamma=gamma, rho0=rho0, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), X_in=as.integer(X_in),ICC0=ICC0,ICC2=ICC2,typeone=as.numeric(typeone),power=power )$power)

        }
        else if(link<2 & link>0)
        {
          p01=exp(mu)
          p11=exp(mu+beta)
          p0[1] = p01
          p11 = p11
          p0stepchange = p0totalchange/(JJ-1)
          for(j in 2:JJ)
          {
            gamma[j]= gamma[j-1] + p0stepchange
          }
          for(j in 2:JJ)
          {
            p0[j] = exp(gamma[j]+mu)
          }
          temp1=c(mu+p0totalchange,mu+beta+p0totalchange,mu,mu+beta)
          if(max(temp1)>0) stop('Violate theory of probability under log link: max(mu+gammaJ,mu+beta+gammaJ,mu,mu+beta)>0.Please check whether any of these four values are out of range.')

          #call computeparameterGEElog(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
          #dyn.load("computeparameterGEElog.so")
          mu=suppressWarnings(.Fortran("computeparameterGEElog",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$mu)
          beta=suppressWarnings(.Fortran("computeparameterGEElog",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$beta)
          gamma=suppressWarnings(.Fortran("computeparameterGEElog",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$gamma)
          rho0=suppressWarnings(.Fortran("computeparameterGEElog",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$rho0)
          #power=LogPower_GEE(mu, beta, gamma, rho0, II, JJ, KK, X_in)
          #dyn.load("power_cal_wrapper.so")
          period=NULL
          period=gamma+mu
          period[JJ+1]=beta
          X=matrix(0,JJ,JJ+1)
          X[,1:JJ]=diag(JJ)
          for(i in 1:II)
          {
            X[,JJ+1]=X_in[i,]
            gmu=X%*%as.matrix(period)
            gmu=exp(gmu)
            mmu=(gmu*(1-gmu))^0.5
            for(m in 1:JJ)
            {
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))>gmu[m]) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))>gmu(m)')
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))<max(2*gmu[m]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))<max(0,2*gmu(m)-1)')
            }
            for(m in 1:(JJ-1))
              for(k in (m+1):JJ)
              {
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha1*(1/mmu(m,m))*(1/mmu(k,k))))>min(gmu(m),gmu(k))')
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0))  stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha1*(1/mmu(m,m))*(1/mmu(k,k))))<max(0,gmu(m)+gmu(k)-1)')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha2*(1/mmu(m,m))*(1/mmu(k,k))))>min(gmu(m),gmu(k))')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu(m)*gmu(k)+alpha2*(1/mmu(m,m))*(1/mmu(k,k))))<max(0,gmu(m)+gmu(k)-1)')
              }
          }


          power=suppressWarnings(.Fortran("LogPowerGEEwrapper",mu=mu, beta=beta, gamma=gamma, rho0=rho0, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), X_in=as.integer(X_in),ICC0=ICC0,ICC2=ICC2,typeone=as.numeric(typeone),power=power )$power)
        }
        else
        {
          p01=exp(mu)/(1+exp(mu))
          p11=exp(mu+beta)/(1+exp(mu+beta))
          p0[1] = p01
          p11 = p11
          p0stepchange = p0totalchange/(JJ-1)
          for(j in 2:JJ)
          {
            gamma[j]= gamma[j-1] + p0stepchange
          }
          for(j in 2:JJ)
          {
            p0[j]= exp(gamma[j]+mu)/(1+exp(mu+gamma[j]))
          }
          #call computeparameterGEElogit(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
          #power=LogitPower_GEE(mu, beta, gamma, rho0, II, JJ, KK, X_in)
          #dyn.load("computeparameterGEElogit.so")
          mu=suppressWarnings(.Fortran("computeparameterGEElogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$mu)
          beta=suppressWarnings(.Fortran("computeparameterGEElogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$beta)
          gamma=suppressWarnings(.Fortran("computeparameterGEElogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$gamma)
          rho=suppressWarnings(.Fortran("computeparameterGEElogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$rho0)
          #dyn.load("power_cal_wrapper.so")
          period=NULL
          period=gamma+mu
          period[JJ+1]=beta
          X=matrix(0,JJ,JJ+1)
          X[,1:JJ]=diag(JJ)
          for(i in 1:II)
          {
            X[,JJ+1]=X_in[i,]
            gmu=X%*%as.matrix(period)
            gmu=exp(gmu)/(1+exp(gmu))
            mmu=(gmu*(1-gmu))^0.5
            for(m in 1:JJ)
            {
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))>gmu[m]) stop('Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.')
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))<max(2*gmu[m]-1,0)) stop('Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.')
            }
            for(m in 1:(JJ-1))
              for(k in (m+1):JJ)
              {
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
              }
          }

          power=suppressWarnings(.Fortran("LogitPowerGEEwrapper",mu=mu, beta=beta, gamma=gamma, rho0=rho0, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), X_in=as.integer(X_in),ICC0=ICC0,ICC2=ICC2,typeone=as.numeric(typeone),power= power )$power)
        }
      }
      else
      {
        if(link<1)
        {
          p01=mu
          p11=beta+mu
          p0[1] = p01
          p11 = p11
          p0stepchange = p0totalchange/(JJ-1)
          for(j in 2:JJ)
          {
            p0[j]= p0[j-1] + p0stepchange
          }
          temp1=c(p01+p0totalchange,p11+p0totalchange,p01,p11)
          if(min(temp1)<0) stop("Violate theory of probability under identity link: min(mu+gammaJ,mu+beta+gammaJ,mu,mu+beta)<0.Please check whether any of these four values are out of range.")

          temp1=c(p01+p0totalchange,p11+p0totalchange,p01,p11)
          if(max(temp1)>1) stop('Violate theory of probability under identity link: max(mu+gammaJ,mu+beta+gammaJ,mu,mu+beta)>1.Please check whether any of these four values are out of range.')

          #call computeparameter(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
          #power=LinearPower_GEE_notime(mu, beta, gamma, rho0, II, JJ, KK, X_in)
          #dyn.load("computeparameter.so")
          mu=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$mu)
          beta=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$beta)
          gamma=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$gamma)
          rho0=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$rho0)
          #power=LinearPower_GEE(mu, beta, gamma, rho0, II, JJ, KK, X_in)
          #dyn.load("power_cal_wrapper.so")
          period=NULL
          period[1]=mu
          period[2]=beta
          X=matrix(1,JJ,2)

          for(i in 1:II)
          {
            X[,2]=X_in[i,]
            gmu=X%*%as.matrix(period)
            mmu=(gmu*(1-gmu))^0.5
            for(m in 1:JJ)
            {
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))>gmu[m]) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))>gmu(m)')
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))<max(2*gmu[m]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))<max(0,2*gmu(m)-1)')
            }
            for(m in 1:(JJ-1))
              for(k in (m+1):JJ)
              {
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
              }
          }
          power=suppressWarnings(.Fortran("LinearPowerGEEnotimewrapper",mu=mu, beta=beta, gamma=gamma, rho0=rho0, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), X_in=as.integer(X_in),ICC0=ICC0,ICC2=ICC2,typeone=as.numeric(typeone), power=power )$power)
        }
        else if(link<2 & link>0)
        {
          p01=exp(mu)
          p11=exp(mu+beta)
          p0[1] = p01
          p11 = p11
          p0stepchange = p0totalchange/(JJ-1)
          for(j in 2:JJ)
          {
            gamma[j]= gamma[j-1] + p0stepchange
          }
          for(j in 2:JJ)
          {
            p0[j] = exp(gamma[j]+mu)
          }
          temp1=c(mu+p0totalchange,mu+beta+p0totalchange,mu,mu+beta)
          if(max(temp1)>0) stop('Violate theory of probability under log link: max(mu+gammaJ,mu+beta+gammaJ,mu,mu+beta)>0.Please check whether any of these four values are out of range.')

          #call computeparameterGEElog(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
          #power=LogPower_GEE_notime(mu, beta, gamma, rho0, II, JJ, KK, X_in)
          #dyn.load("computeparameterGEElog.so")
          mu=suppressWarnings(.Fortran("computeparameterGEElog",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$mu)
          beta=suppressWarnings(.Fortran("computeparameterGEElog",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$beta)
          gamma=suppressWarnings(.Fortran("computeparameterGEElog",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$gamma)
          rho0=suppressWarnings(.Fortran("computeparameterGEElog",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$rho0)
          #power=LogPower_GEE(mu, beta, gamma, rho0, II, JJ, KK, X_in)
          #dyn.load("power_cal_wrapper.so")
          period=NULL
          period[1]=mu
          period[2]=beta
          X=matrix(1,JJ,2)
          for(i in 1:II)
          {
            X[,2]=X_in[i,]
            gmu=X%*%as.matrix(period)
            gmu=exp(gmu)
            mmu=(gmu*(1-gmu))^0.5
            for(m in 1:JJ)
            {
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))>gmu[m]) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")# stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))>gmu(m)')
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))<max(2*gmu[m]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))<max(0,2*gmu(m)-1)')
            }
            for(m in 1:(JJ-1))
              for(k in (m+1):JJ)
              {
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0))  stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
              }
          }

          power=suppressWarnings(.Fortran("LogPowerGEEnotimewrapper",mu=mu, beta=beta, gamma=gamma, rho0=rho0, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), X_in=as.integer(X_in),ICC0=ICC0,ICC2=ICC2,typeone=as.numeric(typeone),power=power )$power)
        }
        else
        {
          p01=exp(mu)/(1+exp(mu))
          p11=exp(mu+beta)/(1+exp(mu+beta))
          p0[1] = p01
          p11 = p11
          p0stepchange = p0totalchange/(JJ-1)
          for(j in 2:JJ)
          {
            gamma[j]= gamma[j-1] + p0stepchange
          }
          for(j in 2:JJ)
          {
            p0[j]= exp(gamma[j]+mu)/(1+exp(mu+gamma[j]))
          }
          #call computeparameterGEElogit(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
          #power=LogitPower_GEE_notime(mu, beta, gamma, rho0, II, JJ, KK, X_in)
          #dyn.load("computeparameterGEElogit.so")
          mu=suppressWarnings(.Fortran("computeparameterGEElogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$mu)
          beta=suppressWarnings(.Fortran("computeparameterGEElogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$beta)
          gamma=suppressWarnings(.Fortran("computeparameterGEElogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$gamma)
          rho0=suppressWarnings(.Fortran("computeparameterGEElogit",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$rho0)
          #dyn.load("power_cal_wrapper.so")
          period=NULL
          period[1]=mu
          period[2]=beta
          X=matrix(1,JJ,2)
          for(i in 1:II)
          {
            X[,2]=X_in[i,]
            gmu=X%*%as.matrix(period)
            gmu=exp(gmu)/(1+exp(gmu))
            mmu=(gmu*(1-gmu))^0.5
            for(m in 1:JJ)
            {
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))>gmu[m]) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))>gmu(m)')
              if((gmu[m]*gmu[m]+alpha0*gmu[m]*(1-gmu[m]))<max(2*gmu[m]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('(gmu(m)*gmu(m)+alpha0*gmu(m)*(1-gmu(m)))<max(0,2*gmu(m)-1)')
            }
            for(m in 1:(JJ-1))
              for(k in (m+1):JJ)
              {
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0))  stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha1*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))>min(c(gmu[m],gmu[k]))')
                if(((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)) stop("Correlation parameters do not satisfy the restrictions of Qaqish (2003). Please  check whether it is possible to reduce the effect size, or make adjustments to  the intraclass correlations.")#stop('((gmu[m]*gmu[k]+alpha2*(mmu[m])*(mmu[k])))<max(gmu[m]+gmu[k]-1,0)')
              }
          }
          power=suppressWarnings(.Fortran("LogitPowerGEEnotimewrapper",mu=mu, beta=beta, gamma=gamma, rho0=rho0, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), X_in=as.integer(X_in),ICC0=ICC0,ICC2=ICC2,typeone=as.numeric(typeone),power=power )$power)
        }
      }
    }
  }
  else{
    alpha0= ICC0
    alpha1= rho0
    alpha2= ICC2
    lambda1 = 1- alpha0 + alpha1 - alpha2
    lambda2 = 1- alpha0 - (JJ-1)*(alpha1 - alpha2)
    lambda3 = 1 + (KK-1)*(alpha0 - alpha1) - alpha2
    lambda4 = 1 + (KK-1)*alpha0 + (JJ-1)*(KK-1)*alpha1 + (JJ-1)*alpha2
    temp2=c(lambda1,lambda2,lambda3,lambda4)
    if(min(temp2)<0) stop('Correlation matrix R is no longer positive definite. Please check whether the between-period correlation is unrealistically larger than the within-period correlation or the within-individual correlation.')
    # if(ICC1>ICC0)  stop('ICC1>ICC0')


    #if(ICC1>ICC2)  stop('ICC1>ICC2')
    if (p0totalchange > TOLERANCE | p0totalchange < -TOLERANCE)
    {   p01=mu
    p11=mu+beta
    p0[1] = p01
    p11 = p11
    p0stepchange = p0totalchange/(JJ-1)
    for(j in 2:JJ)
    {
      p0[j]= p0[j-1] + p0stepchange
    }
    #  call computeparameter(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
    #dyn.load("computeparameter.so")
    mu=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$mu)
    beta=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$beta)
    gamma=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$gamma)
    tau2=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$tau2)
    power=suppressWarnings(.Fortran("ContinuousPowerGEEtimewrapper",mu=mu, beta=beta, gamma=gamma,rho0=rho0, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), X_in=as.integer(X_in),sigma2=sigma2,ICC0=ICC0,ICC2=ICC2,typeone=as.numeric(typeone),power=power )$power)
    }
    else
    { p01=mu
    p11=mu+beta
    p0[1] = p01
    p11 = p11
    p0stepchange = p0totalchange/(JJ-1)
    for(j in 2:JJ)
    {
      p0[j]= p0[j-1] + p0stepchange
    }
    #  call computeparameter(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
    #dyn.load("computeparameter.so")
    mu=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$mu)
    beta=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$beta)
    gamma=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$gamma)
    tau2=suppressWarnings(.Fortran("computeparameter",JJ=as.integer(JJ), mu=mu, beta=beta, gamma=gamma, tau2=tau2, p0=p0, p11=p11, rho0=rho0 )$tau2)
    power=suppressWarnings(.Fortran("ContinuousPowerGEEnotimewrapper",mu=mu, beta=beta, gamma=gamma,rho0=rho0, II=as.integer(II), JJ=as.integer(JJ), KK=as.integer(KK), X_in=as.integer(X_in),sigma2=sigma2,ICC0=ICC0,ICC2=ICC2,typeone=as.numeric(typeone),power=power )$power)
    }
  }
  #summary

  if(type=="cohort") SS=II*KK
  else SS=II*KK*JJ

  if(response<1.5) {
   #summary=matrix(data=c(I,J,K,SS,type,family,md,lf,round(beta,3),round(gamma[J],3),sigma2,ICC0,ICC1,ICC2,alpha,round(power,3)),ncol=1)
   #rownames(summary)=c("I","J","K","total sample size","study type","family of outcomes","model","link","treatment effect beta","time effect gamma_J","marginal variance","alpha0","alpha1","alpha2","two-sided Type I error","Power")
    #design_matrix=dataset
    list_data =list(design_matrix=dataset,I=I,J=J,K=K,total.sample.size=SS,study.type=type,family.of.outcomes=family,model=md,link=lf,treatment.effect.beta=round(beta,3),time.effect.gamma.J=round(gamma[J],3),marginal.variance=sigma2,alpha0=ICC0,alpha1=ICC1,alpha2=ICC2,Type.I.error=alpha,Power=round(power,3))
    #names(list_data)=c("design matrix dataset, row-cluster col-time","Summary")
    class(list_data)="swdpower"
    return(list_data)
  }

  if(response>1.5) {
    #summary=matrix(data=c(I,J,K,SS,type,family,md,lf,round(mu,3),round(beta,3),round(gamma[J],3),ICC0,ICC1,ICC2,alpha,round(power,3)),ncol=1)
    #rownames(summary)=c("I","J","K","total sample size","study type","family of outcomes","model","link","baseline mu","treatment effect beta","time effect gamma_J","alpha0","alpha1","alpha2","two-sided Type I error","Power")
    #design_matrix=dataset
    list_data =list(design_matrix=dataset,I=I,J=J,K=K,total.sample.size=SS,study.type=type,family.of.outcomes=family,model=md,link=lf,baseline.mu=round(mu,3),treatment.effect.beta=round(beta,3),time.effect.gamma.J=round(gamma[J],3),alpha0=ICC0,alpha1=ICC1,alpha2=ICC2,Type.I.error=alpha,Power=round(power,3))
    #list_data =list(design_matrix,summary)
   #?/names(list_data)=c("design matrix dataset, row-cluster col-time","Summary")
    class(list_data)="swdpower"
    return(list_data)
  }

}

SUBROUTINE LinearPowertimewrapper(mu, beta, gamma, tau2, II, JJ, KK, a, b, mincomp, maxcomp, GQ, GQX, GQW, X_in,typeone,power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: mu, beta, tau2,typeone
  ! true values of mu, beta, and tau2
  double precision :: gamma(JJ)
  double precision :: a, b        ! lower and upper limits of GL integral
  integer :: mincomp(JJ+2), maxcomp(JJ+2)
  integer :: GQ   ! number of GQ points
  double precision :: GQX(GQ), GQW(GQ)
  double precision :: power

double precision, external :: LinearPower_time

power = LinearPower_time(mu, beta, gamma, tau2, II, JJ, KK, a, b, mincomp, maxcomp, GQ, GQX, GQW, X_in,typeone)

END SUBROUTINE

SUBROUTINE LogPowertimewrapper(mu, beta, gamma, tau2, II, JJ, KK, a, b, mincomp, maxcomp, GQ, GQX, GQW, X_in,typeone, power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: typeone,mu, beta, tau2
  ! true values of mu, beta, and tau2
  double precision :: gamma(JJ)
  double precision :: a, b        ! lower and upper limits of GL integral
  integer :: mincomp(JJ+2), maxcomp(JJ+2)
  integer :: GQ   ! number of GQ points
  double precision :: GQX(GQ), GQW(GQ)
  double precision :: power

double precision, external :: LogPower_time

power = LogPower_time(mu, beta, gamma, tau2, II, JJ, KK, a, b, mincomp, maxcomp, GQ, GQX, GQW, X_in,typeone)

END SUBROUTINE

SUBROUTINE LogitPowertimewrapper(mu, beta, gamma, tau2, II, JJ, KK, GQ, GQX, GQW, X_in,typeone, power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: typeone,mu, beta, tau2
  ! true values of mu, beta, and tau2
  double precision :: gamma(JJ)
  !double precision :: a, b        ! lower and upper limits of GL integral
  !integer :: mincomp(JJ+2), maxcomp(JJ+2)
  integer :: GQ   ! number of GQ points
  double precision :: GQX(GQ), GQW(GQ)
  double precision :: power

double precision, external :: LogitPower_time

power = LogitPower_time(mu, beta, gamma, tau2, II, JJ, KK, GQ, GQX, GQW, X_in,typeone)
END SUBROUTINE

SUBROUTINE LinearPowernotimewrapper(mu, beta, tau2, II, JJ, KK, a, b, GQ, GQX, GQW, X_in,typeone, power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: typeone,mu, beta, tau2
  ! true values of mu, beta, and tau2
  !double precision :: gamma(JJ)
  double precision :: a, b        ! lower and upper limits of GL integral
  !integer :: mincomp(JJ+2), maxcomp(JJ+2)
  integer :: GQ   ! number of GQ points
  double precision :: GQX(GQ), GQW(GQ)
  double precision :: power

double precision, external :: LinearPower_notime

power = LinearPower_notime(mu, beta,tau2, II, JJ, KK, a, b, GQ, GQX, GQW, X_in,typeone)

END SUBROUTINE

SUBROUTINE LogPowernotimewrapper(mu, beta, tau2, II, JJ, KK, a, b, GQ, GQX, GQW, X_in,typeone, power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: typeone,mu, beta, tau2
  ! true values of mu, beta, and tau2
  !double precision :: gamma(JJ)
  double precision :: a, b        ! lower and upper limits of GL integral
  !integer :: mincomp(JJ+2), maxcomp(JJ+2)
  integer :: GQ   ! number of GQ points
  double precision :: GQX(GQ), GQW(GQ)
  double precision :: power

double precision, external :: LogPower_notime

power = LogPower_notime(mu, beta, tau2, II, JJ, KK, a, b, GQ, GQX, GQW, X_in,typeone)

END SUBROUTINE

SUBROUTINE LogitPowernotimewrapper(mu, beta, tau2, II, JJ, KK, GQ, GQX, GQW, X_in,typeone, power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: typeone,mu, beta, tau2
  ! true values of mu, beta, and tau2
  !double precision :: gamma(JJ)
  !double precision :: a, b        ! lower and upper limits of GL integral
!  integer :: mincomp(JJ+2), maxcomp(JJ+2)
  integer :: GQ   ! number of GQ points
  double precision :: GQX(GQ), GQW(GQ)
  double precision :: power

double precision, external :: LogitPower_notime

power = LogitPower_notime(mu, beta,tau2, II, JJ, KK, GQ, GQX, GQW, X_in,typeone)
END SUBROUTINE

SUBROUTINE LinearPowerGEEwrapper(mu, beta, gamma,rho0, II, JJ, KK, &
                     X_in,ICC0,ICC2,typeone,power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: typeone,mu, beta, rho0,ICC0,ICC2
  ! true values of mu, beta, and tau2
  double precision :: gamma(JJ)
  !double precision :: a, b        ! lower and upper limits of GL integral
  !integer :: mincomp(JJ+2), maxcomp(JJ+2)
  double precision :: power

double precision, external ::  LinearPower_GEE

power = LinearPower_GEE(mu, beta, gamma,rho0, II, JJ, KK, X_in,ICC0,ICC2,typeone)
END SUBROUTINE

SUBROUTINE LogPowerGEEwrapper(mu, beta, gamma,rho0, II, JJ, KK, &
                     X_in,ICC0,ICC2,typeone,power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: typeone,mu, beta, rho0,ICC0,ICC2
  ! true values of mu, beta, and tau2
  double precision :: gamma(JJ)
  !double precision :: a, b        ! lower and upper limits of GL integral
  !integer :: mincomp(JJ+2), maxcomp(JJ+2)
  double precision :: power

double precision, external ::  LogPower_GEE

power = LogPower_GEE(mu, beta, gamma,rho0, II, JJ, KK, X_in,ICC0,ICC2,typeone)
END SUBROUTINE

SUBROUTINE LogitPowerGEEwrapper(mu, beta, gamma,rho0, II, JJ, KK, &
                     X_in,ICC0,ICC2,typeone,power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: typeone,mu, beta, rho0,ICC0,ICC2
  ! true values of mu, beta, and tau2
  double precision :: gamma(JJ)
  !double precision :: a, b        ! lower and upper limits of GL integral
  !integer :: mincomp(JJ+2), maxcomp(JJ+2)
  double precision :: power

double precision, external ::  LogitPower_GEE

power = LogitPower_GEE(mu, beta, gamma,rho0, II, JJ, KK, X_in,ICC0,ICC2,typeone)
END SUBROUTINE

SUBROUTINE LinearPowerGEEnotimewrapper(mu, beta, gamma,rho0, II, JJ, KK, &
                     X_in,ICC0,ICC2,typeone,power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: typeone,mu, beta, rho0,ICC0,ICC2
  ! true values of mu, beta, and tau2
  double precision :: gamma(JJ)
  !double precision :: a, b        ! lower and upper limits of GL integral
  !integer :: mincomp(JJ+2), maxcomp(JJ+2)
  double precision :: power

double precision, external ::  LinearPower_GEE_notime

power = LinearPower_GEE_notime(mu, beta, gamma,rho0, II, JJ, KK, X_in,ICC0,ICC2,typeone)
END SUBROUTINE

SUBROUTINE LogPowerGEEnotimewrapper(mu, beta, gamma,rho0, II, JJ, KK, &
                     X_in,ICC0,ICC2,typeone,power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: typeone,mu, beta, rho0,ICC0,ICC2
  ! true values of mu, beta, and tau2
  double precision :: gamma(JJ)
  !double precision :: a, b        ! lower and upper limits of GL integral
  !integer :: mincomp(JJ+2), maxcomp(JJ+2)
  double precision :: power

double precision, external ::  LogPower_GEE_notime

power = LogPower_GEE_notime(mu, beta, gamma,rho0, II, JJ, KK, X_in,ICC0,ICC2,typeone)
END SUBROUTINE

SUBROUTINE LogitPowerGEEnotimewrapper(mu, beta, gamma,rho0, II, JJ, KK, &
                     X_in,ICC0,ICC2,typeone,power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: typeone,mu, beta, rho0,ICC0,ICC2
  ! true values of mu, beta, and tau2
  double precision :: gamma(JJ)
  !double precision :: a, b        ! lower and upper limits of GL integral
!  integer :: mincomp(JJ+2), maxcomp(JJ+2)
  double precision :: power

double precision, external ::  LogitPower_GEE_notime

power = LogitPower_GEE_notime(mu, beta, gamma,rho0, II, JJ, KK, X_in,ICC0,ICC2,typeone)

END SUBROUTINE

SUBROUTINE ContinuousPowerGEEnotimewrapper(mu, beta, gamma,rho0, II, JJ, KK, &
                     X_in,sigma2,ICC0,ICC2,typeone,power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision ::typeone, mu, beta, sigma2,ICC0,ICC2,rho0
  ! true values of mu, beta, and tau2
  double precision :: gamma(JJ)
  !double precision :: a, b        ! lower and upper limits of GL integral
  !integer :: mincomp(JJ+2), maxcomp(JJ+2)
  double precision :: power

double precision, external ::  GEElinear_continous_notime

power = GEElinear_continous_notime(mu, beta, gamma,rho0, II, JJ, KK, &
                     X_in,sigma2,ICC0,ICC2,typeone)

END SUBROUTINE

SUBROUTINE ContinuousPowerGEEtimewrapper(mu, beta, gamma,rho0, II, JJ, KK, &
                     X_in,sigma2,ICC0,ICC2,typeone,power)

  integer :: II, JJ, KK
  integer :: X_in(II,JJ)
  ! II : number of clusters
  ! JJ : number of steps
  ! KK : number of subjects per cluster per step
  double precision :: typeone,mu, beta, sigma2,ICC0,ICC2,rho0
  ! true values of mu, beta, and tau2
  double precision :: gamma(JJ)
  !double precision :: a, b        ! lower and upper limits of GL integral
  !integer :: mincomp(JJ+2), maxcomp(JJ+2)
  double precision :: power

double precision, external :: GEElinear_continous_time

power = GEElinear_continous_time(mu, beta, gamma,rho0, II, JJ, KK, &
                     X_in,sigma2,ICC0,ICC2,typeone)
END SUBROUTINE

#' A function for calculating ICCs for continuous outcomes given random effects variances
#'
#' @description This function calculates the within-period, between-period, and within-individual correlation parameters for continuous outcomes in a stepped wedge CRT
#'
#' @param type choose the study type, specify type="cohort" for closed cohort study and type="cross-sectional" for cross-sectional study, default is "cross-sectional"
#' @param sigma2 marginal variance of the outcom, default is 1
#' @param sigma_b variance of the between-cluster random effect, default is 0
#' @param sigma_c variance of the cluster-by-time interaction random effect, default is 0
#' @param sigma_pi variance of the random effect for repeated measures of one individual, this parameter should not be specified for cross-sectional studies, default is NA
#' @return The object returned includes the study type and values for the ICCs in this study
#' @examples
#' ContICC(type="cohort",sigma2=1.5,sigma_b=0.5,sigma_c=0.2,sigma_pi=0.3)
#' @export
#'
#'
ContICC<-function(type="cross-sectional", sigma2=1, sigma_b=0, sigma_c=0, sigma_pi=NA){
  if(type!="cohort"&&type!="cross-sectional") stop("Wrong input for study type.")
  if(type=="cross-sectional"&&is.na(sigma_pi)!=1) stop("sigma_pi should not be specified for a cross-sectional study.")
  if(type=="cross-sectional") sigma_pi=0
  if(sum(sigma_b+sigma_c+sigma_pi)>sigma2) stop("The marginal variance should be larger than the sum of its components.")
  alpha0= (sigma_b+sigma_c)/sigma2
  alpha1= (sigma_b)/sigma2
  alpha2= (sigma_b+sigma_pi)/sigma2
  if(type=="cohort") {list_data=list(study_type=type,alpha0=alpha0,alpha1=alpha1,alpha2=alpha2)
  return(list_data)}
  if(type=="cross-sectional") {list_data=list(study_type=type,alpha0=alpha0,alpha1=alpha1)
  return(list_data)}
  }

#' Print the results of swdpower
#'
#' The \code{\link{print}} method for class "swdpower"
#'
#' @param x an object used to select a method.
#' @param ... further arguments passed to or from other methods.
#'
#' @return The output from \code{\link{print}}
#' @export
#'
#'
print.swdpower<-function(x,...){
study<-paste(x$study.type,collapse = ', ')
sampesize<-paste(x$total.sample.size)
cat('This',study, "study has total sample size of", sampesize, "\n")
power<-paste(x$Power,collapse = ', ')
beta<-paste(x$treatment.effect.beta,collapse = ',')
error<-paste(x$Type.I.error,collapse = ',')
cat('Power for this scenario is',power, "for the alternative hypothesis treatment effect beta =",beta, "(two-sided Type I error = ",error, ") \n")
}

#' A function for calculating the intracluster correlation coefficient (ICC) for binary outcomes given the cluster level random effects variance
#'
#' @description This function calculates the ICC (intracluster correlation coeffcient which measures the correlation between individuals in the same cluster) under different link funcitions in a cross-sectional stepped wedge CRT with binary outcomes. This model considers only the fixed time effects and does not include cluster by time interaction random effect.
#'
#' @param link choose link function from link="identity", link="log" and link="logit", with default value of identity link
#' @param meanresponse_start the anticipated mean response in the control group at the start of the study
#' @param tau2 also denoted as sigma_b: variance of the between-cluster random effect, default is 0
#' @return The object returned includes the link function and value for the ICC in this study
#' @examples
#' BinICC(link="identity",meanresponse_start=0.2,tau2=0.05)
#'
#' @import spatstat.random
#'
#' @export
#'
BinICC<-function(link="identity", meanresponse_start, tau2=0){
  if(meanresponse_start>1| meanresponse_start<0) stop("meanresponse_start for binary outcomes should be between 0 and 1")
  if(link!="identity"&&link!="log"&&link!="logit") stop("Wrong input for link function names.")
  if(link=="identity") mu = meanresponse_start
  if(link=="log") mu = log(meanresponse_start)
  if(link=="logit") mu = log(1/(1-meanresponse_start)-1)

  if(link=="identity") ICC=tau2/(mu*(1-mu))
  if(link=="log") ICC=(exp(2*mu+2*tau2)-exp(2*mu+tau2))/(exp(mu+tau2/2)-exp(2*mu+tau2))
  if(link=="logit")
    {temp = gauss.hermite(function(x) (exp(mu+x)/(1+exp(mu+x)))^2, 0, tau2)
   ICC=(temp- meanresponse_start^2)/(temp- meanresponse_start^2+meanresponse_start-temp)
  }
  if(ICC>1|ICC<0) stop("ICC should be between 0 and 1, please modify tau2 or meanresponse_start.")
  list_data=list(study_type="cross-sectional",link_function=link ,ICC=ICC)
  return(list_data)
}

subroutine computeparameterlog(JJ, mu, beta, gamma, tau2, p0, p11, rho0)
    implicit none
    ! ---- arg types -----------------------
    integer :: JJ
    double precision :: mu, beta, tau2
    double precision :: gamma(JJ)
    double precision :: p11, rho0
    double precision :: p0(JJ)
    !double precision, parameter:: TwoPi = 8.D0*atan(1.D0)
    ! ---------------------------------------
    ! ---------------------------------------
    integer :: j

    beta=log(p11/p0(1))
    gamma(1)=0
    do j=2,JJ
        gamma(j)=log(p0(j)/p0(1))
    end do

    tau2=log(rho0*(1-p0(1))/p0(1)+1)
    mu=log(p0(1))-tau2/2

end subroutine computeparameterlog

function LinearPower_time(mu, beta, gamma, tau2, II, JJ, KK, a, b, &
                    mincomp, maxcomp, GQ, GQX, GQW, X_in,typeone) result (power)
    implicit none
    ! ---- arg types -----------------------
    integer :: II, JJ, KK,ifault
    integer :: X_in(II,JJ)
    ! II : number of clusters
    ! JJ : number of steps
    ! KK : number of subjects per cluster per step
    double precision :: mu, beta, tau2,typeone,ppp
    ! true values of mu, beta, and tau2
    double precision :: gamma(JJ)
    double precision :: a, b        ! lower and upper limits of GL integral
    integer :: mincomp(JJ+2), maxcomp(JJ+2)
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    double precision :: power
    ! ----------------------------------------

    double precision, parameter :: PI = 3.14159265358979323846   ! pi
    integer :: X(II,JJ)  ! intervention matrix
    !integer :: DD      ! II/(JJ-1). By design, II is a multiple of (JJ-1)
    integer :: i, j
    logical :: upper



    double precision, external :: alnorm
    double precision, external :: ppnd16
    integer, external :: updatez

    integer :: z0(JJ), z1(JJ)   ! z0: # of subjects with outcome 0; z1: # of subjects with outcome 1.
    ! integer :: nZ               ! total number of possible combination of z0 and z1
    integer :: finish
    double precision :: derlikelihood(JJ+2)   ! derivative of likelihood
    double precision :: derlikelihood2(JJ+2, JJ+2)  ! square of derivative of likelihood
    double precision :: invVar(JJ+2,JJ+2),invVarPre(JJ+2,JJ+2)       ! inverse of variance matrix
    double precision :: Var(JJ+2,JJ+2)         ! variance matrix
    double precision :: prob
    double precision :: sebeta  ! se of beta

    ifault = 0
    upper = .false.

    !allocate(X_in(II,JJ))

    !DD=II/GG
    !DD = II/(JJ-1)   ! II is a multiple of (JJ-1)
    ! assign intervention
    X = 0
    do i=1,II
      do j = 1,JJ
        X(i,j) =  X_in(i,j)
      enddo
    enddo

    ! compute the possible combinations of (z0,z1)
    ! nZ = 1
    ! do j=1,JJ
    !     nZ = nZ * (KK+1)
    ! end do
    ! run the algorithm
    invVar = 0.0d0
    do i=1,II
      if(i>1 .and. ALL(X(i,:).EQ. X(i-1,:))) then
      invVar = invVar + invVarPre
      !finish = updatez(z0, JJ, KK)
      else
        ! per cluster
        z0 = 0
        finish = 0
        invVarPre=0
        do while (finish<1)
            z1 = KK - z0
            ! prob = prob_z(mu,beta,gamma, tau2, z0, z1, X(i,:), JJ, KK, GQ, GQX, GQW)
            call der_likelihood_time(mu,beta,gamma,tau2, z0, z1, X(i,:), JJ, KK, a, b, &
                                mincomp, maxcomp, GQ, GQX, GQW, derlikelihood, prob)
            call vectorsquare(derlikelihood, JJ+2, derlikelihood2)
            invVar = invVar + derlikelihood2 * prob
            invVarPre = invVarPre+derlikelihood2 * prob
            finish = updatez(z0, JJ, KK)
        end do
        end if
    end do
    call syminverse(invVar,Var,JJ+2)
    sebeta = sqrt(Var(2,2))

  !  if(beta<0) then
    !power =alnorm(-beta/sebeta-1.959964d0,upper)
  !else
  !  power =alnorm(beta/sebeta-1.959964d0,upper)
!  end if
ppp=ppnd16(typeone/2,ifault)
power = alnorm(beta/sebeta+ppp,upper) + alnorm(-beta/sebeta+ppp,upper)
end function LinearPower_time

function updatez(z0, JJ, KK) result (finish)
    implicit none
    ! ---- arg types -----------------------
    integer :: JJ, KK
    integer :: z0(JJ)
    integer :: finish
    ! --------------------------------------
    integer :: j
    finish = 0
    z0(1) = z0(1) + 1
    do j=1,JJ-1
        if (z0(j)>KK) then
            z0(j) = 0
            z0(j+1) = z0(j+1) + 1
        else
            exit
        end if
    end do
    if (z0(JJ)>KK) finish = 1
end function updatez

subroutine der_likelihood_time(mu,beta,gamma,tau2, z0, z1, XX, JJ, KK, a, b, &
                        mincomp, maxcomp, GQ, GQX, GQW, derlikelihood, prob)
    implicit none
    ! ---- arg types -----------------------
    integer :: JJ, KK
    double precision :: mu, beta, tau2
    double precision :: gamma(JJ)
    ! true values of mu, beta, gamma, tau2
    integer :: z0(JJ), z1(JJ)   ! z0: # of subjects with outcome 0; z1: # of subjects with outcome 1.
    integer :: XX(JJ)     ! treatment assignment
    double precision :: a, b     ! integration limits: a - lower, b - upper
    integer :: mincomp(JJ+2), maxcomp(JJ+2)  ! gamma(1), ..., gamma(JJ), mu, beta
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    double precision :: derlikelihood(JJ+2)
    double precision :: prob
    ! --------------------------------------
    double precision, parameter :: PI = 3.14159265358979323846   ! pi

    double precision :: likelihoodf_denom, likelihoodf_numer, likelihoodf_denomb2
    double precision :: x
    integer :: i, j, k
    double precision :: ff0, ff1, ff01
    double precision :: ff, ffprob
    double precision :: ff_mu, ff_beta
    double precision :: derlikelihood_mu, derlikelihood_beta, derlikelihood_tau2
    double precision :: ff_gamma(JJ-1)
    double precision :: derlikelihood_gamma(JJ-1)
    double precision :: temp
    double precision :: eaa, ebb, exx
    double precision :: faeaa, fbebb

    likelihoodf_denom = 0.0d0
    likelihoodf_numer = 0.0d0
    likelihoodf_denomb2 = 0.0d0
    derlikelihood_mu = 0.0d0
    derlikelihood_beta = 0.0d0
    derlikelihood_tau2 = 0.0d0
    derlikelihood_gamma = 0.0d0

    prob = 0.0d0
    do i=1,GQ
        x = GQX(i)
        exx = dexp(-0.5d0*x*x/tau2)

        ff = 1.0d0
        ffprob = 1.0d0
        ff_mu = 0.0d0
        ff_beta = 0.0d0
        do j=1,JJ
            ff1 = mu+beta*XX(j)+gamma(j)+x
            ff0 = 1-ff1
            ff = ff*(ff0**z0(j))*(ff1**z1(j))

            ! since GQX are not at limits, we ignore the cases where ff0=0 or ff1=0
            temp = z1(j)/ff1 - z0(j)/ff0
            ff_mu = ff_mu + temp
            ff_beta = ff_beta + temp*XX(j)
            k = j-1
            if (k>0) then
                ff_gamma(k) = temp
            end if

            ff01 = ff0*ff1
            ! compute binomial
            ! compute combination number with power of ff0 and ff1
            ! to avoid overflow
            if (z0(j)<z1(j)) then
                ffprob = ffprob*ff1**(z1(j)-z0(j))
                do k=0,(z0(j)-1)
                    ffprob = ffprob*dble(KK-k)/dble(z0(j)-k)*ff01
                end do
            else
                ffprob = ffprob*ff0**(z0(j)-z1(j))
                do k=0,(z1(j)-1)
                    ffprob = ffprob*dble(KK-k)/dble(z1(j)-k)*ff01
                end do
            end if
        end do
        prob = prob + GQW(i)*ffprob*exx
        likelihoodf_denom = likelihoodf_denom + GQW(i)*exx
        likelihoodf_numer = likelihoodf_numer + GQW(i)*ff*exx
        likelihoodf_denomb2 = likelihoodf_denomb2 + GQW(i)*x*x*exx

        derlikelihood_mu = derlikelihood_mu + GQW(i)*ff*ff_mu*exx
        derlikelihood_beta = derlikelihood_beta + GQW(i)*ff*ff_beta*exx
        derlikelihood_gamma = derlikelihood_gamma + GQW(i)*ff*ff_gamma*exx
        derlikelihood_tau2= derlikelihood_tau2 + GQW(i)*ff*x*x*exx
    enddo

    ! calculate f(a)exp(-0.5*a*a)
    eaa = dexp(-0.5d0*a*a/tau2)
    ff = 1.0d0
    do j=1,JJ
        ff1 = mu+beta*XX(j)+gamma(j)+a
        ff0 = 1-ff1
        ff = ff*(ff0**z0(j))*(ff1**z1(j))
    end do
    faeaa = ff*eaa
    ! calculate f(b)exp(-0.5*b*b)
    ebb = dexp(-0.5d0*b*b/tau2)
    ff = 1.0d0
    do j=1,JJ
        ff1 = mu+beta*XX(j)+gamma(j)+b
        ff0 = 1-ff1
        ff = ff*(ff0**z0(j))*(ff1**z1(j))
    end do
    fbebb = ff*ebb

    ! calculate derlikelihood_mu
    derlikelihood_mu = derlikelihood_mu + faeaa*dble(mincomp(JJ+1)) &
                        - fbebb*dble(maxcomp(JJ+1))
    derlikelihood_mu = derlikelihood_mu / likelihoodf_numer - &
            (eaa*dble(mincomp(JJ+1)) - ebb*dble(maxcomp(JJ+1))) / likelihoodf_denom
    ! calculate derlikelihood_beta
    derlikelihood_beta = derlikelihood_beta + faeaa*dble(mincomp(JJ+2)) &
                        - fbebb*dble(maxcomp(JJ+2))
    derlikelihood_beta = derlikelihood_beta / likelihoodf_numer - &
                    (eaa*dble(mincomp(JJ+2)) - ebb*dble(maxcomp(JJ+2))) / likelihoodf_denom
    ! calculate derlikelihood_gamma
    do j=2,JJ
        k = j-1
        derlikelihood_gamma(k) = derlikelihood_gamma(k) + &
                            faeaa*dble(mincomp(j)) - fbebb*dble(maxcomp(j))
        derlikelihood_gamma(k) = derlikelihood_gamma(k)/likelihoodf_numer &
                        -(eaa*dble(mincomp(j))-ebb*dble(maxcomp(j)))/likelihoodf_denom
    end do

    ! calculate derlikelihood_tau2
    derlikelihood_tau2 = 0.5d0*(derlikelihood_tau2/likelihoodf_numer- &
                    likelihoodf_denomb2/likelihoodf_denom)/tau2/tau2
    prob = prob/likelihoodf_denom

    derlikelihood(1) = derlikelihood_mu
    derlikelihood(2) = derlikelihood_beta
    derlikelihood(3:(JJ+1)) = derlikelihood_gamma
    derlikelihood(JJ+2) = derlikelihood_tau2

end subroutine der_likelihood_time


function LinearPower_notime(mu, beta, tau2, II, JJ, KK, a, b, GQ, GQX, GQW, X_in,typeone) result (power)
    implicit none
    ! ---- arg types -----------------------
    double precision :: mu, beta, tau2,typeone,ppp
    ! true values of beta0, beta1, and tau2
    integer :: II, JJ, KK,ifault
    integer :: X_in(II,JJ)
    ! II : number of clusters
    ! JJ : number of steps
    ! KK : number of subjects per cluster per step
    double precision :: a, b        ! lower and upper limits of GL integral
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    double precision :: power
    ! ----------------------------------------
    integer :: NI   ! number of subjects per cluster, NI=JJ*KK
    !integer :: DD   ! II/(JJ-1). By design, II is a multiple of (JJ-1)

    double precision, parameter :: PI = 3.14159265358979323846   ! pi
    integer :: i, j
    integer :: z0(II), z1(II)
    integer :: z00, z01, z10, z11
    double precision :: h11, h12, h13, h22, h23, h33,h11pre,h12pre,h13pre,h22pre,h23pre,h33pre
    double precision :: derlikelihood_mu, derlikelihood_beta, derlikelihood_tau2
    double precision :: prob
    double precision :: sebeta  ! se of beta1
    logical :: upper

    double precision, external :: alnorm
    double precision, external :: ppnd16

    upper = .false.
    ifault = 0
    a=a
    b=b
    NI = JJ * KK
    !DD = II/GG

    z0 = 0
    do j=1,II
        z0(j) =(JJ-sum(X_in(j,:)))*KK
    enddo
    z1 = NI - z0

    h11 = 0.0d0
    h12 = 0.0d0
    h13 = 0.0d0
    h22 = 0.0d0
    h23 = 0.0d0
    h33 = 0.0d0
    do i=1,II
      if(i>1 .and. ALL(X_in(i,:).EQ. X_in(i-1,:))) then
        h11=h11+h11pre
        h22=h22+h22pre
        h33=h33+h33pre
        h12=h12+h12pre
        h13=h13+h13pre
        h23=h23+h23pre
      else
        h11pre=0
        h22pre=0
        h33pre=0
        h12pre=0
        h13pre=0
        h23pre=0
        do z00 = 0,z0(i)
            z01 = z0(i) - z00
            do z10 = 0,z1(i)
                z11 = z1(i) - z10
                call der_likelihood_notime(mu, beta, tau2, z00, z01, z10, z11, GQ, GQX, GQW,&
derlikelihood_mu, derlikelihood_beta, derlikelihood_tau2, prob)
                h11 = h11 + derlikelihood_mu*derlikelihood_mu*prob
                h22 = h22 + derlikelihood_beta*derlikelihood_beta*prob
                h33 = h33 + derlikelihood_tau2*derlikelihood_tau2*prob
                h12 = h12 + derlikelihood_mu*derlikelihood_beta*prob
                h13 = h13 + derlikelihood_mu*derlikelihood_tau2*prob
                h23 = h23 + derlikelihood_beta*derlikelihood_tau2*prob
                h11pre=h11pre+derlikelihood_mu*derlikelihood_mu*prob
                h22pre=h22pre+derlikelihood_beta*derlikelihood_beta*prob
                h33pre = h33pre + derlikelihood_tau2*derlikelihood_tau2*prob
                h12pre = h12pre + derlikelihood_mu*derlikelihood_beta*prob
                h13pre = h13pre + derlikelihood_mu*derlikelihood_tau2*prob
                h23pre = h23pre + derlikelihood_beta*derlikelihood_tau2*prob
            enddo
        enddo
      end if
    enddo
    sebeta = sqrt(abs((h33*h11-h13*h13)/(h11*h22*h33+2.0d0*h12*h23*h13-h13*h13*h22-h12*h12*h33-h23*h23*h11)))
  !  if(beta<0) then
  !  power =alnorm(-beta/sebeta-1.959964d0,upper)
  !else
  !  power =alnorm(beta/sebeta-1.959964d0,upper)
!  end if
ppp=ppnd16(typeone/2,ifault)
power = alnorm(beta/sebeta+ppp,upper) + alnorm(-beta/sebeta+ppp,upper)
end function LinearPower_notime


subroutine der_likelihood_notime(mu, beta, tau2, z00, z01, z10, z11, GQ, GQX, GQW,&
derlikelihood_mu, derlikelihood_beta, derlikelihood_tau2, prob)
    implicit none
    ! ---- arg types -----------------------
    double precision :: mu, beta, tau2
    ! true values of beta0, beta1, and tau2
    integer :: z00, z01, z10, z11
    integer :: GQ   ! number of GQ points
    double precision :: GQX(GQ), GQW(GQ)
    double precision :: derlikelihood_mu
    double precision :: derlikelihood_beta
    double precision :: derlikelihood_tau2
    double precision :: prob
    ! ---------------------------------------
    double precision :: likelihoodf_denom, likelihoodf_numer, likelihoodf_denomb2

    double precision :: ff00, ff01, ff10, ff11
    double precision :: ff, ff1, ffprob, ff0prob, ff1prob
    double precision :: exx, exx1, exx2, temp
    integer :: z0, z1
    integer :: i, k
    double precision :: x

    double precision, parameter :: PI = 3.14159265358979323846   ! pi

    z0 = z00 + z01
    z1 = z10 + z11
    derlikelihood_mu = 0.0d0
    derlikelihood_beta = 0.0d0
    derlikelihood_tau2 = 0.0d0
    likelihoodf_denom = 0.0d0
    likelihoodf_denomb2 = 0.0d0
    likelihoodf_numer = 0.0d0
    prob = 0.0d0
    do i=1,GQ
        x = GQX(i)
        ff = 1.0d0
        ffprob = 1.0d0
        ff01 = mu+x
        ff00 = 1-ff01
        ff11 = mu+beta+x
        ff10 = 1-ff11
        exx = dexp(-0.5d0*x*x/tau2)

        ff = (ff00**z00)*(ff01**z01)*(ff10**z10)*(ff11**z11)
        likelihoodf_numer = likelihoodf_numer + GQW(i) * ff * exx
        likelihoodf_denom = likelihoodf_denom + GQW(i) * exx
        likelihoodf_denomb2 = likelihoodf_denomb2 + GQW(i) * x * x * exx

        ! since GQX are not at limits, we ignore the cases where ff00=0 or ff01=0 or ff10=0 or ff11=0
        ff1 = ff*(z01/ff01-z00/ff00+z11/ff11-z10/ff10)
        derlikelihood_mu = derlikelihood_mu + GQW(i) * ff1 * exx
        ff1 = ff*(z11/ff11-z10/ff10)
        derlikelihood_beta = derlikelihood_beta + GQW(i) * ff1 * exx
        ff1 = ff*x*x
        derlikelihood_tau2 = derlikelihood_tau2 + GQW(i) * ff1 * exx

        ! prob
        ff0prob = ff00*ff01
        ff1prob = ff10*ff11
        ! compute combination number with power of ff00 and ff01
        ! to avoid overflow
        if (z00<z01) then
            ffprob = ffprob*ff01**(z01-z00)
            do k=0,(z00-1)
                ffprob = ffprob*dble(z0-k)/dble(z00-k)*ff0prob
            end do
        else
            ffprob = ffprob*ff00**(z00-z01)
            do k=0,(z01-1)
                ffprob = ffprob*dble(z0-k)/dble(z01-k)*ff0prob
            end do
        end if
        ! compute combination number with power of ff10 and ff11
        ! to avoid overflow
        if (z10<z11) then
            ffprob = ffprob*ff11**(z11-z10)
            do k=0,(z10-1)
                ffprob = ffprob*dble(z1-k)/dble(z10-k)*ff1prob
            end do
        else
            ffprob = ffprob*ff10**(z10-z11)
            do k=0,(z11-1)
                ffprob = ffprob*dble(z1-k)/dble(z11-k)*ff1prob
            end do
        end if
        prob = prob + GQW(i) * ffprob * exx
    enddo

    if (beta>=0) then
        ! we don't consider the case of beta = 0
        exx1 = dexp(-0.5d0*mu*mu/tau2)       ! exx on lower limits
        exx2 = dexp(-0.5d0*(1-mu-beta)*(1-mu-beta)/tau2)
        if (z01==0) then
            derlikelihood_mu = derlikelihood_mu + ((1-beta)**z10)*(beta**z11)*exx1
        end if
        if (z10==0) then
            temp = ((1-beta)**z01)*(beta**z00)*exx2
            derlikelihood_mu = derlikelihood_mu - temp
            derlikelihood_beta = derlikelihood_beta - temp
        end if
        derlikelihood_mu = derlikelihood_mu / likelihoodf_numer - (exx1-exx2)/likelihoodf_denom
        derlikelihood_beta = derlikelihood_beta / likelihoodf_numer + exx2/likelihoodf_denom
    else
        ! beta < 0
        exx1 = dexp(-0.5d0*(mu+beta)*(mu+beta)/tau2)       ! exx on lower limits
        exx2 = dexp(-0.5d0*(1-mu)*(1-mu)/tau2)
        if (z00==0) then
            derlikelihood_mu = derlikelihood_mu - ((-beta)**z10)*((1+beta)**z11)*exx2
        end if
        if (z11==0) then
            temp = ((-beta)**z01)*((1+beta)**z00)*exx1
            derlikelihood_mu = derlikelihood_mu + temp
            derlikelihood_beta = derlikelihood_beta + temp
        end if
        derlikelihood_mu = derlikelihood_mu / likelihoodf_numer - (exx1-exx2)/likelihoodf_denom
        derlikelihood_beta = derlikelihood_beta / likelihoodf_numer - exx1/likelihoodf_denom
    end if

    derlikelihood_tau2 = 0.5*(derlikelihood_tau2 / likelihoodf_numer - likelihoodf_denomb2 / likelihoodf_denom)/tau2/tau2
    ! likelihoodf = likelihoodf/sqrt(pi)
    prob = prob / likelihoodf_denom
end subroutine der_likelihood_notime

        SUBROUTINE HERZO(N,X,W)
C
C       ========================================================
C       Purpose : Compute the zeros of Hermite polynomial Ln(x)
C                 in R, and the corresponding
C                 weighting coefficients for Gauss-Hermite
C                 integration by Shanjie Zhang, Jianming Jin.
C       Input :   n    --- Order of the Hermite polynomial
C                 X(n) --- Zeros of the Hermite polynomial
C                 W(n) --- Corresponding weighting coefficients
C       ========================================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION X(N),W(N)
        HN=1.0D0/N
        ZL=-1.1611D0+1.46D0*N**0.5
        DO NR=1,N/2
           IF (NR.EQ.1) Z=ZL
           IF (NR.NE.1) Z=Z-HN*(N/2+1-NR)
           IT=0
10         IT=IT+1
           Z0=Z
           F0=1.0D0
           F1=2.0D0*Z
           DO K=2,N
              HF=2.0D0*Z*F1-2.0D0*(K-1.0D0)*F0
              HD=2.0D0*K*F1
              F0=F1
              F1=HF
           END DO
           P=1.0D0
           DO I=1,NR-1
              P=P*(Z-X(I))
           END DO
           FD=HF/P
           Q=0.0D0
           DO I=1,NR-1
              WP=1.0D0
              DO 25 J=1,NR-1
                 IF (J.EQ.I) GO TO 25
                 WP=WP*(Z-X(J))
25            CONTINUE
              Q=Q+WP
           END DO
           GD=(HD-Q*FD)/P
           Z=Z-FD/GD
           IF (IT.LE.40.AND.DABS((Z-Z0)/Z).GT.1.0D-15) GO TO 10
           X(NR)=Z
           X(N+1-NR)=-Z
           R=1.0D0
           DO K=1,N
              R=2.0D0*R*K
           END DO
           W(NR)=3.544907701811D0*R/(HD*HD)
           W(N+1-NR)=W(NR)
        END DO
        IF (N.NE.2*INT(N/2)) THEN
           R1=1.0D0
           R2=1.0D0
           DO 45 J=1,N
              R1=2.0D0*R1*J
              IF (J.GE.(N+1)/2) R2=R2*J
45         CONTINUE
           W(N/2+1)=0.88622692545276D0*R1/(R2*R2)
           X(N/2+1)=0.0D0
        ENDIF
        RETURN
        END

!------------------------------------------------------------------------------
!M+
! NAME:
!       String_Utility
!
! PURPOSE:
!       Module containing string utility routines
!
! CATEGORY:
!       Utility
!
! LANGUAGE:
!       Fortran-95
!
! CALLING SEQUENCE:
!       USE String_Utility
!
! MODULES:
!       None.
!
! CONTAINS:
!       StrUpCase:    Function to convert an input string to upper case.
!
!       StrLowCase:   Function to convert an input string to lower case.
!
!       StrCompress:  Function to return a copy of an input string
!                     with all internal whitespace (spaces and tabs)
!                     removed.
!
! EXTERNALS:
!       None.
!
! COMMON BLOCKS:
!       None.
!
! SIDE EFFECTS:
!       None.
!
! RESTRICTIONS:
!       None known.
!
! CREATION HISTORY:
!       Written by:     Paul van Delst, CIMSS/SSEC 18-Oct-1999
!                       paul.vandelst@ssec.wisc.edu
!
!  Copyright (C) 1999, 2004 Paul van Delst
!
!  This program is free software; you can redistribute it and/or
!  modify it under the terms of the GNU General Public License
!  as published by the Free Software Foundation; either version 2
!  of the License, or (at your option) any later version.
!
!  This program is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with this program; if not, write to the Free Software
!  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
!M-
!------------------------------------------------------------------------------

MODULE String_Utility


  ! ---------------------------
  ! Disable all implicit typing
  ! ---------------------------

  IMPLICIT NONE


  ! ----------
  ! Visibility
  ! ----------

  PRIVATE
  PUBLIC :: StrUpCase
  PUBLIC :: StrLowCase
  PUBLIC :: StrCompress


  ! -----------------
  ! Module parameters
  ! -----------------

  CHARACTER( * ), PRIVATE, PARAMETER :: LOWER_CASE = 'abcdefghijklmnopqrstuvwxyz'
  CHARACTER( * ), PRIVATE, PARAMETER :: UPPER_CASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' 


CONTAINS


!------------------------------------------------------------------------------
!S+
! NAME:
!       StrUpCase
!
! PURPOSE:
!       Function to convert an input string to upper case.
!
! CATEGORY:
!       Utility
!
! LANGUAGE:
!       Fortran-95
!
! CALLING SEQUENCE:
!       Result = StrUpCase( String )
!
! INPUT ARGUMENTS:
!       String:  Character string to be converted to upper case.
!                UNITS:      N/A
!                TYPE:       CHARACTER( * )
!                DIMENSION:  Scalar
!                ATTRIBUTES: INTENT( IN )
!
! OPTIONAL INPUT ARGUMENTS:
!       None.
!
! OUTPUT ARGUMENTS:
!       None.
!
! OPTIONAL OUTPUT ARGUMENTS:
!       None.
!
! FUNCTION RESULT:
!       Result:  The input character string converted to upper case.
!                UNITS:      N/A
!                TYPE:       CHARACTER( LEN(String) )
!                DIMENSION:  Scalar
!
! CALLS:
!       None.
!
! SIDE EFFECTS:
!       None.
!
! RESTRICTIONS:
!       None.
!
! EXAMPLE:
!       string = 'this is a string'
!       WRITE( *, '( a )' ) StrUpCase( string )
!   THIS IS A STRING
!
! PROCEDURE:
!       Figure 3.5B, pg 80, "Upgrading to Fortran 90", by Cooper Redwine,
!       1995 Springer-Verlag, New York.
!
! CREATION HISTORY:
!       Written by:     Paul van Delst, CIMSS/SSEC 18-Oct-1999
!                       paul.vandelst@ssec.wisc.edu
!S-
!------------------------------------------------------------------------------

  FUNCTION StrUpCase ( Input_String ) RESULT ( Output_String )

    ! -- Argument and result
    CHARACTER( * ), INTENT( IN )     :: Input_String
    CHARACTER( LEN( Input_String ) ) :: Output_String

    ! -- Local variables
    INTEGER :: i, n


    ! -- Copy input string
    Output_String = Input_String

    ! -- Loop over string elements
    DO i = 1, LEN( Output_String )

      ! -- Find location of letter in lower case constant string
      n = INDEX( LOWER_CASE, Output_String( i:i ) )

      ! -- If current substring is a lower case letter, make it upper case
      IF ( n /= 0 ) Output_String( i:i ) = UPPER_CASE( n:n )

    END DO

  END FUNCTION StrUpCase



!------------------------------------------------------------------------------
!S+
! NAME:
!       StrLowCase
!
! PURPOSE:
!       Function to convert an input string to lower case.
!
! CATEGORY:
!       Utility
!
! LANGUAGE:
!       Fortran-95
!
! CALLING SEQUENCE:
!       Result = StrLowCase( String )
!
! INPUT ARGUMENTS:
!       String: Character string to be converted to lower case.
!               UNITS:      N/A
!               TYPE:       CHARACTER( * )
!               DIMENSION:  Scalar
!               ATTRIBUTES: INTENT( IN )
!
! OPTIONAL INPUT ARGUMENTS:
!       None.
!
! OUTPUT ARGUMENTS:
!       None.
!
! OPTIONAL OUTPUT ARGUMENTS:
!       None.
!
! FUNCTION RESULT:
!       Result:  The input character string converted to lower case.
!                UNITS:      N/A
!                TYPE:       CHARACTER( LEN(String) )
!                DIMENSION:  Scalar
!
! CALLS:
!       None.
!
! SIDE EFFECTS:
!       None.
!
! RESTRICTIONS:
!       None.
!
! EXAMPLE:
!       string = 'THIS IS A STRING'
!       WRITE( *, '( a )' ) StrLowCase( string )
!   this is a string
!
! PROCEDURE:
!       Figure 3.5B, pg 80, "Upgrading to Fortran 90", by Cooper Redwine,
!       1995 Springer-Verlag, New York.
!
! CREATION HISTORY:
!       Written by:     Paul van Delst, CIMSS/SSEC 18-Oct-1999
!                       paul.vandelst@ssec.wisc.edu
!S-
!------------------------------------------------------------------------------

  FUNCTION StrLowCase ( Input_String ) RESULT ( Output_String )

    ! -- Argument and result
    CHARACTER( * ), INTENT( IN )     :: Input_String
    CHARACTER( LEN( Input_String ) ) :: Output_String

    ! -- Local variables
    INTEGER :: i, n


    ! -- Copy input string
    Output_String = Input_String

    ! -- Loop over string elements
    DO i = 1, LEN( Output_String )

      ! -- Find location of letter in upper case constant string
      n = INDEX( UPPER_CASE, Output_String( i:i ) )

      ! -- If current substring is an upper case letter, make it lower case
      IF ( n /= 0 ) Output_String( i:i ) = LOWER_CASE( n:n )

    END DO

  END FUNCTION StrLowCase



!------------------------------------------------------------------------------
!S+
! NAME:
!       StrCompress
!
! PURPOSE:
!       Subroutine to return a copy of an input string with all whitespace
!       (spaces and tabs) removed.
!
! CATEGORY:
!       Utility
!
! LANGUAGE:
!       Fortran-95
!
! CALLING SEQUENCE:
!       Result = StrCompress( String,  &  ! Input
!                             n = n    )  ! Optional Output
!
! INPUT ARGUMENTS:
!       String:         Character string to be compressed.
!                       UNITS:      N/A
!                       TYPE:       CHARACTER( * )
!                       DIMENSION:  Scalar
!                       ATTRIBUTES: INTENT( IN )
!
! OPTIONAL INPUT ARGUMENTS:
!       None.
!
! OUTPUT ARGUMENTS:
!       None.
!
! OPTIONAL OUTPUT ARGUMENTS:
!       n:              Number of useful characters in output string
!                       after compression. From character n+1 -> LEN( Input_String )
!                       the output is padded with blanks.
!                       UNITS:      N/A
!                       TYPE:       INTEGER
!                       DIMENSION:  Scalar
!                       ATTRIBUTES: INTENT( OUT ), OPTIONAL
!
! FUNCTION RESULT:
!       Result:         Input string with all whitespace removed before the
!                       first non-whitespace character, and from in-between 
!                       non-whitespace characters.
!                       UNITS:      N/A
!                       TYPE:       CHARACTER( LEN(String) )
!                       DIMENSION:  Scalar
!
! CALLS:
!       None.
!
! SIDE EFFECTS:
!       None.
!
! RESTRICTIONS:
!       None.
!
! EXAMPLE:
!       Input_String = '  This is a string with spaces in it.'
!       Output_String = StrCompress( Input_String, n=n )
!       WRITE( *, '( a )' ) '>',Output_String( 1:n ),'<'
!   >Thisisastringwithspacesinit.<
!
!       or
!
!       WRITE( *, '( a )' ) '>',TRIM( Output_String ),'<'
!   >Thisisastringwithspacesinit.<
!
! PROCEDURE:
!       Definitions of a space and a tab character are made for the
!       ASCII collating sequence. Each single character of the input
!       string is checked against these definitions using the IACHAR()
!       intrinsic. If the input string character DOES NOT correspond 
!       to a space or tab, it is not copied to the output string.
!
!       Note that for input that ONLY has spaces or tabs BEFORE the first
!       useful character, the output of this function is the same as the
!       ADJUSTL() instrinsic.
!
! CREATION HISTORY:
!       Written by:     Paul van Delst, CIMSS/SSEC 18-Oct-1999
!                       paul.vandelst@ssec.wisc.edu
!S-
!------------------------------------------------------------------------------

  FUNCTION StrCompress( Input_String, n ) RESULT ( Output_String )

    ! -- Arguments
    CHARACTER( * ),    INTENT( IN )  :: Input_String
    INTEGER, OPTIONAL, INTENT( OUT ) :: n

    ! -- Function result
    CHARACTER( LEN( Input_String ) ) :: Output_String

    ! -- Local parameters
    INTEGER, PARAMETER :: IACHAR_SPACE = 32
    INTEGER, PARAMETER :: IACHAR_TAB   = 9

    ! -- Local variables
    INTEGER :: i, j
    INTEGER :: IACHAR_Character

    ! -- Initialise output string
    Output_String = ' '

    ! -- Initialise output string "useful" length counter
    j = 0

    ! -- Loop over string elements
    DO i = 1, LEN( Input_String )

      ! -- Convert the current character to its position
      ! -- in the ASCII collating sequence
      IACHAR_Character = IACHAR( Input_String( i:i ) )

      ! -- If the character is NOT a space ' ' or a tab '->|'
      ! -- copy it to the output string.
      IF ( IACHAR_Character /= IACHAR_SPACE .AND. &
           IACHAR_Character /= IACHAR_TAB         ) THEN
        j = j + 1
        Output_String( j:j ) = Input_String( i:i )
      END IF

    END DO

    ! -- Save the non-whitespace count
    IF ( PRESENT( n ) ) n = j

  END FUNCTION StrCompress

END MODULE String_Utility


!-------------------------------------------------------------------------------
!                          -- MODIFICATION HISTORY --
!-------------------------------------------------------------------------------
!
! $Id: String_Utility.f90,v 1.6 2004/08/11 23:21:23 paulv Exp $
!
! $Date: 2004/08/11 23:21:23 $
!
! $Revision: 1.6 $
!
! $State: Exp $
!
! $Log: String_Utility.f90,v $
! Revision 1.6  2004/08/11 23:21:23  paulv
! - Updated header documentation
! - Made "n" argument to StrCompress function optional.
!
! Revision 1.5  2002/09/06 21:58:01  paulv
! - Simplified output string initialisation in STRCOMPRESS().
!
! Revision 1.4  2001/12/19 22:23:56  paulv
! - Simplified the STRUPCASE and STRLOWCASE functions. Removed some extraneous
!   variables.
! - Converted STRCOMPRESS to a function. It was too klunky as a subroutine.
!   Also removed variables that were not really required.
!
! Revision 1.3  2000/12/08 21:48:14  paulv
! - Added header documentation.
! - Using ACHAR and IACHAR in STRCOMPRESS to enable tab characters to be
!   removed.
!
!
!

subroutine inverse(a,c,n)
!============================================================
! Inverse matrix
! Method: Based on Doolittle LU factorization for Ax=b
! Alex G. December 2009
!-----------------------------------------------------------
! input ...
! a(n,n) - array of coefficients for matrix A
! n      - dimension
! output ...
! c(n,n) - inverse matrix of A
! comments ...
! the original matrix a(n,n) will be destroyed
! during the calculation
!===========================================================
implicit none
integer n
double precision a(n,n), c(n,n)
double precision L(n,n), U(n,n), b(n), d(n), x(n)
double precision coeff
integer i, j, k

! step 0: initialization for matrices L and U and b
! Fortran 90/95 aloows such operations on matrices
L=0.0
U=0.0
b=0.0

! step 1: forward elimination
do k=1, n-1
   do i=k+1,n
      coeff=a(i,k)/a(k,k)
      L(i,k) = coeff
      do j=k+1,n
         a(i,j) = a(i,j)-coeff*a(k,j)
      end do
   end do
end do

! Step 2: prepare L and U matrices
! L matrix is a matrix of the elimination coefficient
! + the diagonal elements are 1.0
do i=1,n
  L(i,i) = 1.0
end do
! U matrix is the upper triangular part of A
do j=1,n
  do i=1,j
    U(i,j) = a(i,j)
  end do
end do

! Step 3: compute columns of the inverse matrix C
do k=1,n
  b(k)=1.0
  d(1) = b(1)
! Step 3a: Solve Ld=b using the forward substitution
  do i=2,n
    d(i)=b(i)
    do j=1,i-1
      d(i) = d(i) - L(i,j)*d(j)
    end do
  end do
! Step 3b: Solve Ux=d using the back substitution
  x(n)=d(n)/U(n,n)
  do i = n-1,1,-1
    x(i) = d(i)
    do j=n,i+1,-1
      x(i)=x(i)-U(i,j)*x(j)
    end do
    x(i) = x(i)/u(i,i)
  end do
! Step 3c: fill the solutions x(n) into column k of C
  do i=1,n
    c(i,k) = x(i)
  end do
  b(k)=0.0
end do
end subroutine inverse


subroutine vectorsquare(a,n,c)
!============================================================
! Calculate a*a', where a is a vector
! ----------------------------------------------------------
! input ...
! a(n) - vector a
! n    - dimension
! output ...
! c(n,n) - a*a'
!!!!!  next step: modify c to storage compression format
!!!!!  c is a positive definite matrix
!!!!!    stored by rows in lower triangular form
!!!!!    as a one dimensional array, in the sequence
!===========================================================
implicit none
integer n
double precision a(n), c(n,n)

integer i, j

do i=1,n-1
    c(i,i) = a(i)*a(i)
    do j=i+1,n
        c(i,j) = a(i)*a(j)
        c(j,i) = c(i,j)
    end do
end do
c(n,n) = a(n)*a(n)
end subroutine vectorsquare

subroutine vectorproduct(a,b,n,c)
!============================================================
! Calculate a*b', where a,b are vectors
! ----------------------------------------------------------
! input ...
! a(n) - vector a
! b(n) - vector b
! n    - dimension
! output ...
! c(n,n) - a*b'
!===========================================================
implicit none
integer n
double precision a(n), b(n), c(n,n)

integer i, j

do i=1,n
    do j=1,n
        c(i,j) = a(i)*b(j)
    end do
end do
    end subroutine vectorproduct

subroutine synvectorproduct(a,b,n,c)
!============================================================
! Calculate a*b'+b*a', where a,b are vectors
! ----------------------------------------------------------
! input ...
! a(n) - vector a
! b(n) - vector b
! n    - dimension
! output ...
! c(n,n) - a*b'+b*a'
!===========================================================
implicit none
integer n
double precision a(n), b(n), c(n,n)

integer i, j

do i=1,n
    do j=1,n
        c(i,j) = a(i)*b(j) + a(j)*b(i)
    end do
end do
end subroutine synvectorproduct

subroutine vectorproduct2(a,b,n,m,c)
!============================================================
! Calculate a*b', where a,b are vectors
! ----------------------------------------------------------
! input ...
! a(n) - vector a
! b(m) - vector b
! n,m    - dimension
! output ...
! c(n,m) - a*b'
!===========================================================
implicit none
integer n, m
double precision a(n), b(m), c(n,m)

integer i, j

do i=1,n
    do j=1,m
        c(i,j) = a(i)*b(j)
    end do
end do
end subroutine vectorproduct2

subroutine syminverse(a,c,n)
!============================================================
! Inverse symmetric matrix
! Method: Based on Doolittle LU factorization for Ax=b
! Alex G. December 2009
!-----------------------------------------------------------
! input ...
! a(n,n) - array of coefficients for matrix A
! n      - dimension
! output ...
! c(n,n) - inverse matrix of A
! comments ...
! Both a and c are symmetric
!===========================================================
implicit none
integer n
double precision a(n,n), c(n,n)

double precision aa(n*(n+1)/2), cc(n*(n+1)/2)
integer i, j, k
integer nullty, ifault

k = 0
do i=1,n
    do j=1,i
        k = k + 1
        aa(k) = a(i,j)
    end do
end do
call syminv(aa, n, cc, nullty, ifault)
k = 0
do i=1,n
    do j=1,i-1
        k = k + 1
        c(i,j) = cc(k)
        c(j,i) = cc(k)
    end do
    k = k + 1
    c(i,i) = cc(k)
end do
end subroutine syminverse

      subroutine cdgqf ( nt, kind, alpha, beta, t, wts )

c*********************************************************************72
c
cc CDGQF computes a Gauss quadrature formula with default A, B and simple knots.
c
c  Discussion:
c
c    This routine computes all the knots and weights of a Gauss quadrature
c    formula with a classical weight function with default values for A and B,
c    and only simple knots.
c
c    There are no moments checks and no printing is done.
c
c    Use routine EIQFS to evaluate a quadrature computed by CGQFS.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    17 September 2013
c
c  Author:
c
c    Original FORTRAN77 version by Sylvan Elhay, Jaroslav Kautsky.
c    This FORTRAN77 version by John Burkardt.
c
c  Reference:
c
c    Sylvan Elhay, Jaroslav Kautsky,
c    Algorithm 655: IQPACK, FORTRAN Subroutines for the Weights of
c    Interpolatory Quadrature,
c    ACM Transactions on Mathematical Software,
c    Volume 13, Number 4, December 1987, pages 399-415.
c
c  Parameters:
c
c    Input, integer NT, the number of knots.
c
c    Input, integer KIND, the rule.
c    1, Legendre,             (a,b)       1.0
c    2, Chebyshev Type 1,     (a,b)       ((b-x)*(x-a))^(-0.5)
c    3, Gegenbauer,           (a,b)       ((b-x)*(x-a))^alpha
c    4, Jacobi,               (a,b)       (b-x)^alpha*(x-a)^beta
c    5, Generalized Laguerre, (a,+oo)     (x-a)^alpha*exp(-b*(x-a))
c    6, Generalized Hermite,  (-oo,+oo)   |x-a|^alpha*exp(-b*(x-a)^2)
c    7, Exponential,          (a,b)       |x-(a+b)/2.0|^alpha
c    8, Rational,             (a,+oo)     (x-a)^alpha*(x+b)^beta
c    9, Chebyshev Type 2,     (a,b)       ((b-x)*(x-a))^(+0.5)
c
c    Input, double precision ALPHA, the value of Alpha, if needed.
c
c    Input, double precision BETA, the value of Beta, if needed.
c
c    Output, double precision T(NT), the knots.
c
c    Output, double precision WTS(NT), the weights.
c
      implicit none

      integer nt

      double precision aj(nt)
      double precision alpha
      double precision beta
      double precision bj(nt)
      integer kind
      double precision t(nt)
      double precision wts(nt)
      double precision zemu

      call parchk ( kind, 2 * nt, alpha, beta )
c
c  Get the Jacobi matrix and zero-th moment.
c
      call class_matrix ( kind, nt, alpha, beta, aj, bj, zemu )
c
c  Compute the knots and weights.
c
      call sgqf ( nt, aj, bj, zemu, t, wts )

      return
      end
      subroutine cgqf ( nt, kind, alpha, beta, a, b, t, wts )

c*********************************************************************72
c
cc CGQF computes knots and weights of a Gauss quadrature formula.
c
c  Discussion:
c
c    The user may specify the interval (A,B).
c
c    Only simple knots are produced.
c
c    Use routine EIQFS to evaluate this quadrature formula.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    17 September 2013
c
c  Author:
c
c    Original FORTRAN77 version by Sylvan Elhay, Jaroslav Kautsky.
c    This FORTRAN77 version by John Burkardt.
c
c  Reference:
c
c    Sylvan Elhay, Jaroslav Kautsky,
c    Algorithm 655: IQPACK, FORTRAN Subroutines for the Weights of
c    Interpolatory Quadrature,
c    ACM Transactions on Mathematical Software,
c    Volume 13, Number 4, December 1987, pages 399-415.
c
c  Parameters:
c
c    Input, integer NT, the number of knots.
c
c    Input, integer KIND, the rule.
c    1, Legendre,             (a,b)       1.0
c    2, Chebyshev Type 1,     (a,b)       ((b-x)*(x-a))^-0.5)
c    3, Gegenbauer,           (a,b)       ((b-x)*(x-a))^alpha
c    4, Jacobi,               (a,b)       (b-x)^alpha*(x-a)^beta
c    5, Generalized Laguerre, (a,+oo)     (x-a)^alpha*exp(-b*(x-a))
c    6, Generalized Hermite,  (-oo,+oo)   |x-a|^alpha*exp(-b*(x-a)^2)
c    7, Exponential,          (a,b)       |x-(a+b)/2.0|^alpha
c    8, Rational,             (a,+oo)     (x-a)^alpha*(x+b)^beta
c    9, Chebyshev Type 2,     (a,b)       ((b-x)*(x-a))^(+0.5)
c
c    Input, double precision ALPHA, the value of Alpha, if needed.
c
c    Input, double precision BETA, the value of Beta, if needed.
c
c    Input, double precision A, B, the interval endpoints, or
c    other parameters.
c
c    Output, double precision T(NT), the knots.
c
c    Output, double precision WTS(NT), the weights.
c
      implicit none

      integer nt

      double precision a
      double precision alpha
      double precision b
      double precision beta
      integer i
      integer kind
      integer mlt(nt)
      integer ndx(nt)
      double precision t(nt)
      double precision wts(nt)
c
c  Compute the Gauss quadrature formula for default values of A and B.
c
      call cdgqf ( nt, kind, alpha, beta, t, wts )
c
c  Prepare to scale the quadrature formula to other weight function with
c  valid A and B.
c
      do i = 1, nt
        mlt(i) = 1
      end do

      do i = 1, nt
        ndx(i) = i
      end do

      call scqf ( nt, t, mlt, wts, nt, ndx, wts, t, kind, alpha, beta,
     &  a, b )

      return
      end
      subroutine ch_cap ( ch )

c*********************************************************************72
c
cc CH_CAP capitalizes a single character.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    03 January 2007
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input/output, character CH, the character to capitalize.
c
      implicit none

      character ch
      integer itemp

      itemp = ichar ( ch )

      if ( 97 .le. itemp .and. itemp .le. 122 ) then
        ch = char ( itemp - 32 )
      end if

      return
      end
      function ch_eqi ( c1, c2 )

c*********************************************************************72
c
cc CH_EQI is a case insensitive comparison of two characters for equality.
c
c  Example:
c
c    CH_EQI ( 'A', 'a' ) is TRUE.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    03 January 2007
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, character C1, C2, the characters to compare.
c
c    Output, logical CH_EQI, the result of the comparison.
c
      implicit none

      character c1
      character c1_cap
      character c2
      character c2_cap
      logical ch_eqi

      c1_cap = c1
      c2_cap = c2

      call ch_cap ( c1_cap )
      call ch_cap ( c2_cap )

      if ( c1_cap .eq. c2_cap ) then
        ch_eqi = .true.
      else
        ch_eqi = .false.
      end if

      return
      end
      subroutine ch_to_digit ( c, digit )

c*********************************************************************72
c
cc CH_TO_DIGIT returns the integer value of a base 10 digit.
c
c  Example:
c
c     C   DIGIT
c    ---  -----
c    '0'    0
c    '1'    1
c    ...  ...
c    '9'    9
c    ' '    0
c    'X'   -1
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    04 August 1999
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, character C, the decimal digit, '0' through '9' or blank
c    are legal.
c
c    Output, integer DIGIT, the corresponding integer value.  If C was
c    'illegal', then DIGIT is -1.
c
      implicit none

      character c
      integer digit

      if ( lge ( c, '0' ) .and. lle ( c, '9' ) ) then

        digit = ichar ( c ) - 48

      else if ( c .eq. ' ' ) then

        digit = 0

      else

        digit = -1

      end if

      return
      end
      subroutine class_matrix ( kind, m, alpha, beta, aj, bj, zemu )

c*********************************************************************72
c
cc CLASS_MATRIX computes the Jacobi matrix for a quadrature rule.
c
c  Discussion:
c
c    This routine computes the diagonal AJ and sub-diagonal BJ
c    elements of the order M tridiagonal symmetric Jacobi matrix
c    associated with the polynomials orthogonal with respect to
c    the weight function specified by KIND.
c
c    For weight functions 1-7, M elements are defined in BJ even
c    though only M-1 are needed.  For weight function 8, BJ(M) is
c    set to zero.
c
c    The zero-th moment of the weight function is returned in ZEMU.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    17 September 2013
c
c  Author:
c
c    Original FORTRAN77 version by Sylvan Elhay, Jaroslav Kautsky.
c    This FORTRAN77 version by John Burkardt.
c
c  Reference:
c
c    Sylvan Elhay, Jaroslav Kautsky,
c    Algorithm 655: IQPACK, FORTRAN Subroutines for the Weights of
c    Interpolatory Quadrature,
c    ACM Transactions on Mathematical Software,
c    Volume 13, Number 4, December 1987, pages 399-415.
c
c  Parameters:
c
c    Input, integer KIND, the rule.
c    1, Legendre,             (a,b)       1.0
c    2, Chebyshev Type 1,     (a,b)       ((b-x)*(x-a))^(-0.5)
c    3, Gegenbauer,           (a,b)       ((b-x)*(x-a))^alpha
c    4, Jacobi,               (a,b)       (b-x)^alpha*(x-a)^beta
c    5, Generalized Laguerre, (a,+oo)     (x-a)^alpha*exp(-b*(x-a))
c    6, Generalized Hermite,  (-oo,+oo)   |x-a|^alpha*exp(-b*(x-a)^2)
c    7, Exponential,          (a,b)       |x-(a+b)/2.0|^alpha
c    8, Rational,             (a,+oo)     (x-a)^alpha*(x+b)^beta
c    9, Chebyshev Type 2,     (a,b)       ((b-x)*(x-a))^(+0.5)
c
c    Input, integer M, the order of the Jacobi matrix.
c
c    Input, double precision ALPHA, the value of Alpha, if needed.
c
c    Input, double precision BETA, the value of Beta, if needed.
c
c    Output, double precision AJ(M), BJ(M), the diagonal and subdiagonal
c    of the Jacobi matrix.
c
c    Output, double precision ZEMU, the zero-th moment.
c
      implicit none

      integer m

      double precision a2b2
      double precision ab
      double precision aba
      double precision abi
      double precision abj
      double precision abti
      double precision aj(m)
      double precision alpha
      double precision apone
      double precision beta
      double precision bj(m)
      integer i
      integer kind
      double precision pi
      parameter ( pi = 3.14159265358979323846264338327950D+00 )
      double precision r8_gamma
      double precision r8_epsilon
      double precision temp
      double precision temp2
      double precision zemu

      temp = r8_epsilon ( )

      call parchk ( kind, 2 * m - 1, alpha, beta )

      temp2 = r8_gamma ( 0.5D+00 )

      if ( 500.0D+00 * temp .lt. abs ( temp2 * temp2 - pi ) ) then
c        write ( *, '(a)' ) ' '
c        write ( *, '(a)' ) 'CLASS_MATRIX - Fatal error!'
c        write ( *, '(a)' )
c     &    '  Gamma function does not match machine parameters.'
c        stop 1
      end if

      if ( kind .eq. 1 ) then

        ab = 0.0D+00

        zemu = 2.0D+00 / ( ab + 1.0D+00 )

        do i = 1, m
          aj(i) = 0.0D+00
        end do

        do i = 1, m
          abi = i + ab * mod ( i, 2 )
          abj = 2 * i + ab
          bj(i) = abi * abi / ( abj * abj - 1.0D+00 )
        end do

        do i = 1, m
          bj(i) = sqrt ( bj(i) )
        end do

      else if ( kind .eq. 2 ) then

        zemu = pi

        do i = 1, m
          aj(i) = 0.0D+00
        end do

        bj(1) =  sqrt ( 0.5D+00 )
        do i = 2, m
          bj(i) = 0.5D+00
        end do

      else if ( kind .eq. 3 ) then

        ab = alpha * 2.0D+00
        zemu = 2.0D+00**( ab + 1.0D+00 )
     &    * ( r8_gamma ( alpha + 1.0D+00 ) )**2
     &    / r8_gamma ( ab + 2.0D+00 )

        do i = 1, m
          aj(i) = 0.0D+00
        end do

        bj(1) = 1.0D+00 / ( 2.0D+00 * alpha + 3.0D+00 )
        do i = 2, m
          bj(i) = i * ( i + ab )
     &      / ( 4.0D+00 * ( i + alpha ) * ( i + alpha ) - 1.0D+00 )
        end do
        do i = 1, m
          bj(i) =  sqrt ( bj(i) )
        end do

      else if ( kind .eq. 4 ) then

        ab = alpha + beta
        abi = 2.0D+00 + ab
        zemu = 2.0D+00**( ab + 1.0D+00 ) * r8_gamma ( alpha + 1.0D+00 )
     &      * r8_gamma ( beta + 1.0D+00 ) / r8_gamma ( abi )
        aj(1) = ( beta - alpha ) / abi
        bj(1) = 4.0D+00 * ( 1.0 + alpha ) * ( 1.0D+00 + beta )
     &    / ( ( abi + 1.0D+00 ) * abi * abi )
        a2b2 = beta * beta - alpha * alpha

        do i = 2, m
          abi = 2.0D+00 * i + ab
          aj(i) = a2b2 / ( ( abi - 2.0D+00 ) * abi )
          abi = abi * abi
          bj(i) = 4.0D+00 * i * ( i + alpha ) * ( i + beta )
     &      * ( i + ab ) / ( ( abi - 1.0D+00 ) * abi )
        end do

        do i = 1, m
          bj(i) =  sqrt ( bj(i) )
        end do

      else if ( kind .eq. 5 ) then

        zemu = r8_gamma ( alpha + 1.0D+00 )

        do i = 1, m
          aj(i) = 2.0D+00 * i - 1.0D+00 + alpha
          bj(i) = i * ( i + alpha )
        end do

        do i = 1, m
          bj(i) = sqrt ( bj(i) )
        end do

      else if ( kind .eq. 6 ) then

        zemu = r8_gamma ( ( alpha + 1.0D+00 ) / 2.0D+00 )

        do i = 1, m
          aj(i) = 0.0D+00
        end do

        do i = 1, m
          bj(i) = ( i + alpha * mod ( i, 2 ) ) / 2.0D+00
        end do

        do i = 1, m
          bj(i) =  sqrt ( bj(i) )
        end do

      else if ( kind .eq. 7 ) then

        ab = alpha
        zemu = 2.0D+00 / ( ab + 1.0D+00 )

        do i = 1, m
          aj(i) = 0.0D+00
        end do

        do i = 1, m
          abi = i + ab * mod ( i, 2 )
          abj = 2 * i + ab
          bj(i) = abi * abi / ( abj * abj - 1.0D+00 )
        end do

        do i = 1, m
          bj(i) =  sqrt ( bj(i) )
        end do

      else if ( kind .eq. 8 ) then

        ab = alpha + beta
        zemu = r8_gamma ( alpha + 1.0D+00 )
     &    * r8_gamma ( - ( ab + 1.0D+00 ) )
     &    / r8_gamma ( - beta )
        apone = alpha + 1.0D+00
        aba = ab * apone
        aj(1) = - apone / ( ab + 2.0D+00 )
        bj(1) = - aj(1) * ( beta + 1.0D+00 ) / ( ab + 2.0D+00 )
     &    / ( ab + 3.0D+00 )
        do i = 2, m
          abti = ab + 2.0D+00 * i
          aj(i) = aba + 2.0D+00 * ( ab + i ) * ( i - 1 )
          aj(i) = - aj(i) / abti / ( abti - 2.0D+00 )
        end do

        do i = 2, m - 1
          abti = ab + 2.0D+00 * i
          bj(i) = i * ( alpha + i ) / ( abti - 1.0D+00 ) * ( beta + i )
     &      / ( abti * abti ) * ( ab + i ) / ( abti + 1.0D+00 )
        end do

        bj(m) = 0.0D+00

        do i = 1, m
          bj(i) =  sqrt ( bj(i) )
        end do

      else if ( kind .eq. 9 ) then

        zemu = pi / 2.0D+00

        do i = 1, m
          aj(i) = 0.0D+00
          bj(i) = 0.5D+00
        end do

      end if

      return
      end
      subroutine get_unit ( iunit )

c*********************************************************************72
c
cc GET_UNIT returns a free FORTRAN unit number.
c
c  Discussion:
c
c    A "free" FORTRAN unit number is a value between 1 and 99 which
c    is not currently associated with an I/O device.  A free FORTRAN unit
c    number is needed in order to open a file with the OPEN command.
c
c    If IUNIT = 0, then no free FORTRAN unit could be found, although
c    all 99 units were checked (except for units 5, 6 and 9, which
c    are commonly reserved for console I/O).
c
c    Otherwise, IUNIT is a value between 1 and 99, representing a
c    free FORTRAN unit.  Note that GET_UNIT assumes that units 5 and 6
c    are special, and will never return those values.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    02 September 2013
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Output, integer IUNIT, the free unit number.
c
      implicit none

      integer i
      integer iunit
      logical value

      iunit = 0

      do i = 1, 99

        if ( i .ne. 5 .and. i .ne. 6 .and. i .ne. 9 ) then

          inquire ( unit = i, opened = value, err = 10 )

          if ( .not. value ) then
            iunit = i
            return
          end if

        end if

10      continue

      end do

      return
      end
      subroutine imtqlx ( n, d, e, z )

c*********************************************************************72
c
cc IMTQLX diagonalizes a symmetric tridiagonal matrix.
c
c  Discussion:
c
c    This routine is a slightly modified version of the EISPACK routine to
c    perform the implicit QL algorithm on a symmetric tridiagonal matrix.
c
c    The authors thank the authors of EISPACK for permission to use this
c    routine.
c
c    It has been modified to produce the product Q' * Z, where Z is an input
c    vector and Q is the orthogonal matrix diagonalizing the input matrix.
c    The changes consist (essentially) of applying the orthogonal
c    transformations directly to Z as they are generated.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    17 September 2013
c
c  Author:
c
c    Original FORTRAN77 version by Sylvan Elhay, Jaroslav Kautsky.
c    This FORTRAN77 version by John Burkardt.
c
c  Reference:
c
c    Sylvan Elhay, Jaroslav Kautsky,
c    Algorithm 655: IQPACK, FORTRAN Subroutines for the Weights of
c    Interpolatory Quadrature,
c    ACM Transactions on Mathematical Software,
c    Volume 13, Number 4, December 1987, pages 399-415.
c
c    Roger Martin, James Wilkinson,
c    The Implicit QL Algorithm,
c    Numerische Mathematik,
c    Volume 12, Number 5, December 1968, pages 377-383.
c
c  Parameters:
c
c    Input, integer N, the order of the matrix.
c
c    Input/output, double precision D(N), the diagonal entries of the matrix.
c    On output, the information in D has been overwritten.
c
c    Input/output, double precision E(N), the subdiagonal entries of the
c    matrix, in entries E(1) through E(N-1).  On output, the information in
c    E has been overwritten.
c
c    Input/output, double precision Z(N).  On input, a vector.  On output,
c    the value of Q' * Z, where Q is the matrix that diagonalizes the
c    input symmetric tridiagonal matrix.
c
      implicit none

      integer n

      double precision b
      double precision c
      double precision d(n)
      double precision e(n)
      double precision f
      double precision g
      integer i
      integer ii
      integer itn
      parameter ( itn = 30 )
      integer j
      integer k
      integer l
      integer m
      integer mml
      double precision p
      double precision prec
      double precision r
      double precision r8_epsilon
      double precision s
      double precision z(n)

      prec = r8_epsilon ( )

      if ( n .eq. 1 ) then
        return
      end if

      e(n) = 0.0D+00

      do l = 1, n

        j = 0

10      continue

          do m = l, n

            if ( m .eq. n ) then
              go to 20
            end if

            if ( abs ( e(m) ) .le.
     &        prec * ( abs ( d(m) ) + abs ( d(m+1) ) ) ) then
              go to 20
            end if

          end do

20        continue

          p = d(l)

          if ( m .eq. l ) then
            go to 30
          end if

          if ( itn .le. j ) then
c            write ( *, '(a)' ) ' '
c            write ( *, '(a)' ) 'IMTQLX - Fatal error!'
c            write ( *, '(a)' ) '  Iteration limit exceeded.'
c            write ( *, '(a,i8)' ) '  J = ', j
c            write ( *, '(a,i8)' ) '  L = ', l
c            write ( *, '(a,i8)' ) '  M = ', m
c            write ( *, '(a,i8)' ) '  N = ', n
c            stop 1
          end if

          j = j + 1
          g = ( d(l+1) - p ) / ( 2.0D+00 * e(l) )
          r =  sqrt ( g * g + 1.0D+00 )
          g = d(m) - p + e(l) / ( g + sign ( r, g ) )
          s = 1.0D+00
          c = 1.0D+00
          p = 0.0D+00
          mml = m - l

          do ii = 1, mml

            i = m - ii
            f = s * e(i)
            b = c * e(i)

            if ( abs ( g ) .le. abs ( f ) ) then
              c = g / f
              r =  sqrt ( c * c + 1.0D+00 )
              e(i+1) = f * r
              s = 1.0D+00 / r
              c = c * s
            else
              s = f / g
              r =  sqrt ( s * s + 1.0D+00 )
              e(i+1) = g * r
              c = 1.0D+00 / r
              s = s * c
            end if

            g = d(i+1) - p
            r = ( d(i) - g ) * s + 2.0D+00 * c * b
            p = s * r
            d(i+1) = g + p
            g = c * r - b
            f = z(i+1)
            z(i+1) = s * z(i) + c * f
            z(i) = c * z(i) - s * f

          end do

          d(l) = d(l) - p
          e(l) = g
          e(m) = 0.0D+00

        go to 10

30      continue

      end do
c
c  Sorting.
c
      do ii = 2, n

        i = ii - 1
        k = i
        p = d(i)

        do j = ii, n
          if ( d(j) .lt. p ) then
            k = j
            p = d(j)
          end if
        end do

        if ( k .ne. i ) then
          d(k) = d(i)
          d(i) = p
          p = z(i)
          z(i) = z(k)
          z(k) = p
        end if

      end do

      return
      end
      subroutine legendrehandle ( order, a, b, x, w )

c*********************************************************************72
c
cc LEGENDRE_COMPUTE computes a Legendre quadrature rule.
c
c  Discussion:
c
c    Our convention is that the abscissas are numbered from left to right.
c
c    The rule is defined on [-1,1].
c
c    The integral to approximate:
c
c      Integral ( -1 <= X <= 1 ) F(X) dX
c
c    The quadrature rule:
c
c      Sum ( 1 <= I <= ORDER ) W(I) * F ( X(I) )
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    28 September 2013
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer ORDER, the order of the rule.
c    1 <= ORDER.
c
c    Output, double precision X(ORDER), the abscissas.
c
c    Output, double precision W(ORDER), the weights.
c
      implicit none

      integer order

      double precision a
      double precision alpha
      double precision b
      double precision beta

      integer kind

      double precision w(order)
      double precision x(order)

      kind = 1
      alpha = 0.0D+00
      beta = 0.0D+00

      call cgqf ( order, kind, alpha, beta, a, b, x, w )

      return
      end
      subroutine parchk ( kind, m, alpha, beta )

c*********************************************************************72
c
cc PARCHK checks parameters ALPHA and BETA for classical weight functions.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    17 September 2013
c
c  Author:
c
c    Original FORTRAN77 version by Sylvan Elhay, Jaroslav Kautsky.
c    This FORTRAN77 version by John Burkardt.
c
c  Reference:
c
c    Sylvan Elhay, Jaroslav Kautsky,
c    Algorithm 655: IQPACK, FORTRAN Subroutines for the Weights of
c    Interpolatory Quadrature,
c    ACM Transactions on Mathematical Software,
c    Volume 13, Number 4, December 1987, pages 399-415.
c
c  Parameters:
c
c    Input, integer KIND, the rule.
c    1, Legendre,             (a,b)       1.0
c    2, Chebyshev Type 1,     (a,b)       ((b-x)*(x-a))^(-0.5)
c    3, Gegenbauer,           (a,b)       ((b-x)*(x-a))^alpha
c    4, Jacobi,               (a,b)       (b-x)^alpha*(x-a)^beta
c    5, Generalized Laguerre, (a,+oo)     (x-a)^alpha*exp(-b*(x-a))
c    6, Generalized Hermite,  (-oo,+oo)   |x-a|^alpha*exp(-b*(x-a)^2)
c    7, Exponential,          (a,b)       |x-(a+b)/2.0|^alpha
c    8, Rational,             (a,+oo)     (x-a)^alpha*(x+b)^beta
c    9, Chebyshev Type 2,     (a,b)       ((b-x)*(x-a))^(+0.5)
c
c    Input, integer M, the order of the highest moment to
c    be calculated.  This value is only needed when KIND = 8.
c
c    Input, double precision ALPHA, BETA, the parameters, if required
c    by the value of KIND.
c
      implicit none

      double precision alpha
      double precision beta
      integer kind
      integer m
      double precision tmp

      if ( kind .le. 0 ) then
c        write ( *, '(a)' ) ' '
c        write ( *, '(a)' ) 'PARCHK - Fatal error!'
c        write ( *, '(a)' ) '  KIND .le. 0.'
c        stop 1
      end if
c
c  Check ALPHA for Gegenbauer, Jacobi, Laguerre, Hermite, Exponential.
c
      if ( 3 .le. kind .and. kind .le. 8 .and.
     &  alpha .le. -1.0D+00 ) then
c        write ( *, '(a)' ) ' '
c        write ( *, '(a)' ) 'PARCHK - Fatal error!'
c        write ( *, '(a)' ) '  3 .le. KIND and ALPHA .le. -1.'
c        stop 1
      end if
c
c  Check BETA for Jacobi.
c
      if ( kind .eq. 4 .and. beta .le. -1.0D+00 ) then
c        write ( *, '(a)' ) ' '
c        write ( *, '(a)' ) 'PARCHK - Fatal error!'
c        write ( *, '(a)' ) '  KIND .eq. 4 and BETA .le. -1.0.'
c        stop 1
      end if
c
c  Check ALPHA and BETA for rational.
c
      if ( kind .eq. 8 ) then
        tmp = alpha + beta + m + 1.0D+00
        if ( 0.0D+00 .le. tmp .or. tmp .le. beta ) then
c          write ( *, '(a)' ) ' '
c          write ( *, '(a)' ) 'PARCHK - Fatal error!'
c          write ( *, '(a)' )
c     &      '  KIND .eq. 8 but condition on ALPHA and BETA fails.'
c          stop 1
        end if
      end if

      return
      end
      function r8_epsilon ( )

c*********************************************************************72
c
cc R8_EPSILON returns the R8 roundoff unit.
c
c  Discussion:
c
c    The roundoff unit is a number R which is a power of 2 with the
c    property that, to the precision of the computer's arithmetic,
c      1 .lt. 1 + R
c    but
c      1 = ( 1 + R / 2 )
c
c    FORTRAN90 provides the superior library routine
c
c      EPSILON ( X )
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    01 September 2012
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Output, double precision R8_EPSILON, the R8 roundoff unit.
c
      implicit none

      double precision r8_epsilon

      r8_epsilon = 2.220446049250313D-016

      return
      end
      function r8_gamma ( x )

c*********************************************************************72
c
cc R8_GAMMA evaluates Gamma(X) for a real argument.
c
c  Discussion:
c
c    This routine calculates the gamma function for a real argument X.
c    Computation is based on an algorithm outlined in reference 1.
c    The program uses rational functions that approximate the gamma
c    function to at least 20 significant decimal digits.  Coefficients
c    for the approximation over the interval (1,2) are unpublished.
c    Those for the approximation for 12 .le. X are from reference 2.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    18 January 2008
c
c  Author:
c
c    Original FORTRAN77 version by William Cody, Laura Stoltz.
c    This FORTRAN77 version by John Burkardt.
c
c  Reference:
c
c    William Cody,
c    An Overview of Software Development for Special Functions,
c    in Numerical Analysis Dundee, 1975,
c    edited by GA Watson,
c    Lecture Notes in Mathematics 506,
c    Springer, 1976.
c
c    John Hart, Ward Cheney, Charles Lawson, Hans Maehly,
c    Charles Mesztenyi, John Rice, Henry Thatcher,
c    Christoph Witzgall,
c    Computer Approximations,
c    Wiley, 1968,
c    LC: QA297.C64.
c
c  Parameters:
c
c    Input, double precision X, the argument of the function.
c
c    Output, double precision R8_GAMMA, the value of the function.
c
      implicit none

      double precision c(7)
      double precision eps
      double precision fact
      integer i
      integer n
      double precision p(8)
      logical parity
      double precision pi
      double precision q(8)
      double precision r8_gamma
      double precision res
      double precision sqrtpi
      double precision sum
      double precision x
      double precision xbig
      double precision xden
      double precision xinf
      double precision xminin
      double precision xnum
      double precision y
      double precision y1
      double precision ysq
      double precision z
c
c  Mathematical constants
c
      data sqrtpi / 0.9189385332046727417803297D+00 /
      data pi / 3.1415926535897932384626434D+00 /
c
c  Machine dependent parameters
c
      data xbig / 171.624D+00 /
      data xminin / 2.23D-308 /
      data eps / 2.22D-16 /
      data xinf /1.79D+308 /
c
c  Numerator and denominator coefficients for rational minimax
c  approximation over (1,2).
c
      data p /
     & -1.71618513886549492533811d+00,
     &  2.47656508055759199108314d+01,
     & -3.79804256470945635097577d+02,
     &  6.29331155312818442661052d+02,
     &  8.66966202790413211295064d+02,
     & -3.14512729688483675254357d+04,
     & -3.61444134186911729807069d+04,
     &  6.64561438202405440627855d+04 /

      data q /
     & -3.08402300119738975254353d+01,
     &  3.15350626979604161529144d+02,
     & -1.01515636749021914166146d+03,
     & -3.10777167157231109440444d+03,
     &  2.25381184209801510330112d+04,
     &  4.75584627752788110767815d+03,
     & -1.34659959864969306392456d+05,
     & -1.15132259675553483497211d+05 /
c
c  Coefficients for minimax approximation over (12, INF).
c
      data c /
     & -1.910444077728D-03,
     &  8.4171387781295D-04,
     & -5.952379913043012D-04,
     &  7.93650793500350248D-04,
     & -2.777777777777681622553D-03,
     &  8.333333333333333331554247D-02,
     &  5.7083835261D-03 /

      parity = .false.
      fact = 1.0D+00
      n = 0
      y = x
c
c  Argument is negative.
c
      if ( y .le. 0.0D+00 ) then

        y = - x
        y1 = aint ( y )
        res = y - y1

        if ( res .ne. 0.0D+00 ) then

          if ( y1 .ne. aint ( y1 * 0.5D+00 ) * 2.0D+00 ) then
            parity = .true.
          end if

          fact = - pi / sin ( pi * res )
          y = y + 1.0D+00

        else

          res = xinf
          r8_gamma = res
          return

        end if

      end if
c
c  Argument is positive.
c
      if ( y .lt. eps ) then
c
c  Argument < EPS.
c
        if ( xminin .le. y ) then
          res = 1.0D+00 / y
        else
          res = xinf
          r8_gamma = res
          return
        end if

      else if ( y .lt. 12.0D+00 ) then

        y1 = y
c
c  0.0 < argument < 1.0.
c
        if ( y .lt. 1.0D+00 ) then

          z = y
          y = y + 1.0D+00
c
c  1.0 < argument < 12.0.
c  Reduce argument if necessary.
c
        else

          n = int ( y ) - 1
          y = y - dble ( n )
          z = y - 1.0D+00

        end if
c
c  Evaluate approximation for 1.0 < argument < 2.0.
c
        xnum = 0.0D+00
        xden = 1.0D+00
        do i = 1, 8
          xnum = ( xnum + p(i) ) * z
          xden = xden * z + q(i)
        end do

        res = xnum / xden + 1.0D+00
c
c  Adjust result for case  0.0 < argument < 1.0.
c
        if ( y1 .lt. y ) then

          res = res / y1
c
c  Adjust result for case 2.0 < argument < 12.0.
c
        else if ( y .lt. y1 ) then

          do i = 1, n
            res = res * y
            y = y + 1.0D+00
          end do

        end if

      else
c
c  Evaluate for 12.0 .le. argument.
c
        if ( y .le. xbig ) then

          ysq = y * y
          sum = c(7)
          do i = 1, 6
            sum = sum / ysq + c(i)
          end do
          sum = sum / y - y + sqrtpi
          sum = sum + ( y - 0.5D+00 ) * log ( y )
          res = exp ( sum )

        else

          res = xinf
          r8_gamma = res
          return

        end if

      end if
c
c  Final adjustments and return.
c
      if ( parity ) then
        res = - res
      end if

      if ( fact .ne. 1.0D+00 ) then
        res = fact / res
      end if

      r8_gamma = res

      return
      end

      subroutine r8mat_write ( m, n )

c*********************************************************************72
c
cc R8MAT_WRITE writes a R8MAT file.
c
c  Discussion:
c
c    An R8MAT is an array of R8's.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    22 October 2009
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, character * ( * ) OUTPUT_FILENAME, the output file name.
c
c    Input, integer M, the spatial dimension.
c
c    Input, integer N, the number of points.
c
c    Input, double precision TABLE(M,N), the data.
c
      implicit none

      integer m
      integer n

      integer j

      integer output_unit


c
c  Open the file.
c
      call get_unit ( output_unit )

c      open ( unit = output_unit, file = output_filename,
c     &  status = 'replace' )
c
c  Create the format string.
c
      if ( 0 .lt. m .and. 0 .lt. n ) then

c        write ( string, '(a1,i8,a1,i8,a1,i8,a1)' )
c     &    '(', m, 'g', 24, '.', 16, ')'
c
c  Write the data.
c
        do j = 1, n
c          write ( output_unit, string ) table(1:m,j)
        end do

      end if
c
c  Close the file.
c
c      close ( unit = output_unit )

      return
      end
      subroutine rule_write ( order, x, w, r, filename )

c*********************************************************************72
c
cc RULE_WRITE writes a quadrature rule to a file.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    18 February 2010
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer ORDER, the order of the rule.
c
c    Input, double precision X(ORDER), the abscissas.
c
c    Input, double precision W(ORDER), the weights.
c
c    Input, double precision R(2), defines the region.
c
c    Input, character ( len = * ) FILENAME, specifies the output.
c    'filename_w.txt', 'filename_x.txt', 'filename_r.txt' defining weights,
c    abscissas, and region.
c
      implicit none

      integer order

      character(len=*) filename
      character(len=255) filename_r
      character(len=255) filename_w
      character(len=255) filename_x


      double precision r(2)
      double precision w(order)
      double precision x(order)

      filename_w = trim ( filename ) // '_w.txt'
      filename_x = trim ( filename ) // '_x.txt'
      filename_r = trim ( filename ) // '_r.txt'

c      write ( *, '(a)' ) ' '
c      write ( *, '(a)' ) '  Creating quadrature files.'
c      write ( *, '(a)' ) ' '
c      write ( *, '(a)' )
c     &  '  "Root" file name is   "' // trim ( filename ) // '".'
c      write ( *, '(a)' ) ' '
c      write ( *, '(a)' )
c     &  '  Weight file will be   "' // trim ( filename_w ) // '".'
c      write ( *, '(a)' )
c     &  '  Abscissa file will be "' // trim ( filename_x ) // '".'
c      write ( *, '(a)' )
c     &  '  Region file will be   "' // trim ( filename_r ) // '".'

      call r8mat_write ( 1, order )
      call r8mat_write ( 1, order )
      call r8mat_write ( 1, 2 )

      return
      end
      subroutine s_to_i4 ( s, ival, ierror, length )

c*********************************************************************72
c
cc S_TO_I4 reads an I4 from a string.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    28 April 2008
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, character * ( * ) S, a string to be examined.
c
c    Output, integer IVAL, the integer value read from the string.
c    If the string is blank, then IVAL will be returned 0.
c
c    Output, integer IERROR, an error flag.
c    0, no error.
c    1, an error occurred.
c
c    Output, integer LENGTH, the number of characters of S
c    used to make IVAL.
c
      implicit none

      character c
      integer i
      integer ierror
      integer isgn
      integer istate
      integer ival
      integer length
      character(len=*) s

      ierror = 0
      istate = 0
      isgn = 1
      ival = 0

      do i = 1, len_trim ( s )

        c = s(i:i)
c
c  Haven't read anything.
c
        if ( istate .eq. 0 ) then

          if ( c .eq. ' ' ) then

          else if ( c .eq. '-' ) then
            istate = 1
            isgn = -1
          else if ( c .eq. '+' ) then
            istate = 1
            isgn = + 1
          else if ( lle ( '0', c ) .and. lle ( c, '9' ) ) then
            istate = 2
            ival = ichar ( c ) - ichar ( '0' )
          else
            ierror = 1
            return
          end if
c
c  Have read the sign, expecting digits.
c
        else if ( istate .eq. 1 ) then

          if ( c .eq. ' ' ) then

          else if ( lle ( '0', c ) .and. lle ( c, '9' ) ) then
            istate = 2
            ival = ichar ( c ) - ichar ( '0' )
          else
            ierror = 1
            return
          end if
c
c  Have read at least one digit, expecting more.
c
        else if ( istate .eq. 2 ) then

          if ( lle ( '0', c ) .and. lle ( c, '9' ) ) then
            ival = 10 * ival + ichar ( c ) - ichar ( '0' )
          else
            ival = isgn * ival
            length = i - 1
            return
          end if

        end if

      end do
c
c  If we read all the characters in the string, see if we're OK.
c
      if ( istate .eq. 2 ) then
        ival = isgn * ival
        length = len_trim ( s )
      else
        ierror = 1
        length = 0
      end if

      return
      end

      subroutine s_to_r8 ( s, dval, ierror, length )

c*********************************************************************72
c
cc S_TO_R8 reads an R8 from a string.
c
c  Discussion:
c
c    The routine will read as many characters as possible until it reaches
c    the end of the string, or encounters a character which cannot be
c    part of the number.
c
c    Legal input is:
c
c       1 blanks,
c       2 '+' or '-' sign,
c       2.5 blanks
c       3 integer part,
c       4 decimal point,
c       5 fraction part,
c       6 'E' or 'e' or 'D' or 'd', exponent marker,
c       7 exponent sign,
c       8 exponent integer part,
c       9 exponent decimal point,
c      10 exponent fraction part,
c      11 blanks,
c      12 final comma or semicolon,
c
c    with most quantities optional.
c
c  Example:
c
c    S                 DVAL
c
c    '1'               1.0
c    '     1   '       1.0
c    '1A'              1.0
c    '12,34,56'        12.0
c    '  34 7'          34.0
c    '-1E2ABCD'        -100.0
c    '-1X2ABCD'        -1.0
c    ' 2E-1'           0.2
c    '23.45'           23.45
c    '-4.2E+2'         -420.0
c    '17d2'            1700.0
c    '-14e-2'         -0.14
c    'e2'              100.0
c    '-12.73e-9.23'   -12.73 * 10.0^(-9.23)
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    28 April 2008
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, character * ( * ) S, the string containing the
c    data to be read.  Reading will begin at position 1 and
c    terminate at the end of the string, or when no more
c    characters can be read to form a legal real.  Blanks,
c    commas, or other nonnumeric data will, in particular,
c    cause the conversion to halt.
c
c    Output, double precision DVAL, the value read from the string.
c
c    Output, integer IERROR, error flag.
c    0, no errors occurred.
c    1, 2, 6 or 7, the input number was garbled.  The
c    value of IERROR is the last type of input successfully
c    read.  For instance, 1 means initial blanks, 2 means
c    a plus or minus sign, and so on.
c
c    Output, integer LENGTH, the number of characters read
c    to form the number, including any terminating
c    characters such as a trailing comma or blanks.
c
      implicit none

      logical ch_eqi
      character c
      double precision dval
      integer ierror
      integer ihave
      integer isgn
      integer iterm
      integer jbot
      integer jsgn
      integer jtop
      integer length
      integer nchar
      integer ndig
      double precision rbot
      double precision rexp
      double precision rtop
      character(len=*) s

      nchar = len_trim ( s )

      ierror = 0
      dval = 0.0D+00
      length = -1
      isgn = 1
      rtop = 0
      rbot = 1
      jsgn = 1
      jtop = 0
      jbot = 1
      ihave = 1
      iterm = 0

10    continue

        length = length + 1

        if ( nchar .lt. length + 1 ) then
          go to 20
        end if

        c = s(length+1:length+1)
c
c  Blank character.
c
        if ( c .eq. ' ' ) then

          if ( ihave .eq. 2 ) then

          else if ( ihave .eq. 6 .or. ihave .eq. 7 ) then
            iterm = 1
          else if ( 1 .lt. ihave ) then
            ihave = 11
          end if
c
c  Comma.
c
        else if ( c .eq. ',' .or. c .eq. ';' ) then

          if ( ihave .ne. 1 ) then
            iterm = 1
            ihave = 12
            length = length + 1
          end if
c
c  Minus sign.
c
        else if ( c .eq. '-' ) then

          if ( ihave .eq. 1 ) then
            ihave = 2
            isgn = -1
          else if ( ihave .eq. 6 ) then
            ihave = 7
            jsgn = -1
          else
            iterm = 1
          end if
c
c  Plus sign.
c
        else if ( c .eq. '+' ) then

          if ( ihave .eq. 1 ) then
            ihave = 2
          else if ( ihave .eq. 6 ) then
            ihave = 7
          else
            iterm = 1
          end if
c
c  Decimal point.
c
        else if ( c .eq. '.' ) then

          if ( ihave .lt. 4 ) then
            ihave = 4
          else if ( 6 .le. ihave .and. ihave .le. 8 ) then
            ihave = 9
          else
            iterm = 1
          end if
c
c  Scientific notation exponent marker.
c
        else if ( ch_eqi ( c, 'E' ) .or. ch_eqi ( c, 'D' ) ) then

          if ( ihave .lt. 6 ) then
            ihave = 6
          else
            iterm = 1
          end if
c
c  Digit.
c
        else if ( ihave .lt. 11 .and. lle ( '0', c )
     &    .and. lle ( c, '9' ) ) then

          if ( ihave .le. 2 ) then
            ihave = 3
          else if ( ihave .eq. 4 ) then
            ihave = 5
          else if ( ihave .eq. 6 .or. ihave .eq. 7 ) then
            ihave = 8
          else if ( ihave .eq. 9 ) then
            ihave = 10
          end if

          call ch_to_digit ( c, ndig )

          if ( ihave .eq. 3 ) then
            rtop = 10.0D+00 * rtop + dble ( ndig )
          else if ( ihave .eq. 5 ) then
            rtop = 10.0D+00 * rtop + dble ( ndig )
            rbot = 10.0D+00 * rbot
          else if ( ihave .eq. 8 ) then
            jtop = 10 * jtop + ndig
          else if ( ihave .eq. 10 ) then
            jtop = 10 * jtop + ndig
            jbot = 10 * jbot
          end if
c
c  Anything else is regarded as a terminator.
c
        else
          iterm = 1
        end if
c
c  If we haven't seen a terminator, and we haven't examined the
c  entire string, go get the next character.
c
        if ( iterm .eq. 1 ) then
          go to 20
        end if

        go to 10

20    continue
c
c  If we haven't seen a terminator, and we have examined the
c  entire string, then we're done, and LENGTH is equal to NCHAR.
c
      if ( iterm .ne. 1 .and. length+1 .eq. nchar ) then
        length = nchar
      end if
c
c  Number seems to have terminated.  Have we got a legal number?
c  Not if we terminated in states 1, 2, 6 or 7.
c
      if ( ihave .eq. 1 .or. ihave .eq. 2 .or.
     &     ihave .eq. 6 .or. ihave .eq. 7 ) then
        ierror = ihave
c        write ( *, '(a)' ) ' '
c        write ( *, '(a)' ) 'S_TO_R8 - Serious error!'
c        write ( *, '(a)' ) '  Illegal or nonnumeric input:'
c        write ( *, '(a,a)' ) '    ', s
        return
      end if
c
c  Number seems OK.  Form it.
c
      if ( jtop .eq. 0 ) then
        rexp = 1.0D+00
      else
        if ( jbot .eq. 1 ) then
          rexp = 10.0D+00 ** ( jsgn * jtop )
        else
          rexp = 10.0D+00 ** ( dble ( jsgn * jtop ) / dble ( jbot ) )
        end if
      end if

      dval = dble ( isgn ) * rexp * rtop / rbot

      return
      end
      subroutine scqf ( nt, t, mlt, wts, nwts, ndx, swts, st, kind,
     &  alpha, beta, a, b )

c*********************************************************************72
c
cc SCQF scales a quadrature formula to a nonstandard interval.
c
c  Discussion:
c
c    The arrays WTS and SWTS may coincide.
c
c    The arrays T and ST may coincide.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    17 September 2013
c
c  Author:
c
c    Original FORTRAN77 version by Sylvan Elhay, Jaroslav Kautsky.
c    This FORTRAN77 version by John Burkardt.
c
c  Reference:
c
c    Sylvan Elhay, Jaroslav Kautsky,
c    Algorithm 655: IQPACK, FORTRAN Subroutines for the Weights of
c    Interpolatory Quadrature,
c    ACM Transactions on Mathematical Software,
c    Volume 13, Number 4, December 1987, pages 399-415.
c
c  Parameters:
c
c    Input, integer NT, the number of knots.
c
c    Input, double precision T(NT), the original knots.
c
c    Input, integer MLT(NT), the multiplicity of the knots.
c
c    Input, double precision WTS(NWTS), the weights.
c
c    Input, integer NWTS, the number of weights.
c
c    Input, integer NDX(NT), used to index the array WTS.
c    For more details see the comments in CAWIQ.
c
c    Output, double precision SWTS(NWTS), the scaled weights.
c
c    Output, double precision ST(NT), the scaled knots.
c
c    Input, integer KIND, the rule.
c    1, Legendre,             (a,b)       1.0
c    2, Chebyshev Type 1,     (a,b)       ((b-x)*(x-a))^(-0.5)
c    3, Gegenbauer,           (a,b)       ((b-x)*(x-a))^alpha
c    4, Jacobi,               (a,b)       (b-x)^alpha*(x-a)^beta
c    5, Generalized Laguerre, (a,+oo)     (x-a)^alpha*exp(-b*(x-a))
c    6, Generalized Hermite,  (-oo,+oo)   |x-a|^alpha*exp(-b*(x-a)^2)
c    7, Exponential,          (a,b)       |x-(a+b)/2.0|^alpha
c    8, Rational,             (a,+oo)     (x-a)^alpha*(x+b)^beta
c    9, Chebyshev Type 2,     (a,b)       ((b-x)*(x-a))^(+0.5)
c
c    Input, double precision ALPHA, the value of Alpha, if needed.
c
c    Input, double precision BETA, the value of Beta, if needed.
c
c    Input, double precision A, B, the interval endpoints.
c
      implicit none

      integer nt
      integer nwts

      double precision a
      double precision al
      double precision alpha
      double precision b
      double precision be
      double precision beta
      integer i
      integer k
      integer kind
      integer l
      integer mlt(nt)
      integer ndx(nt)
      double precision p
      double precision r8_epsilon
      double precision shft
      double precision slp
      double precision st(nt)
      double precision swts(nwts)
      double precision t(nt)
      double precision temp
      double precision tmp
      double precision wts(nwts)

      temp = r8_epsilon ( )

      call parchk ( kind, 1, alpha, beta )

      if ( kind .eq. 1 ) then

        al = 0.0D+00
        be = 0.0D+00

        if ( abs ( b - a ) .le. temp ) then
c          write ( *, '(a)' ) ' '
c          write ( *, '(a)' ) 'SCQF - Fatal error!'
c          write ( *, '(a)' ) '  |B - A| too small.'
c          stop 1
        end if

        shft = ( a + b ) / 2.0D+00
        slp = ( b - a ) / 2.0D+00

      else if ( kind .eq. 2 ) then

        al = -0.5D+00
        be = -0.5D+00

        if ( abs ( b - a ) .le. temp ) then
c          write ( *, '(a)' ) ' '
c          write ( *, '(a)' ) 'SCQF - Fatal error!'
c          write ( *, '(a)' ) '  |B - A| too small.'
c          stop 1
        end if

        shft = ( a + b ) / 2.0D+00
        slp = ( b - a ) / 2.0D+00

      else if ( kind .eq. 3 ) then

        al = alpha
        be = alpha

        if ( abs ( b - a ) .le. temp ) then
c          write ( *, '(a)' ) ' '
c          write ( *, '(a)' ) 'SCQF - Fatal error!'
c          write ( *, '(a)' ) '  |B - A| too small.'
c          stop 1
        end if

        shft = ( a + b ) / 2.0D+00
        slp = ( b - a ) / 2.0D+00

      else if ( kind .eq. 4 ) then

        al = alpha
        be = beta

        if ( abs ( b - a ) .le. temp ) then
c          write ( *, '(a)' ) ' '
c          write ( *, '(a)' ) 'SCQF - Fatal error!'
c          write ( *, '(a)' ) '  |B - A| too small.'
c          stop 1
        end if

        shft = ( a + b ) / 2.0D+00
        slp = ( b - a ) / 2.0D+00

      else if ( kind .eq. 5 ) then

        if ( b .le. 0.0D+00 ) then
c          write ( *, '(a)' ) ' '
c          write ( *, '(a)' ) 'SCQF - Fatal error!'
c          write ( *, '(a)' ) '  B .le. 0'
c          stop 1
        end if

        shft = a
        slp = 1.0D+00 / b
        al = alpha
        be = 0.0D+00

      else if ( kind .eq. 6 ) then

        if ( b .le. 0.0D+00 ) then
c          write ( *, '(a)' ) ' '
c          write ( *, '(a)' ) 'SCQF - Fatal error!'
c          write ( *, '(a)' ) '  B .le. 0.'
c          stop 1
        end if

        shft = a
        slp = 1.0D+00 / sqrt ( b )
        al = alpha
        be = 0.0D+00

      else if ( kind .eq. 7 ) then

        al = alpha
        be = 0.0D+00

        if ( abs ( b - a ) .le. temp ) then
c          write ( *, '(a)' ) ' '
c          write ( *, '(a)' ) 'SCQF - Fatal error!'
c          write ( *, '(a)' ) '  |B - A| too small.'
c          stop 1
        end if

        shft = ( a + b ) / 2.0D+00
        slp = ( b - a ) / 2.0D+00

      else if ( kind .eq. 8 ) then

        if ( a + b .le. 0.0D+00 ) then
c          write ( *, '(a)' ) ' '
c          write ( *, '(a)' ) 'SCQF - Fatal error!'
c          write ( *, '(a)' ) '  A + B .le. 0.'
c          stop 1
        end if

        shft = a
        slp = a + b
        al = alpha
        be = beta

      else if ( kind .eq. 9 ) then

        al = 0.5D+00
        be = 0.5D+00

        if ( abs ( b - a ) .le. temp ) then
c          write ( *, '(a)' ) ' '
c          write ( *, '(a)' ) 'SCQF - Fatal error!'
c          write ( *, '(a)' ) '  |B - A| too small.'
c          stop 1
        end if

        shft = ( a + b ) / 2.0D+00
        slp = ( b - a ) / 2.0D+00

      end if

      p = slp ** ( al + be + 1.0D+00 )

      do k = 1, nt

        st(k) = shft + slp * t(k)
        l = abs ( ndx(k) )

        if ( l .ne. 0 ) then
          tmp = p
          do i = l, l + mlt(k) - 1
            swts(i) = wts(i) * tmp
            tmp = tmp * slp
          end do
        end if

      end do

      return
      end
      subroutine sgqf ( nt, aj, bj, zemu, t, wts )

c*********************************************************************72
c
cc SGQF computes knots and weights of a Gauss Quadrature formula.
c
c  Discussion:
c
c    This routine computes all the knots and weights of a Gauss quadrature
c    formula with simple knots from the Jacobi matrix and the zero-th
c    moment of the weight function, using the Golub-Welsch technique.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    17 September 2013
c
c  Author:
c
c    Original FORTRAN77 version by Sylvan Elhay, Jaroslav Kautsky.
c    This FORTRAN77 version by John Burkardt.
c
c  Reference:
c
c    Sylvan Elhay, Jaroslav Kautsky,
c    Algorithm 655: IQPACK, FORTRAN Subroutines for the Weights of
c    Interpolatory Quadrature,
c    ACM Transactions on Mathematical Software,
c    Volume 13, Number 4, December 1987, pages 399-415.
c
c  Parameters:
c
c    Input, integer NT, the number of knots.
c
c    Input, double precision AJ(NT), the diagonal of the Jacobi matrix.
c
c    Input/output, double precision BJ(NT), the subdiagonal of the Jacobi
c    matrix, in entries 1 through NT-1.  On output, BJ has been overwritten.
c
c    Input, double precision ZEMU, the zero-th moment of the weight function.
c
c    Output, double precision T(NT), the knots.
c
c    Output, double precision WTS(NT), the weights.
c
      implicit none

      integer nt

      double precision aj(nt)
      double precision bj(nt)
      integer i
      double precision t(nt)
      double precision wts(nt)
      double precision zemu
c
c  Exit if the zero-th moment is not positive.
c
      if ( zemu .le. 0.0D+00 ) then
c        write ( *, '(a)' ) ' '
c        write ( *, '(a)' ) 'SGQF - Fatal error!'
c        write ( *, '(a)' ) '  ZEMU .le. 0.'
c        stop 1
      end if
c
c  Set up vectors for IMTQLX.
c
      do i = 1, nt
        t(i) = aj(i)
      end do

      wts(1) = sqrt ( zemu )
      do i = 2, nt
        wts(i) = 0.0D+00
      end do
c
c  Diagonalize the Jacobi matrix.
c
      call imtqlx ( nt, t, bj, wts )

      do i = 1, nt
        wts(i) = wts(i) ** 2
      end do

      return
      end
      subroutine legendre_handle2 ( order, a, b, x, w )

c*********************************************************************72
c
cc LEGENDRE_COMPUTE computes a Legendre quadrature rule.
c
c  Discussion:
c
c    Our convention is that the abscissas are numbered from left to right.
c
c    The rule is defined on [-1,1].
c
c    The integral to approximate:
c
c      Integral ( -1 <= X <= 1 ) F(X) dX
c
c    The quadrature rule:
c
c      Sum ( 1 <= I <= ORDER ) W(I) * F ( X(I) )
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    28 September 2013
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer ORDER, the order of the rule.
c    1 <= ORDER.
c
c    Output, double precision X(ORDER), the abscissas.
c
c    Output, double precision W(ORDER), the weights.
c
      implicit none

      integer order

      double precision a
      double precision alpha
      double precision b
      double precision beta

      integer kind

      double precision w(order)
      double precision x(order)

      kind = 5
      alpha = 0.0D+00
      beta =  0.0D+00
      call cgqf ( order, kind, alpha, beta, a, b, x, w )

      return
      end

function GEElinear_continous_time(mu, beta, gamma,rho0, II, JJ, KK, &
                     X_in,sigma2,ICC0,ICC2,typeone) result (power)


    implicit none
    ! ---- arg types -----------------------
    integer :: II, JJ, KK,ifault
    integer :: X_in(II,JJ)
    ! II : number of clusters
    ! JJ : number of steps
    ! KK : number of subjects per cluster per step
    double precision :: typeone,ppp
    double precision :: mu, beta,rho0,alpha0,alpha1,alpha2,sigma2,ICC0,ICC2
    ! true values of mu, beta, and tau2
    double precision :: gamma(JJ),B1(JJ*KK,JJ*KK)
    !double precision :: a, b        ! lower and upper limits of GL integral
    !integer :: mincomp(JJ+2), maxcomp(JJ+2)
    !integer :: GQ   ! number of GQ points
    !double precision :: GQX(GQ), GQW(GQ)
    !double precision :: t_power
    double precision :: power,lambda1,lambda2,lambda3,lambda4,vardelta
    ! ----------------------------------------

    double precision, parameter :: PI = 3.14159265358979323846   ! pi
  !  real :: X(JJ*KK,JJ+1)  ! intervention matrix
    !integer :: DD      ! II/(JJ-1). By design, II is a multiple of (JJ-1)
    integer :: i, j, U1,U2,U3,U4,U5
    !logical :: upper

    !double precision, external :: alnorm
    !integer, external :: updatez
    !double precision :: intm4(JJ+1,JJ+1)
    double precision :: z0(JJ*KK),z1(JJ*KK,JJ*KK)   ! z0: # of subjects with outcome 0; z1: # of subjects with outcome 1.
    !double precision :: R(JJ*KK,JJ*KK)
    !double precision :: Ry(JJ+1)
    !double precision :: Wsub(JJ*KK,JJ*KK)
    !double precision :: W(JJ*KK,JJ*KK)
    ! integer :: nZ               ! total number of possible combination of z0 and z1
    !integer :: finish
    !double precision :: derlikelihood(JJ+2)   ! derivative of likelihood
    !double precision :: derlikelihood2(JJ+2, JJ+2)  ! square of derivative of likelihood
    !double precision :: invVar(JJ+2,JJ+2)      ! inverse of variance matrix
    !double precision :: Var(JJ+2,JJ+2)         ! variance matrix
    !double precision :: prob
    !double precision :: sebeta  ! se of beta
    logical :: upper
    double precision, external :: alnorm
    double precision, external :: ppnd16
  !  double precision, external :: diag
    !double precision, external :: matmual
    !double precision, external :: r4_normal_01_cdf_inverse
    upper = .false.
    ifault = 0
    mu=mu
    z0=1
    z1=1

    B1=0
    !allocate(X_in(II,JJ))

    !DD=II/GG
    !DD = II/(JJ-1)   ! II is a multiple of (JJ-1)
    ! assign intervention


    gamma(1)=gamma(1)
    alpha0= ICC0
    alpha1= rho0
    alpha2= ICC2



    !check positive definiteness
    lambda1 = 1- alpha0 + alpha1 - alpha2
    lambda2 = 1- alpha0 - (JJ-1)*(alpha1 - alpha2)
    lambda3 = 1 + (KK-1)*(alpha0 - alpha1) - alpha2
    lambda4 = 1 + (KK-1)*alpha0 + (JJ-1)*(KK-1)*alpha1 + (JJ-1)*alpha2

    if (min(lambda1,lambda2,lambda3,lambda4)<0) then
       !print *, 'not positive-definite, min(lambda1,lambda2,lambda3,lambda4)<0'
      !stop
    end if
    !inverse of R
    !analytical inverse is used here, if the matrix gets large,
    !one could also use the closed-form expression provided in the paper

!calculate variance
   U1=0
   U2=0
   U3=0
   do i=1,II
    ! per cluster
      do j=1,JJ
        U1=U1+X_in(i,j)
      enddo
    enddo

    do j=1,JJ
     ! per cluster
       U4=0
       do i=1,II
        U4=U4+X_in(i,j)
       enddo
     U2=U2+U4*U4
     enddo

     do i=1,II
      ! per cluster
      U5=0
        do j=1,JJ
          U5=U5+X_in(i,j)
        enddo
        U3=U3+U5*U5
      enddo

    ! nZ = 1
    ! do j=1,JJ
    !     nZ = nZ * (KK+1)
    ! end do
    ! run the algorithm
    !invVar = 0.0d0
    !do i=1,II
        ! per cluster
    !    z0 = 0
    !    finish = 0
    !    do while (finish<1)
    !        z1 = KK - z0
            ! prob = prob_z(mu,beta,gamma, tau2, z0, z1, X(i,:), JJ, KK, GQ, GQX, GQW)
    !        call der_likelihood_time(mu,beta,gamma,tau2, z0, z1, X(i,:), JJ, KK, a, b, &
    !                            mincomp, maxcomp, GQ, GQX, GQW, derlikelihood, prob)
    !        call vectorsquare(derlikelihood, JJ+2, derlikelihood2)
    !        invVar = invVar + derlikelihood2 * prob
    !        finish = updatez(z0, JJ, KK)
    !    end do
    !end do
    !call syminverse(invVar,Var,JJ+2)
    !sebeta = sqrt(Var(2,2))
    !power = alnorm(beta/sebeta-1.959964d0,upper) + alnorm(-beta/sebeta-1.959964d0,upper)


    !delta=beta
    vardelta = (sigma2/KK)*II*JJ*lambda3*lambda4/((U1*U1+II*JJ*U1-JJ*U2-II*U3)*lambda4-(U1*U1-II*U3)*lambda3)


     ! verify whether this is close to the assumed delta, which is log(0.25)
    !vardelta = invOmega(1,1)!  # var of the trt effect estimator


    !delta=0
    !vardelta=1
    ! z-test
    !power = alnorm(delta/sqrt(vardelta)-1.959964d0,upper) + alnorm(-delta/sqrt(vardelta)-1.959964d0,upper)
    !if(beta<0) then
    !power =alnorm(-beta/sqrt(vardelta)-1.959964d0,upper)
  !else
    !power =alnorm(beta/sqrt(vardelta)-1.959964d0,upper)
  !end if
!  temerror=r4_normal_01_cdf_inverse(0.95)
  !temerror=ppnd(0.95)
   ppp=ppnd16(typeone/2,ifault)
    power =alnorm(-beta/sqrt(vardelta)+ppp,upper)+alnorm(beta/sqrt(vardelta)+ppp,upper)

  !power =alnorm(-beta/sqrt(vardelta)-1.96,upper)+alnorm(beta/sqrt(vardelta)-1.96,upper)
    !z_power = pnorm(qnorm(0.05/2) + abs(delta)/sqrt(vardelta))
   !print(z_power)
  !power=temerror
    ! t-test df=# clusters minus p
  !  df = II - (JJ+1)
  !  t_power = pt(qt(0.05/2,df=df) + abs(delta)/sqrt(vardelta),df=df)


end function GEElinear_continous_time

      function ppnd16 ( p, ifault )

c*********************************************************************72
c
cc PPND16 produces the normal deviate value corresponding to lower tail area = P.
c
c  Discussion:
c
c    The result is accurate to about 1 part in 10**16.
c
c  Modified:
c
c    13 January 2008
c
c  Author:
c
c    Michael Wichura
c
c  Reference:
c
c    Michael Wichura,
c    Algorithm AS 241:
c    The Percentage Points of the Normal Distribution,
c    Applied Statistics,
c    Volume 37, Number 3, 1988, pages 477-484.
c
c  Parameters:
c
c    Input, double precision P, the value of the cumulative probability 
c    densitity function.  0 < P < 1.
c
c    Output, integer IFAULT, error flag.
c    0, no error.
c    1, P <= 0 or P >= 1.
c
c    Output, double precision PPND16, the normal deviate value with the 
c    property that the probability of a standard normal deviate being 
c    less than or equal to PPND16 is P.c
c
      implicit none

      double precision a0
      double precision a1
      double precision a2
      double precision a3
      double precision a4
      double precision a5
      double precision a6
      double precision a7
      double precision b1
      double precision b2
      double precision b3
      double precision b4
      double precision b5
      double precision b6
      double precision b7
      double precision c0
      double precision c1
      double precision c2
      double precision c3
      double precision c4
      double precision c5
      double precision c6
      double precision c7
      double precision const1
      double precision const2
      double precision d1
      double precision d2
      double precision d3
      double precision d4
      double precision d5
      double precision d6
      double precision d7
      double precision e0
      double precision e1
      double precision e2
      double precision e3
      double precision e4
      double precision e5
      double precision e6
      double precision e7
      double precision f1
      double precision f2
      double precision f3
      double precision f4
      double precision f5
      double precision f6
      double precision f7
      integer ifault
      double precision p
      double precision ppnd16
      double precision q
      double precision r
      double precision split1
      double precision split2

      parameter ( a0 = 3.3871328727963666080D+00 )
      parameter ( a1 = 1.3314166789178437745D+02 )
      parameter ( a2 = 1.9715909503065514427D+03 )
      parameter ( a3 = 1.3731693765509461125D+04 )
      parameter ( a4 = 4.5921953931549871457D+04 )
      parameter ( a5 = 6.7265770927008700853D+04 )
      parameter ( a6 = 3.3430575583588128105D+04 )
      parameter ( a7 = 2.5090809287301226727D+03 )
      parameter ( b1 = 4.2313330701600911252D+01 )
      parameter ( b2 = 6.8718700749205790830D+02 )
      parameter ( b3 = 5.3941960214247511077D+03 )
      parameter ( b4 = 2.1213794301586595867D+04 )
      parameter ( b5 = 3.9307895800092710610D+04 )
      parameter ( b6 = 2.8729085735721942674D+04 )
      parameter ( b7 = 5.2264952788528545610D+03 )
      parameter ( c0 = 1.42343711074968357734D+00 )
      parameter ( c1 = 4.63033784615654529590D+00 )
      parameter ( c2 = 5.76949722146069140550D+00 )
      parameter ( c3 = 3.64784832476320460504D+00 )
      parameter ( c4 = 1.27045825245236838258D+00 )
      parameter ( c5 = 2.41780725177450611770D-01 )
      parameter ( c6 = 2.27238449892691845833D-02 )
      parameter ( c7 = 7.74545014278341407640D-04 )
      parameter ( const1 = 0.180625D+00 )
      parameter ( const2 = 1.6D+00 )
      parameter ( d1 = 2.05319162663775882187D+00 )
      parameter ( d2 = 1.67638483018380384940D+00 )
      parameter ( d3 = 6.89767334985100004550D-01 )
      parameter ( d4 = 1.48103976427480074590D-01 )
      parameter ( d5 = 1.51986665636164571966D-02 )
      parameter ( d6 = 5.47593808499534494600D-04 )
      parameter ( d7 = 1.05075007164441684324D-09 )
      parameter ( e0 = 6.65790464350110377720D+00 )
      parameter ( e1 = 5.46378491116411436990D+00 )
      parameter ( e2 = 1.78482653991729133580D+00 )
      parameter ( e3 = 2.96560571828504891230D-01 )
      parameter ( e4 = 2.65321895265761230930D-02 )
      parameter ( e5 = 1.24266094738807843860D-03 )
      parameter ( e6 = 2.71155556874348757815D-05 )
      parameter ( e7 = 2.01033439929228813265D-07 )
      parameter ( f1 = 5.99832206555887937690D-01 )
      parameter ( f2 = 1.36929880922735805310D-01 )
      parameter ( f3 = 1.48753612908506148525D-02 )
      parameter ( f4 = 7.86869131145613259100D-04 )
      parameter ( f5 = 1.84631831751005468180D-05 )
      parameter ( f6 = 1.42151175831644588870D-07 )
      parameter ( f7 = 2.04426310338993978564D-15 )
      parameter ( split1 = 0.425D+00 )
      parameter ( split2 = 5.D+00 )

      ifault = 0
      q = p - 0.5D+00

      if ( dabs ( q ) .le. split1 ) then

        r = const1 - q * q

        ppnd16 = q * (((((((
     &      a7   * r 
     &    + a6 ) * r 
     &    + a5 ) * r 
     &    + a4 ) * r 
     &    + a3 ) * r 
     &    + a2 ) * r 
     &    + a1 ) * r 
     &    + a0 ) / (((((((
     &      b7   * r 
     &    + b6 ) * r 
     &    + b5 ) * r 
     &    + b4 ) * r 
     &    + b3 ) * r 
     &    + b2 ) * r 
     &    + b1 ) * r 
     &    + 1.0D+00 )

      else

        if ( q .lt. 0.0D+00 ) then
          r = p
        else
          r = 1.0D+00 - p
        end if

        if ( r .le. 0.0D+00 ) then
          ifault = 1
          ppnd16 = 0.0D+00
          return
        end if

        r = dsqrt ( - dlog ( r ) )

        if ( r .le. split2 ) then

          r = r - const2

          ppnd16 = (((((((
     &        c7   * r 
     &      + c6 ) * r 
     &      + c5 ) * r 
     &      + c4 ) * r 
     &      + c3 ) * r 
     &      + c2 ) * r 
     &      + c1 ) * r 
     &      + c0 ) / (((((((
     &        d7   * r 
     &      + d6 ) * r 
     &      + d5 ) * r 
     &      + d4 ) * r 
     &      + d3 ) * r 
     &      + d2 ) * r 
     &      + d1 ) * r 
     &      + 1.0D+00 )

        else

          r = r - split2

          ppnd16 = (((((((
     &        e7   * r 
     &      + e6 ) * r 
     &      + e5 ) * r 
     &      + e4 ) * r 
     &      + e3 ) * r 
     &      + e2 ) * r 
     &      + e1 ) * r 
     &      + e0 ) / (((((((
     &        f7   * r 
     &      + f6 ) * r 
     &      + f5 ) * r 
     &      + f4 ) * r 
     &      + f3 ) * r 
     &      + f2 ) * r 
     &      + f1 ) * r 
     &      + 1.0D+00 )

        end if

        if ( q .lt. 0.0D+00 ) then
          ppnd16 = - ppnd16
        end if

      end if

      return
      end

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ContICC.R
\name{ContICC}
\alias{ContICC}
\title{A function for calculating ICCs for continuous outcomes given random effects variances}
\usage{
ContICC(
  type = "cross-sectional",
  sigma2 = 1,
  sigma_b = 0,
  sigma_c = 0,
  sigma_pi = NA
)
}
\arguments{
\item{type}{choose the study type, specify type="cohort" for closed cohort study and type="cross-sectional" for cross-sectional study, default is "cross-sectional"}

\item{sigma2}{marginal variance of the outcom, default is 1}

\item{sigma_b}{variance of the between-cluster random effect, default is 0}

\item{sigma_c}{variance of the cluster-by-time interaction random effect, default is 0}

\item{sigma_pi}{variance of the random effect for repeated measures of one individual, this parameter should not be specified for cross-sectional studies, default is NA}
}
\value{
The object returned includes the study type and values for the ICCs in this study
}
\description{
This function calculates the within-period, between-period, and within-individual correlation parameters for continuous outcomes in a stepped wedge CRT
}
\examples{
ContICC(type="cohort",sigma2=1.5,sigma_b=0.5,sigma_c=0.2,sigma_pi=0.3)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/swdpower.R
\name{swdpower}
\alias{swdpower}
\title{A function of power calculation for Stepped Wedge Design Studies}
\usage{
swdpower(
  K,
  design,
  family = "binomial",
  model = "conditional",
  link = "identity",
  type = "cross-sectional",
  meanresponse_start = NA,
  meanresponse_end0 = meanresponse_start,
  meanresponse_end1 = NA,
  effectsize_beta = NA,
  sigma2 = 0,
  typeIerror = 0.05,
  alpha0 = 0.1,
  alpha1 = alpha0/2,
  alpha2 = NA
)
}
\arguments{
\item{K}{number of participants at each time period in a cluster, specified as the average clusterperiod size considering cluster-size variability}

\item{design}{I*J dimensional data set that describes the study design (control 0, intervention 1), I is the number of clusters, J is the number of time periods. Unequal allocation of sequences and only complete designs with no transition periods are allowed}

\item{family}{family of responses, specify family="gaussian" for continuous outcome and family="binomial" for binary outcome, with default value of "binomial"}

\item{model}{choose from conditional model (model="conditional") and marginal model (model="marginal"), with default value of applying conditional model}

\item{link}{choose link function from link="identity", link="log" and link="logit", with default value of identity link}

\item{type}{choose the study type, specify type="cohort" for closed cohort study and type="cross-sectional" for cross-sectional study, with default value of cross-sectional study}

\item{meanresponse_start}{the anticipated mean response in the control group at the start of the study}

\item{meanresponse_end0}{the anticipated mean response in the control group at the end of the study, with default value equals to meanresponse_start (no time effects). To include time effects in your model, set meanresponse_start and meanresponse_end0 to different values.}

\item{meanresponse_end1}{the anticipated mean response in the intervention group at the end of the study}

\item{effectsize_beta}{the anticipated effect size, just omit this parameter if you don't need to specify it. In all scenarios, you can choose to specify the three parameters about mean responses without specifying this effect size, or alternatively specify meanresponse_start, meanresponse_end0 and this effect size. For continuous outcomes, users can conduct power calculations by only specifying this parameter without the above three parameters about mean responses (as the power is dependent just on it), then calculation will be implemented assuming scenarios without time effects. If you would consider scenarios with time effects and continuous outcomes, please specify meanresponse_start, meanresponse_end0 (donot require accurate information, just make sure they are not equal) and this effectsize_beta.}

\item{sigma2}{marginal variance of the outcome (only needed for continuous outcomes and should not be an input for binary outcomes), with default value of 0.}

\item{typeIerror}{two-sided type I error, with default value of 0.05}

\item{alpha0}{within-period correlation, with default value of 0.1}

\item{alpha1}{between-period correlation, with default value of alpha0/2}

\item{alpha2}{within-individual correlation, should not be an input under cross-sectional designs although it is numerically identical to alpha1 in this scenario by definition}
}
\value{
The object returned has a class of \code{swdpower}, which includes a list of the design matrix and a summary of this design (including the power)
}
\description{
This function performs power calculations for stepped wedge cluster randomized trials under different scenarios. The default setting assumes no time effect; to include time effects, set meanresponse_start and meanresponse_end0 to different values. Please refer to the documentation for guidance on incorporating time effects.
}
\examples{
library(swdpwr)
#a cross-sectional design with 12 clusters, 3 periods and binary outcomes applying conditional model
#alpha2 should not be specified, as the current version does not support power calculation using
#conditional models with binary outcomes in a cohort design
#create a 12*3 matrix which describes the study design,
#0 means control status, 1 means intervention status
dataset = matrix(c(rep(c(0,1,1),6),rep(c(0,0,1),6)),12,3,byrow=TRUE)

#specify meanresponse_start, meanresponse_end0 and meanresponse_end1
swdpower(K = 30, design = dataset, family = "binomial", model = "conditional", link = "logit",
type = "cross-sectional", meanresponse_start = 0.2, meanresponse_end0 = 0.3,
meanresponse_end1 = 0.4, typeIerror = 0.05, alpha0 = 0.01, alpha1 = 0.01)

#specify meanresponse_start, meanresponse_end0 and effectsize_beta
swdpower(K = 30, design = dataset, family = "binomial", model = "conditional", link = "logit",
type = "cross-sectional", meanresponse_start = 0.2, meanresponse_end0 = 0.3, effectsize_beta = 0.6,
typeIerror = 0.05, alpha0 = 0.01, alpha1 = 0.01)

#a cohort design with 8 clusters, 3 periods and continuous outcomes applying marginal model
#sigma2 should be specified, as continuous outcomes require marginal variance in calculation
#create a 8*3 matrix which describes the study design,
#0 means control status, 1 means intervention status
dataset = matrix(c(rep(c(0,1,1),4),rep(c(0,0,1),4)),8,3, byrow=TRUE)

#specify meanresponse_start, meanresponse_end0 and meanresponse_end1 assuming time effects
swdpower(K = 24, design = dataset, family = "gaussian", model = "marginal", link = "identity",
type = "cohort", meanresponse_start = 0.1, meanresponse_end0 = 0.2,  meanresponse_end1 = 0.4,
sigma2 = 0.095, typeIerror = 0.05, alpha0 = 0.03, alpha1 = 0.015, alpha2 = 0.2)

#specify meanresponse_start, meanresponse_end0 and effectsize_beta assuming time effects.
#As an alternative to the previous example, the time effect specification for meanresponse_start
#and meanresponse_end0 does not need to be precise (make sure they are not equal).
swdpower(K = 24, design = dataset, family = "gaussian", model = "marginal", link = "identity",
type = "cohort", meanresponse_start = 0.1, meanresponse_end0 = 0.2,  effectsize_beta=0.2,
sigma2 = 0.095, typeIerror = 0.05, alpha0 = 0.03, alpha1 = 0.015, alpha2 = 0.2)

#specify effectsize_beta only, then the program runs assuming no time effects
swdpower(K = 24, design = dataset, family = "gaussian", model = "marginal", link = "identity",
type = "cohort",effectsize_beta=0.3, sigma2 = 0.095, typeIerror = 0.05, alpha0 = 0.03,
alpha1 = 0.015, alpha2 = 0.2)
}

\name{swdpwr-package}
\alias{swdpwr-package}
\alias{swdpwr}
\docType{package}
\title{
Power Calculation for Stepped Wedge Cluster Randomized Trials
}
\description{
This package includes a function \code{swdpower} that accounts for power calculation for stepped wedge cluster randomized trials.
}
\details{
\tabular{ll}{
Package: \tab swdpwr\cr
Type: \tab Package\cr
Version: \tab 1.11\cr
Date: \tab 2024-10-06\cr
License: \tab GPL (version 3)\cr
}
Previous literature and developement of software focused mainly on continuous outcomes and obtained approximation results for binary outcomes. This package implemented new methods of power calculation for stepped wedge designs with binary outcomes and also incorporated procedures for continuous outcomes. The function \code{swdpower} can accommodate both cross-sectional and cohort designs, binary and continuous outcomes, marginal (GEE) and conditional models (mixed effects model), three link functions (identity, log, logit links), with and without time effects (the default specification assumes no-time-effect) under exchangeable, nested exchangeable and block exchangeable correlation structures. Unequal numbers of clusters per sequence are also allowed. With this package, investigators can obtain more accurate calculation of statistical power, that will help a lot in the design and analysis of stepped wedge cluster randomized trials. The package also includes functions that perform calculations for the intra-cluster correlation coefficients based on the random effects variances as input variables for continuous and binary outcomes, respectively. Other supplementary documents can be found at: https://ysph.yale.edu/cmips/research/software/study-design-power-calculation/swdpwr/. The Shiny app for swdpwr can be accessed at: <https://jiachenchen322.shinyapps.io/swdpwr_shinyapp/>.

%~~ An overview of how to use the package, including the most important functions ~~
}
\author{
Jiachen Chen, Xin Zhou , Fan Li and Donna Spiegelman.

Maintainer:Jiachen Chen <jiachen.chen322@gmail.com>
}
\references{
Zhou X, Liao X, Kunz L M, et al. A maximum likelihood approach to power calculations for stepped wedge designs of binary outcomes[J]. Biostatistics, 2020, 21(1): 102-121.

Li F, Turner E L, Preisser J S. Sample size determination for GEE analyses of stepped wedge cluster randomized trials[J]. Biometrics, 2018, 74(4): 1450-1458.
}
%~~ Optionally other standard keywords, one per line, from file KEYWORDS in the R documentation directory ~~
\keyword{ stepped wedge }
\keyword{ cluster randomized trials }
\keyword{ sample size estimation }
\keyword{ cross-sectional designs}
\keyword{ cohort designs}
\keyword{ binary and continuous outcomes }
\keyword{ correlation structure }
%\seealso{
%~~ Optional links to other man pages, e.g. ~~
%~~ \code{\link[<pkg>:<pkg>-package]{<pkg>}} ~~
%}
%\examples{
%~~ simple examples of the most important functions ~~
%}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/print.swdpower.R
\name{print.swdpower}
\alias{print.swdpower}
\title{Print the results of swdpower}
\usage{
\method{print}{swdpower}(x, ...)
}
\arguments{
\item{x}{an object used to select a method.}

\item{...}{further arguments passed to or from other methods.}
}
\value{
The output from \code{\link{print}}
}
\description{
The \code{\link{print}} method for class "swdpower"
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BinICC.R
\name{BinICC}
\alias{BinICC}
\title{A function for calculating the intracluster correlation coefficient (ICC) for binary outcomes given the cluster level random effects variance}
\usage{
BinICC(link = "identity", meanresponse_start, tau2 = 0)
}
\arguments{
\item{link}{choose link function from link="identity", link="log" and link="logit", with default value of identity link}

\item{meanresponse_start}{the anticipated mean response in the control group at the start of the study}

\item{tau2}{also denoted as sigma_b: variance of the between-cluster random effect, default is 0}
}
\value{
The object returned includes the link function and value for the ICC in this study
}
\description{
This function calculates the ICC (intracluster correlation coeffcient which measures the correlation between individuals in the same cluster) under different link funcitions in a cross-sectional stepped wedge CRT with binary outcomes. This model considers only the fixed time effects and does not include cluster by time interaction random effect.
}
\examples{
BinICC(link="identity",meanresponse_start=0.2,tau2=0.05)

}
